package es.csa.commons.faces.util;

/*
 * #%L
 * Librerías comunes de Java Server Faces de CSA
 * %%
 * Copyright (C) 2015 CSA - Centro Regional de Servicios Avanzados S.A.
 * %%
 * This file is part of "Librerías comunes de CSA".
 * 
 * developed by: Centro Regional de Servicios Avanzados, S.A.
 * 
 * "Librerías comunes de CSA" is free software: you can redistribute it and/or modify it under the terms of:
 * - Apache License, Version 2.0 (the "License");  
 * - under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 * "Librerías comunes de CSA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or General Public License for more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE­2.0
 * 
 * You may obtain a copy of the General Public Licence at:
 * http://www.gnu.org/licenses/
 * #L%
 */
 
import java.io.Serializable;
import java.util.Collection;
import java.util.Map;
import java.util.Set;

/**
 * Un mapa dummy.
 * <p>
 * Una implementación de mapa que no hace nada, pero que permite utilizarla como base para algo parecido a las funciones
 * EL. <br/>
 * Podemos hacer una función que devuelva un mapa para permitir propiedades con un parámetro, que será la clave del
 * mapa.
 * </p>
 * 
 * @author Josué Alcalde <jalcalde@csa.es>
 * @param <K>
 *          Clave.
 * @param <V>
 *          Valor.
 */
public abstract class DummyMap<K, V> implements Map<K, V>, Serializable {

  private static final long serialVersionUID = 399406414980793635L;

  @Override
  public void clear() {}

  @Override
  public boolean containsKey(Object key) {
    return false;
  }

  @Override
  public boolean containsValue(Object value) {
    return false;
  }

  @Override
  public Set<java.util.Map.Entry<K, V>> entrySet() {
    return null;
  }

  @Override
  public boolean isEmpty() {
    return false;
  }

  @Override
  public Set<K> keySet() {
    return null;
  }

  @Override
  public V put(K key, V value) {
    return null;
  }

  @Override
  public void putAll(Map<? extends K, ? extends V> m) {}

  @Override
  public V remove(Object key) {
    return null;
  }

  @Override
  public int size() {
    return 0;
  }

  @Override
  public Collection<V> values() {
    return null;
  }

}
