package es.csa.commons.faces.util;

/*
 * #%L
 * Librerías comunes de Java Server Faces de CSA
 * %%
 * Copyright (C) 2015 CSA - Centro Regional de Servicios Avanzados S.A.
 * %%
 * This file is part of "Librerías comunes de CSA".
 * 
 * developed by: Centro Regional de Servicios Avanzados, S.A.
 * 
 * "Librerías comunes de CSA" is free software: you can redistribute it and/or modify it under the terms of:
 * - Apache License, Version 2.0 (the "License");  
 * - under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 * "Librerías comunes de CSA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or General Public License for more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE­2.0
 * 
 * You may obtain a copy of the General Public Licence at:
 * http://www.gnu.org/licenses/
 * #L%
 */
 
import java.util.Locale;

import javax.el.ELContext;
import javax.el.ELResolver;
import javax.el.FunctionMapper;
import javax.el.VariableMapper;

/**
 * @author asmirnov (Esta clase está copiada de richfaces osea que es GPL)
 */
public class ELContextWrapper extends ELContext {

  private final ELContext parent;

  private final ELResolver resolver;

  public ELContextWrapper(ELContext parent, ELResolver resolver) {
    super();
    this.resolver = resolver;
    this.parent = parent;
  }

  @Override
  public ELResolver getELResolver() {
    return resolver;
  }

  @Override
  public FunctionMapper getFunctionMapper() {
    return parent.getFunctionMapper();
  }

  @Override
  public VariableMapper getVariableMapper() {
    return parent.getVariableMapper();
  }

  @Override
  @SuppressWarnings("unchecked")
  public Object getContext(Class key) {
    return parent.getContext(key);
  }

  @Override
  @SuppressWarnings("unchecked")
  public void putContext(Class key, Object contextObject) {
    parent.putContext(key, contextObject);
  }

  @Override
  public Locale getLocale() {
    return parent.getLocale();
  }

  @Override
  public void setLocale(Locale locale) {
    parent.setLocale(locale);
  }
}
