package es.csa.commons.faces.util;

/*
 * #%L
 * Librerías comunes de Java Server Faces de CSA
 * %%
 * Copyright (C) 2015 CSA - Centro Regional de Servicios Avanzados S.A.
 * %%
 * This file is part of "Librerías comunes de CSA".
 * 
 * developed by: Centro Regional de Servicios Avanzados, S.A.
 * 
 * "Librerías comunes de CSA" is free software: you can redistribute it and/or modify it under the terms of:
 * - Apache License, Version 2.0 (the "License");  
 * - under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 * "Librerías comunes de CSA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or General Public License for more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE­2.0
 * 
 * You may obtain a copy of the General Public Licence at:
 * http://www.gnu.org/licenses/
 * #L%
 */
 
import java.io.FileInputStream;
import java.io.InputStream;

import org.apache.commons.io.IOUtils;
import org.richfaces.model.UploadItem;

import es.csa.commons.persistence.entity.FicheroSubido;

public class FicheroSubidoRichFacesAdapter implements FicheroSubido {

  private static final long serialVersionUID = 7050528040988846380L;

  private UploadItem uploadItem;

  public FicheroSubidoRichFacesAdapter(UploadItem uploadItem) {
    super();
    this.uploadItem = uploadItem;
  }

  @Override
  public String getNombre() {
    return uploadItem.getFileName();
  }

  @Override
  public Integer getTamanio() {
    return uploadItem.getFileSize();
  }

  @Override
  public String getTipoMime() {
    return uploadItem.getContentType();
  }

  @Override
  public byte[] getContenido() {
    try {
      if (getUploadItem().isTempFile()) {
        InputStream fis = new FileInputStream(getUploadItem().getFile());
        return IOUtils.toByteArray(fis);
      } else {
        return getUploadItem().getData();
      }
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    }
  }

  @Override
  public boolean deleteFichero() {
    return getUploadItem().isTempFile() ? getUploadItem().getFile().delete() : false;
  }

  public UploadItem getUploadItem() {
    return uploadItem;
  }

  public void setUploadItem(UploadItem uploadItem) {
    this.uploadItem = uploadItem;
  }

}
