package es.csa.commons.persistence.browser.jpaql;

/*
 * #%L
 * Librerías comunes de Java Server Faces de CSA
 * %%
 * Copyright (C) 2015 CSA - Centro Regional de Servicios Avanzados S.A.
 * %%
 * This file is part of "Librerías comunes de CSA".
 * 
 * developed by: Centro Regional de Servicios Avanzados, S.A.
 * 
 * "Librerías comunes de CSA" is free software: you can redistribute it and/or modify it under the terms of:
 * - Apache License, Version 2.0 (the "License");  
 * - under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 * "Librerías comunes de CSA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or General Public License for more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE­2.0
 * 
 * You may obtain a copy of the General Public Licence at:
 * http://www.gnu.org/licenses/
 * #L%
 */
 
import java.io.Serializable;
import java.util.Arrays;

public class CriterionJPAQL implements Serializable {

  private static final long serialVersionUID = 6523890512482732989L;

  private String query;

  private Object[] parameters = new Object[0];

  public String getQuery() {
    return this.query;
  }

  public void setQuery(String query) {
    this.query = query;
  }

  public Object[] getParameters() {
    return parameters;
  }

  protected void setParameters(Object[] params) {
    this.parameters = params;
  }

  public void addParameter(Object param) {
    setParameters(Arrays.copyOf(getParameters(), getParameters().length + 1));
    getParameters()[getParameters().length - 1] = param;
  }

  public void addParameters(Object[] params) {
    if (params != null) for (Object param : params)
      addParameter(param);
  }

}
