package es.csa.commons.persistence.browser.jpaql;

/*
 * #%L
 * Librerías comunes de Java Server Faces de CSA
 * %%
 * Copyright (C) 2015 CSA - Centro Regional de Servicios Avanzados S.A.
 * %%
 * This file is part of "Librerías comunes de CSA".
 * 
 * developed by: Centro Regional de Servicios Avanzados, S.A.
 * 
 * "Librerías comunes de CSA" is free software: you can redistribute it and/or modify it under the terms of:
 * - Apache License, Version 2.0 (the "License");  
 * - under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 * "Librerías comunes de CSA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or General Public License for more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE­2.0
 * 
 * You may obtain a copy of the General Public Licence at:
 * http://www.gnu.org/licenses/
 * #L%
 */
 
import es.csa.commons.persistence.browser.Sort;

public class SortJPAQL implements Sort<String> {

  private static final long serialVersionUID = 2646531606944284784L;

  // Provided data

  public boolean sortAsc;

  public String sortProperty;

  /** El criterion de hibernate. */
  protected transient String sortOrder;

  public SortJPAQL() {
    super();
    sortAsc = true;
    sortOrder = null;
  }

  @Override
  public boolean getSortAsc() {
    return sortAsc;
  }

  @Override
  public void setSortAsc(boolean sortAsc) {
    sortOrder = null;
    this.sortAsc = sortAsc;
  }

  @Override
  public String getSortProperty() {
    return sortProperty;
  }

  @Override
  public void setSortProperty(String sortProperty) {
    sortOrder = null;
    this.sortProperty = sortProperty;
  }

  @Override
  public String getOrder() {
    if (sortProperty == null) 
      return null;
    if (sortOrder == null)
      sortOrder = "ORDER BY " + sortProperty + (getSortAsc() ? " ASC" : " DESC");
    return sortOrder;
  }

}
