package es.csa.commons.persistence.validator;

/*
 * #%L
 * Librerías comunes de Java Server Faces de CSA
 * %%
 * Copyright (C) 2015 CSA - Centro Regional de Servicios Avanzados S.A.
 * %%
 * This file is part of "Librerías comunes de CSA".
 * 
 * developed by: Centro Regional de Servicios Avanzados, S.A.
 * 
 * "Librerías comunes de CSA" is free software: you can redistribute it and/or modify it under the terms of:
 * - Apache License, Version 2.0 (the "License");  
 * - under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 * "Librerías comunes de CSA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or General Public License for more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE­2.0
 * 
 * You may obtain a copy of the General Public Licence at:
 * http://www.gnu.org/licenses/
 * #L%
 */
 
public class CCCUtils {

  public static int[] CIFRAS_VALIDACION = { 1, 2, 4, 8, 5, 10, 9, 7, 3, 6 };

  public static boolean isValidLengthAndFormat(String ccc) {
    if (ccc == null || ccc.length() != 20) return false;
    for (int i = 0; i < 20; i++)
      if (!Character.isDigit(ccc.charAt(i))) return false;
    return true;
  }

  public static boolean isValid(String ccc) {
    // validar longitud y formato
    if (!isValidLengthAndFormat(ccc)) return false;
    int dc[] = new int[2];
    // validar entidad y oficina 
    int suma = 0;
    for (int i = 0; i < 8; i++)
      suma += Integer.parseInt(ccc.substring(i, i + 1)) * CIFRAS_VALIDACION[i + 2];
    dc[0] = 11 - suma % 11;
    dc[0] = dc[0] == 11 ? 0 : dc[0] == 10 ? 1 : dc[0];
    if (dc[0] != Integer.parseInt(ccc.substring(8,9))) return false;
    // validar numero de cuenta
    suma = 0;
   for (int i = 10; i < 20; i++)
     suma += Integer.parseInt(ccc.substring(i,i+1)) * CIFRAS_VALIDACION[i - 10];
    dc[1] = 11 - suma % 11;
    dc[1] = dc[1] == 11 ? 0 : dc[1] == 10 ? 1 : dc[1];
    if (dc[1] != Integer.parseInt(ccc.substring(9,10))) return false;
    // si validan los dos ya está
    return true;
  }

}
