package es.csa.commons.util;

/*
 * #%L
 * Librerías comunes de Java Server Faces de CSA
 * %%
 * Copyright (C) 2015  Xunta de Galicia <oficinacemit@xunta.es>
 * %%
 * This file is part of "Librerías comunes de CSA".
 * 
 * developed by: Balidea <info@balidea.com>
 * 
 * "Librerías comunes de CSA" is free software: you can redistribute it and/or modify it under the terms of:
 * - Apache License, Version 2.0 (the "License");  
 * - under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 * "Librerías comunes de CSA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or General Public License for more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE­2.0
 * 
 * You may obtain a copy of the General Public Licence at:
 * http://www.gnu.org/licenses/
 * #L%
 */

import java.util.Arrays;

import org.apache.commons.lang.WordUtils;

public class AditionalStringUtils {

	  /**
	   * 3.4.3-R RF_XEA_19 
	   * Convierte el nombre o apellido con una mayuscula al principio y el resto
	   * minusculas
	   * 
	    */
	   public static String formatCapitalized(String cadena) {
	         String result = "";
	         
	         cadena = cadena.toLowerCase();

	         // Formateamos la palabra capitalizada
	         char[] delimiters = new char[2];
	         delimiters[0] = '-';
	         delimiters[1] = ' ';
	         
	         String cadenaCapitalizada = WordUtils.capitalizeFully(cadena, delimiters);

	         // Eliminamos las excepciones a la capitalización
	         String[] excepcionesCapitalizacion = new String[] { "De", "Los", "La", "Y", "Del", "Las" };
	         String arrayTokenCadena[] = cadenaCapitalizada.split(" ");
	         for (String tokenCadena : arrayTokenCadena) {
	               if (Arrays.asList(excepcionesCapitalizacion).contains(tokenCadena)) {
	                     tokenCadena = tokenCadena.toLowerCase();
	               }
	               result += tokenCadena + " ";
	         }

	         return result;
	   }	
	
}
