package es.csa.commons.util;

/*
 * #%L
 * Librerías comunes de Java Server Faces de CSA
 * %%
 * Copyright (C) 2015 CSA - Centro Regional de Servicios Avanzados S.A.
 * %%
 * This file is part of "Librerías comunes de CSA".
 * 
 * developed by: Centro Regional de Servicios Avanzados, S.A.
 * 
 * "Librerías comunes de CSA" is free software: you can redistribute it and/or modify it under the terms of:
 * - Apache License, Version 2.0 (the "License");  
 * - under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 * "Librerías comunes de CSA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or General Public License for more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE­2.0
 * 
 * You may obtain a copy of the General Public Licence at:
 * http://www.gnu.org/licenses/
 * #L%
 */
 
import org.apache.commons.codec.binary.Base64;
import org.apache.commons.codec.digest.DigestUtils;

public class HashUtils {

  /**
   * Codifica a md5 en hexadecimal el login en mayusculas concatenado con el password.
   * 
   * @param login
   *          El login.
   * @param password
   *          El password.
   * @return La cadena codificada.
   */
  public static String encodeMd5Hex(String login, String password) {
    return DigestUtils.md5Hex(login.toUpperCase() + password).toUpperCase();
  }

  /**
   * Codifica a md5 en base64 el login en mayusculas concatenado con el password.
   * 
   * @param login
   *          El login.
   * @param password
   *          El password.
   * @return La cadena codificada.
   */
  public static String encodeMd5Base64(String login, String password) {
    return new String(Base64.encodeBase64(encodeMd5Hex(login, password).getBytes()));
  }

}
