package es.csa.fdt.cyldigital.calendario.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import org.richfaces.json.JSONArray;
import org.richfaces.json.JSONException;
import org.richfaces.json.JSONObject;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.calendario.entity.CalendarItem;
import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;

/**
 * Servicio de eventos de calendario.
 * 
 * @author csa
 */
@Service
@Repository
public class CalendarItemServiceImpl extends AbstractServiceImpl<CalendarItem, Long> implements CalendarItemService {

  private static final long serialVersionUID = -5575228180361917674L;

  private JSONObject jsonO;

  private JSONArray jsonA;

  /**
   * Devuelve json a.
   * 
   * @return json a
   */
  public JSONArray getJsonA() {
    return jsonA;
  }

  /**
   * Persist calendar item.
   */
  public void persistCalendarItem() {
    CalendarItem item = new CalendarItem();
    disableMessages();
    persist(item);
    enableMessages();
  }

  /**
   * Find items.
   */
  public void findItems() {
    jsonA = new JSONArray();
    List<CalendarItem> items = findAll();
    try {
      for (CalendarItem ci : items) {
        jsonO = new JSONObject();
        jsonO.put("title", ci.getTitle());
        jsonO.put("start", ci.getStart());
        jsonO.put("end", ci.getEnd());
        jsonO.put("allday", ci.isAllDay());
        jsonO.put("className", ci.getClassName());
        jsonO.put("descripcion", ci.getDescription());

        jsonA.put(jsonO);
      }
    } catch (JSONException e) {
      e.printStackTrace();
    }
  }
}
