package es.csa.fdt.cyldigital.enlaces;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import javax.persistence.AttributeOverride;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.envers.Audited;
import org.hibernate.validator.Length;
import org.hibernate.validator.NotEmpty;
import org.hibernate.validator.NotNull;

import es.csa.fdt.cyldigital.core.entity.AbstractEntity;
import es.csa.fdt.cyldigital.servicios.entity.ServicioCursoEnlace;

/**
 * Clase Formulario.
 * 
 * @author csa
 */
@Entity
@Table(name = "enlaces")
@AttributeOverride(name = "id", column = @Column(name = "idEnlace"))
@Audited
public class Enlace extends AbstractEntity {	
	
	private static final long serialVersionUID = -3171434833058925384L;
	
	private String textoEnlace;
	private String url;
	
	private List<ServicioCursoEnlace> serviciosCursoEnlace;
	
	/**
	 * Devuelve y recoge el texto del enlace
	 * @return textoEnlace
	 */
	
	@NotEmpty
	@NotNull
	@Length(max = 255)
	public String getTextoEnlace() {
		return textoEnlace;
	}
	
	public void setTextoEnlace(String textoEnlace) {
		this.textoEnlace = textoEnlace;
	}
	
	
	/**
	 * Devuelve y recoge la url
	 * @return url
	 */
	@NotEmpty
	@NotNull
	@Lob
	@Column(columnDefinition = "longtext character set utf8 collate utf8_general_ci")
	public String getUrl() {
		return url;
	}
	
	public void setUrl(String url) {
		this.url = url;
	}
	
	@OneToMany(cascade = CascadeType.ALL)
	@JoinColumn(name = "idEnlace")
	public List<ServicioCursoEnlace> getServiciosCursoEnlace(){
		return serviciosCursoEnlace;
	}

	public void setServiciosCursoEnlace(List<ServicioCursoEnlace> serviciosCursoEnlace) {
		this.serviciosCursoEnlace = serviciosCursoEnlace;
	}	
	
	/*public void getServiciosCursoEnlace(List<ServicioCursoEnlace> serviciosCursoEnlace){
		this.serviciosCursoEnlace = serviciosCursoEnlace;
	}*/
	
	
}
