package es.csa.fdt.cyldigital.evaluacion.entity;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.io.Serializable;
import java.util.List;

import javax.persistence.AttributeOverride;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.IndexColumn;
import org.hibernate.envers.Audited;

/**
 * Clase Grupo.
 * 
 * @author Fundetec
 */
@Entity
@Table(name = "gruposexamenes")
@AttributeOverride(name = "id", column = @Column(name = "idGrupoExamen"))
@PrimaryKeyJoinColumn(name = "idGrupoExamen", referencedColumnName="idItemExamen")
@Audited
public class GrupoExamen extends ItemExamen implements Serializable {

	private static final long serialVersionUID = 8744851382511868488L;

	private List<PreguntaExamen> preguntas;

	/**
	 * Devuelve preguntas del examen.
	 * 
	 * @return preguntas
	 */
	@OneToMany(cascade = CascadeType.ALL)
	@JoinColumn(name = "idGrupoExamen")
	@Cascade(org.hibernate.annotations.CascadeType.DELETE_ORPHAN)
	@IndexColumn(name = "secuenciaGrupoExamen", base = 0)
	public List<PreguntaExamen> getPreguntas() {
		return preguntas;
	}

	/**
	 * Asigna preguntas de examen al grupo
	 * 
	 * @param preguntas
	 *          preguntas
	 */
	public void setPreguntas(List<PreguntaExamen> preguntas) {
		this.preguntas = preguntas;
	}

	/* (non-Javadoc)
	 * @see es.csa.fdt.cyldigital.evaluacion.entity.Item#isGrupo()
	 */
	@Override
	@Transient
	public boolean isGrupo() {
		return true;
	}

	/* (non-Javadoc)
	 * @see es.csa.fdt.cyldigital.evaluacion.entity.Item#isPregunta()
	 */
	@Override
	@Transient
	public boolean isPregunta() {
		return false;
	}
}
