package es.csa.fdt.cyldigital.evaluacion.entity;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.io.Serializable;

import javax.persistence.AttributeOverride;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.Audited;
import org.hibernate.validator.NotNull;

import es.csa.fdt.cyldigital.core.entity.AbstractEntity;

/**
 * Clase Respuesta.
 * 
 * @author Fundetec
 */
@Entity
@Audited
@Table(name = "respuestasexamenes")
@AttributeOverride(name = "id", column = @Column(name = "idRespuestaExamen"))
public class RespuestaExamen extends AbstractEntity implements Serializable {
	private static final long serialVersionUID = -6094927143756353614L;

	private PreguntaExamen preguntaExamen;

	private OpcionPreguntaExamen opcionRespondida;

	/**
	 * Construye un nuevo objeto de la clase
	 */
	public RespuestaExamen() {
		super();
	}

	/**
	 * Devuelve pregunta de examen.
	 * 
	 * @return preguntaExamen
	 */
	@ManyToOne(fetch = FetchType.LAZY, cascade = { CascadeType.PERSIST, CascadeType.MERGE, CascadeType.REFRESH })
	@JoinColumn(name = "idPreguntaExamen")
	@NotNull
	public PreguntaExamen getPreguntaExamen() {
		return preguntaExamen;
	}

	/**
	 * Asigna pregunta de examan.
	 * 
	 * @param preguntaExamen
	 *            pregunta de examen
	 */
	public void setPreguntaExamen(PreguntaExamen preguntaExamen) {
		this.preguntaExamen = preguntaExamen;
	}

	/**
	 * @return the opcionRespondida
	 */
	@ManyToOne(fetch = FetchType.LAZY, cascade = {CascadeType.PERSIST, CascadeType.MERGE, CascadeType.REFRESH})
	@JoinColumn(name="idOpcionRespondida")
	@NotNull
	public OpcionPreguntaExamen getOpcionRespondida() {
		return opcionRespondida;
	}

	/**
	 * @param opcionRespondida the opcionRespondida to set
	 */
	public void setOpcionRespondida(OpcionPreguntaExamen opcionRespondida) {
		this.opcionRespondida = opcionRespondida;
	}
}
