package es.csa.fdt.cyldigital.evaluacion.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import es.csa.fdt.cyldigital.core.service.AbstractService;
import es.csa.fdt.cyldigital.evaluacion.entity.GrupoExamen;
import es.csa.fdt.cyldigital.evaluacion.entity.ItemExamen;
import es.csa.fdt.cyldigital.language.entity.Language;

/**
 * Interfaz del servicio de Grupo.
 * 
 * @author Fundetec
 */
public interface GrupoExamenService extends AbstractService<GrupoExamen, Long> {

	/**
	 * Crea grupo de examen.
	 * 
	 * @param idExamen
	 *           id de Examen
	 * @return item de Examen
	 */
	public abstract ItemExamen createGrupo(Long idExamen, List<Language> languages);
}
