package es.csa.fdt.cyldigital.financiero.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.commons.persistence.browser.jpaql.BrowserJPAQL;
import es.csa.commons.persistence.browser.jpaql.CriterionJPAQL;
import es.csa.fdt.cyldigital.financiero.entity.Contrato;
import es.csa.fdt.cyldigital.usuarios.entity.Proveedor;

/**
 * Servicio del Browser de Contratos.
 * 
 * @author csa
 */
@Service
@Repository
public class ContratoBrowserImpl extends BrowserJPAQL<Contrato> implements ContratoBrowser<CriterionJPAQL, String> {

  private static final long serialVersionUID = 2984375904237950874L;
  
  /**
   * Construye un nuevo objeto de la clase
   */
  public ContratoBrowserImpl(){
    super();
  }

  /**
   * Apply custom filter.
   * 
   * @param proveedor
   *           proveedor
   */
  public void applyCustomFilter(Proveedor proveedor) {
    if (proveedor != null){
      this.getCondition().getCriterion().setQuery("e.proveedor = ?");
      this.getCondition().getCriterion().addParameter(proveedor);
    }

    this.applyCondition();
  }
  
  /**
   * Clear.
   */
  public void clear() {
    this.getEntityManager().clear();
  }

}
