package es.csa.fdt.cyldigital.financiero.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.commons.persistence.browser.jpaql.BrowserJPAQL;
import es.csa.commons.persistence.browser.jpaql.CriterionJPAQL;
import es.csa.fdt.cyldigital.financiero.entity.Proyecto;

/**
 * Servicio del Browser de Proyectos.
 * 
 * @author csa
 */
@Service
@Repository
public class ProyectoBrowserImpl extends BrowserJPAQL<Proyecto> implements ProyectoBrowser<CriterionJPAQL, String> {

  private static final long serialVersionUID = 8649164934919641644L;

  /**
   * Construye un nuevo objeto de la clase
   */
  public ProyectoBrowserImpl() {
    super();
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.financiero.service.ProyectoBrowser#applyCustomFilter(es.csa.fdt.cyldigital.financiero.entity.Proyecto)
   */
  public void applyCustomFilter(Proyecto proyectoGeneral) {
    if (proyectoGeneral == null) this.getCondition().getCriterion().setQuery("e.proyectoGeneral IS NULL");
    else {
      this.getCondition().getCriterion().setQuery("e.proyectoGeneral = ?");
      this.getCondition().getCriterion().addParameter(proyectoGeneral);
    }

    this.applyCondition();
  }

  /**
   * Clear.
   */
  public void clear() {
    this.getEntityManager().clear();
  }

}
