package es.csa.fdt.cyldigital.incidencias.entity;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.hibernate.envers.Audited;

import es.csa.fdt.cyldigital.core.entity.AbstractEntity;

/**
 * Clase Lista.
 * 
 * @author csa
 */
@Audited
public class Lista extends AbstractEntity implements Serializable {
  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  private List<Integer> lista;

  /**
   * Construye un nuevo objeto de la clase
   */
  public Lista() {
    lista = new ArrayList<Integer>();
  }

  /**
   * Asigna lista.
   * 
   * @param lista
   *          lista
   */
  public void setLista(List<Integer> lista) {
    this.lista = lista;
  }

  /**
   * Devuelve lista.
   * 
   * @return lista
   */
  public List<Integer> getLista() {
    return lista;
  }

}
