package es.csa.fdt.cyldigital.incidencias.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import es.csa.fdt.cyldigital.core.service.AbstractService;
import es.csa.fdt.cyldigital.incidencias.entity.CategoriaIncidencia;
import es.csa.fdt.cyldigital.usuarios.entity.Empleado;

/**
 * Interfaz del servicio de CategoriaIncidencia.
 * 
 * @author csa
 */
public interface CategoriaIncidenciaService extends AbstractService<CategoriaIncidencia, Long> {
  
  /**
   * Devuelve empleados.
   * 
   * @return empleados
   */
  public List<Empleado> getEmpleados();

  /**
   * Persist categoria incidencia.
   * 
   * @param c
   *           c
   */
  public void persistCategoriaIncidencia(CategoriaIncidencia c);

  /**
   * Asigna empleados.
   * 
   * @param empleados
   *          empleados
   */
  public void setEmpleados(List<Empleado> empleados);
  // public void addEmpleado(Empleado empleado);
  // public void quitarEmpleado(Empleado empleado);

}
