package es.csa.fdt.cyldigital.language.entity;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.io.Serializable;
import java.util.List;

import javax.persistence.AttributeOverride;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.Table;
import javax.persistence.OneToMany;

import org.hibernate.annotations.Cascade;

import org.hibernate.envers.Audited;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotEmpty;
import org.hibernate.validator.NotNull;

import es.csa.fdt.cyldigital.core.entity.AbstractEntity;

/**
 * Entity implementation class for Entity: Language
 *
 */
@Entity
@Table(name="languages")
@Audited
@AttributeOverride(name = "id", column = @Column(name = "idLanguage"))
public class Language extends AbstractEntity implements Serializable {
	
	private static final long serialVersionUID = 3250452345011247964L;
	
	/**
	 * Nombre del idioma en el mismo idioma definido
	 */
	private String name;
	
	/**
	 * Nomenclatura ISO que describe el idioma
	 */
	private String ISO;

	/**
	 * Constructor
	 */
	public Language() {
		super();
	}

    /**
     * Devuelve name.
     * 
     * @return name
     */
	@Length(max = 50)
	@NotEmpty
	@NotNull
	public String getName() {
		return this.name;
	}

	/**
	 * Asigna name.
	 * 
	 * @param name
	 *          name
	 */
	public void setName(String name) {
		this.name = name;
	}

    /**
     * Devuelve ISO.
     * 
     * @return ISO
     */
	@Length(max = 10)
	@NotEmpty
	@NotNull
	public String getISO() {
		return this.ISO;
	}

	/**
	 * Asigna ISO.
	 * 
	 * @param ISO
	 *          ISO
	 */
	public void setISO(String ISO) {
		this.ISO = ISO;
	}
}
