package es.csa.fdt.cyldigital.language.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.commons.persistence.browser.jpaql.CriterionJPAQL;
import es.csa.fdt.cyldigital.core.service.BrowserFilteredByActive;
import es.csa.fdt.cyldigital.language.entity.DiplomaLanguage;
import es.csa.fdt.cyldigital.language.entity.Language;

/**
 * Servicio del Browser de DiplomaLanguage.
 * 
 * @author Fundetec
 */
@Service
@Repository
public class DiplomaLanguageBrowserImpl extends BrowserFilteredByActive<DiplomaLanguage> implements DiplomaLanguageBrowser<CriterionJPAQL, String> {

	private static final long serialVersionUID = 3817663998282439538L;
	
	/**
	 * Construye un nuevo objeto de la clase
	 */
	public DiplomaLanguageBrowserImpl() {
		super();

		getSort().setSortAsc(false);
		getSort().setSortProperty("diploma");
	}

	public void applyLanguageCondition(Language language) {
		this.clearConditions();

		this.getCondition().getCriterion().setQuery("e.language = ?");
		this.getCondition().getCriterion().addParameter(language);

	    this.applyCondition();
	}
}
