package es.csa.fdt.cyldigital.language.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.centros.entity.Centro;
import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;
import es.csa.fdt.cyldigital.language.entity.PropuestaServicioLanguage;
import es.csa.fdt.cyldigital.language.entity.Language;
import es.csa.fdt.cyldigital.servicios.entity.PreinscripcionCurso;
import es.csa.fdt.cyldigital.servicios.entity.PreinscripcionPropuesta;
import es.csa.fdt.cyldigital.servicios.entity.PropuestaServicio;
import es.csa.fdt.cyldigital.servicios.entity.ServicioCurso;
import es.csa.fdt.cyldigital.servicios.entity.PreinscripcionCurso.PreferenciaHoraria;
import es.csa.fdt.cyldigital.usuarios.entity.UsuarioCyL;


/**
 * Clase PropuestaLanguageServiceImpl.
 * 
 * @author it-pronet
 */
@Service
@Repository
public class PropuestaServicioLanguageServiceImpl extends AbstractServiceImpl<PropuestaServicioLanguage, Long>
										   implements PropuestaServicioLanguageService {

	private static final long serialVersionUID = -508581690737783870L;

	/**
	 * Construye un nuevo objeto de la clase
	 */
	public PropuestaServicioLanguageServiceImpl() {
		super();
	}

	public PropuestaServicioLanguage find(Long id, Language language) {
		Map<String, Object> propiedades = new HashMap<String, Object>();
		propiedades.put("propuesta.id", id);
		propiedades.put("language.id", language.getId());
	      
		return findOneWhere(propiedades);
	}
	
	/**
	 * Put interesados in curso.
	 * 
	 * @param idCurso
	 *            id curso
	 * @param idPropuesta
	 *            id propuesta
	 */
	/*public void putInteresadosInCurso(Long idCurso, Long idPropuesta) {
		ServicioCurso c = find(ServicioCurso.class, idCurso);
		refresh(c);

		PropuestaServicio ps = find(PropuestaServicio.class, idPropuesta);
		refresh(ps);
		
		try {
			if (ps != null) {
				for (PreinscripcionPropuesta pp : ps.getPreinscripciones()) {
					if (!pp.getDesactivado()) {
						PreinscripcionCurso pc = new PreinscripcionCurso();
						Centro centro = find(Centro.class, pp.getCentro().getId());
						UsuarioCyL u = find(UsuarioCyL.class, pp.getUsuario().getId());
						
						pc.setCentro(centro);
						pc.setFecha(pp.getFecha());
						pc.setHorarioPreferido(PreferenciaHoraria.valueOf(pp.getHorarioPreferido().toString()));
						pc.setUsuario(u);
						pc.setServicioCurso(c);
						
						if (c.getPreinscripciones() == null)
							c.setPreinscripciones(new ArrayList<PreinscripcionCurso>());
						
						c.getPreinscripciones().add(pc);
					}
				}
				persist(c);
				setMessagesEnabled(false);

				ps.getPreinscripciones().clear();
				remove(ps);
				setMessagesEnabled(true);
			} else {
				remove(c);
			}
		} catch (Exception e) {
			remove(c);
		}
	}*/
}
