package es.csa.fdt.cyldigital.language.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.HashMap;

import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;
import es.csa.fdt.cyldigital.language.entity.ServicioCursoLanguage;
import es.csa.fdt.cyldigital.language.entity.Language;
import es.csa.fdt.cyldigital.servicios.entity.ServicioCurso;

/**
 * Clase ServicioCursoLanguageServiceImpl.
 * 
 * @author csa
 */
@Service
@Repository
public class ServicioCursoLanguageServiceImpl extends AbstractServiceImpl<ServicioCursoLanguage, Long>
										   implements ServicioCursoLanguageService {

	private static final long serialVersionUID = 8962559030197545966L;
	
	//private boolean areThereFicherosGuiones;

	/**
	 * Construye un nuevo objeto de la clase
	 */
	public ServicioCursoLanguageServiceImpl() {
		super();
		
		//areThereFicherosGuiones = false;
	}

	/*public boolean getAreThereFicherosGuiones() {
		return areThereFicherosGuiones;
	}

	private void setAreThereFicherosGuiones(ServicioCursoLanguage scl) {
		areThereFicherosGuiones = false;
		
		if (scl != null) {
			for (ServicioCursoLanguage textoServicioCurso : scl.getServicioCurso().getGuiones())
				if (textoServicioCurso.getFicheroGuion() != null) {
					areThereFicherosGuiones = true;

					break;
				}
		}
	}*/

	public ServicioCursoLanguage find(Long id, Language language) {
		HashMap<String, Object> propiedades = new HashMap<String, Object>();
		propiedades.put("servicioCurso.id", id);
		propiedades.put("language.id", language.getId());

		ServicioCursoLanguage scl = super.findOneWhere(propiedades);
		
		//setAreThereFicherosGuiones(scl);
		
		return scl;
	}
	
	public void clear(ServicioCursoLanguage scl) {
		clear();

		//setAreThereFicherosGuiones(scl);
	}
	
	public void reactivateServicioCurso(Long idSC) {
		if ((idSC != null) && (idSC >= 0)) {
			ServicioCurso sc = find(ServicioCurso.class, idSC);
			
			disableMessages();
			for (ServicioCursoLanguage scl : sc.getGuiones()) {
				scl.setDesactivado(false);
				
				persist(scl);
			}
			
			sc.setDesactivado(false);
			
			persist(sc);
			enableMessages();
			
			addInfoMessage("servicios.messageReactivatedService");
		}
	}
}
