package es.csa.fdt.cyldigital.recursos.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;
import es.csa.fdt.cyldigital.recursos.entity.CategoriaRecurso;


/**
 * Clase CategoriaRecursoServiceImpl.
 * 
 * @author csa
 */
@Service
@Repository
public class CategoriaRecursoServiceImpl extends AbstractServiceImpl<CategoriaRecurso, Long> implements
    CategoriaRecursoService {

  private static final long serialVersionUID = -5575228180361917674L;

  /**
   * Construye un nuevo objeto de la clase
   */
  public CategoriaRecursoServiceImpl() {
    super();
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.recursos.service.CategoriaRecursoService#persistCategoria(es.csa.fdt.cyldigital.recursos.entity.CategoriaRecurso)
   */
  public boolean persistCategoria(CategoriaRecurso categoria) {
    categoria.setEtiquetado(categoria.getEtiquetado().trim().replace(" ", "").toUpperCase());

    persist(categoria);
    return true;
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.recursos.service.CategoriaRecursoService#getCategoriasDisponibles()
   */
  public List<CategoriaRecurso> getCategoriasDisponibles() {
    return findAll(CategoriaRecurso.class);
  }

  /**
   * Elimina categoria.
   * 
   * @param categoria
   *           categoria
   */
  public void removeCategoria(CategoriaRecurso categoria) {
    if ((categoria.getId() != 0) &&
    	((categoria.getEtiquetado().compareTo("ORD") != 0) &&
    	 (categoria.getEtiquetado().compareTo("ROU") != 0)))
    	 remove(categoria);
  }
}
