package es.csa.fdt.cyldigital.recursos.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.commons.persistence.browser.jpaql.CriterionJPAQL;
import es.csa.fdt.cyldigital.centros.service.CentroServiceImpl;
import es.csa.fdt.cyldigital.core.service.BrowserFilteredByActive;
import es.csa.fdt.cyldigital.recursos.entity.EventoPanel;
import es.csa.fdt.cyldigital.recursos.entity.Panel;

/**
 * Servicio del Browser de Eventos de Paneles.
 * 
 * @author csa
 */
@Service
@Repository
public class EventosPanelesBrowserImpl extends BrowserFilteredByActive<EventoPanel> implements
    EventosPanelesBrowser<CriterionJPAQL, String> {

  private static final long serialVersionUID = -7227366052245717441L;

  /**
   * Construye un nuevo objeto de la clase
   */
  public EventosPanelesBrowserImpl() {
    super();
  }

  /**
   * Apply filter panel.
   * 
   * @param id
   *           id
   * @param c
   *           c
   */
  public void applyFilterPanel(long id, CentroServiceImpl c) {

    if (id != 0) {
      Panel p = c.find(Panel.class, id);
      this.getCondition().getCriterion().setQuery(" ? member of e.paneles ");
      this.getCondition().getCriterion().addParameter(p);
      this.applyCondition();
    }
  }
}
