package es.csa.fdt.cyldigital.servicios.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2015  Xunta de Galicia <oficinacemit@xunta.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Balidea <info@balidea.com>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */

import es.csa.commons.persistence.browser.Filter;
import es.csa.commons.persistence.browser.jpaql.CriterionJPAQL;
import es.csa.commons.persistence.browser.jpaql.FilterJPAQLByQuery;
import es.csa.fdt.cyldigital.core.service.BrowserFilteredByActive;
import es.csa.fdt.cyldigital.servicios.entity.MatriculaCharla;


public class CharlasUsuarioBrowserImpl extends BrowserFilteredByActive<MatriculaCharla> implements CharlasUsuarioBrowser<CriterionJPAQL, String>{

	private static final long serialVersionUID = -72268752780144608L;

	public CharlasUsuarioBrowserImpl(){
		super();
		getSort().setSortProperty("idMatriculaCharla");
	}
	
	public void setFilterByUsuario(Long idUsuario) {
		removeFilterUsuario();
		filterByUsuario(idUsuario);
	}
	
	private void removeFilterUsuario() {
	    int i = -1;
	    for (Filter<CriterionJPAQL, MatriculaCharla> f : getFilters())
	      if (f.getCriterion().getQuery().contains("idUsuario")) i = getFilters().indexOf(f);
	    if (i > -1) getFilters().remove(i);
	  }

	/**
	 * Filter by usuario.
	 * 
	 * @param idUsuario
	 *           id usuario
	 */
	public void filterByUsuario(Long idUsuario) {
	    String query = "";

	    boolean flag = false;
	    FilterJPAQLByQuery<MatriculaCharla> filter = new FilterJPAQLByQuery<MatriculaCharla>();

	    query += " idUsuario = ? ";
	    filter.getCriterion().addParameter(idUsuario);

	    for (Filter<CriterionJPAQL, MatriculaCharla> f : getFilters())
	      if (f.getCriterion().getQuery().contains("idUsuario")) flag = true;

	    if (!flag) {
	      filter.getCriterion().setQuery(query);
	      getFilters().add(filter);
	    }
	  }
}
