package es.csa.fdt.cyldigital.servicios.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2015  Xunta de Galicia <oficinacemit@xunta.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Balidea <info@balidea.com>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */
 
import es.csa.commons.persistence.browser.Filter;
import es.csa.commons.persistence.browser.jpaql.CriterionJPAQL;
import es.csa.commons.persistence.browser.jpaql.FilterJPAQLByQuery;
import es.csa.fdt.cyldigital.core.service.BrowserFilteredByActive;
import es.csa.fdt.cyldigital.servicios.entity.Curso;

public class CursosPersonalBrowserImpl extends BrowserFilteredByActive<Curso> implements CursosPersonalBrowser<CriterionJPAQL, String>{

	private static final long serialVersionUID = -7896300384386155870L;
	
	public CursosPersonalBrowserImpl(){
		super();
		getSort().setSortProperty("fechaInicio");
	}
	
	public void setFilterByEmpleado(Long idPersonal) {
		removeFilterEmpleado();
		filterByEmpleado(idPersonal);
	}
	
	private void removeFilterEmpleado() {
	    int i = -1;
	    for (Filter<CriterionJPAQL, Curso> f : getFilters())
	      if (f.getCriterion().getQuery().contains("idPersonal")) i = getFilters().indexOf(f);
	    if (i > -1) getFilters().remove(i);
	  }

	/**
	 * Filter by empleado.
	 * 
	 * @param idPersonal
	 *           id empleado
	 */
	public void filterByEmpleado(Long idPersonal) {
	    String query = "";

	    boolean flag = false;
	    FilterJPAQLByQuery<Curso> filter = new FilterJPAQLByQuery<Curso>();

	    query += " idPersonal = ? ";
	    filter.getCriterion().addParameter(idPersonal);

	    for (Filter<CriterionJPAQL, Curso> f : getFilters())
	      if (f.getCriterion().getQuery().contains("idPersonal")) flag = true;

	    if (!flag) {
	      filter.getCriterion().setQuery(query);
	      getFilters().add(filter);
	    }
	  }

}
