package es.csa.fdt.cyldigital.servicios.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;
import es.csa.fdt.cyldigital.servicios.entity.PropuestaServicio;
import es.csa.fdt.cyldigital.servicios.entity.ServicioCursoOnline;
import es.csa.fdt.cyldigital.servicios.entity.Tematica;


/**
 * Clase ServicioCursoOnlineServiceImpl.
 * 
 * @author csa
 */
@Service
@Repository
public class ServicioCursoOnlineServiceImpl extends AbstractServiceImpl<ServicioCursoOnline, Long> implements
    ServicioCursoOnlineService {

  private static final long serialVersionUID = -5575228180361917674L;

  private List<Tematica> tematicas;

  /**
   * Construye un nuevo objeto de la clase
   */
  public ServicioCursoOnlineServiceImpl() {
    super();
  }

  /**
   * Devuelve tematicas.
   * 
   * @return tematicas
   */
  public List<Tematica> getTematicas() {
    return tematicas != null ? tematicas : findAllOrder(Tematica.class, "nombre", true);
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.ServicioCursoOnlineService#persistServicioCurso(es.csa.fdt.cyldigital.servicios.entity.ServicioCursoOnline)
   */
  public void persistServicioCurso(ServicioCursoOnline curso) {
    persist(curso);
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.ServicioCursoOnlineService#removeServicioCurso(es.csa.fdt.cyldigital.servicios.entity.ServicioCursoOnline)
   */
  public void removeServicioCurso(ServicioCursoOnline curso) {
    if (curso.getId() != 0) remove(curso);
  }

  /*
   * Esto parece sobrar. public void borrarFicheroTemporal(File file) { if (file != null && file.getFicheroSubido() !=
   * null) { file.getFicheroSubido().deleteFichero(); } }
   */
  /**
   * Update from propuesta.
   * 
   * @param idPropuesta
   *           id propuesta
   * @param c
   *           c
   * @return servicio curso online
   */
  public ServicioCursoOnline updateFromPropuesta(Long idPropuesta, ServicioCursoOnline c) {
    PropuestaServicio ps = find(PropuestaServicio.class, idPropuesta);
    if (ps != null) {
    	/*
         * Comentado para implementar los servicios MULTILANGUAGE
         * TODO: mirar y modificar
		c.setNombre(ps.getNombre());
		c.setDescripcion(ps.getComentarios());
    	*/
    }
    return c;
  }
}
