package es.csa.fdt.cyldigital.servicios.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;
import es.csa.fdt.cyldigital.servicios.entity.Navegacion;
import es.csa.fdt.cyldigital.servicios.entity.ServicioNavegacion;


/**
 * Clase ServicioNavegacionServiceImpl.
 * 
 * @author csa
 */
@Service
@Repository
public class ServicioNavegacionServiceImpl extends AbstractServiceImpl<ServicioNavegacion, Long> implements
    ServicioNavegacionService {

  private static final long serialVersionUID = -5575228180361917674L;

  private static final String DEFAULT_NOMBRE_SERVICIO = "Navegacion";

  /**
   * Construye un nuevo objeto de la clase
   */
  public ServicioNavegacionServiceImpl() {
    super();
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.ServicioNavegacionService#persistServicioNavegacion(es.csa.fdt.cyldigital.servicios.entity.ServicioNavegacion)
   */
  public void persistServicioNavegacion(ServicioNavegacion navegacion) {
    persist(navegacion);
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.ServicioNavegacionService#removeServicioNavegacion(es.csa.fdt.cyldigital.servicios.entity.ServicioNavegacion)
   */
  public void removeServicioNavegacion(ServicioNavegacion navegacion) {
    if (navegacion.getId() != 0) remove(navegacion);
  }

  /**
   * Actualiza servicio.
   * 
   * @param navegacion
   *           navegacion
   */
  public void actualizaServicio(Navegacion navegacion) {
    List<ServicioNavegacion> serviciosNavegacions = findAll(ServicioNavegacion.class);
    if (serviciosNavegacions.size() > 0) {
      navegacion.setServicio(serviciosNavegacions.get(0));
    } else {
      ServicioNavegacion servAsesor = new ServicioNavegacion();
      
      /*
       * Comentado para implementar los servicios MULTILANGUAGE
       * TODO: mirar y modificar
      servAsesor.setNombre(DEFAULT_NOMBRE_SERVICIO);
      */
      
      servAsesor.setEdadMaxima(100);
      servAsesor.setEdadMinima(4);
      disableMessages();
      persist(servAsesor);
      enableMessages();
      navegacion.setServicio(servAsesor);
    }
  }

}
