package es.csa.fdt.cyldigital.servicios.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;
import java.util.ArrayList;

//import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;
import es.csa.fdt.cyldigital.language.entity.Language;
import es.csa.fdt.cyldigital.language.entity.ServicioLanguage;
import es.csa.fdt.cyldigital.servicios.entity.PracticaTaller;
import es.csa.fdt.cyldigital.servicios.entity.ServicioPracticaTaller;


/**
 * Clase ServicioPracticaTallerServiceImpl.
 * 
 * @author csa
 */
@Service
@Repository
public class ServicioPracticaTallerServiceImpl extends AbstractServiceImpl<ServicioPracticaTaller, Long> implements
    ServicioPracticaTallerService {

  private static final long serialVersionUID = -5575228180361917674L;

  private static final String DEFAULT_NOMBRE_SERVICIO = "PracticaTaller";

  /**
   * Construye un nuevo objeto de la clase
   */
  public ServicioPracticaTallerServiceImpl() {
    super();
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.ServicioPracticaTallerService#persistServicioPracticaTaller(es.csa.fdt.cyldigital.servicios.entity.ServicioPracticaTaller)
   */
  public void persistServicioPracticaTaller(ServicioPracticaTaller practicaTaller) {
    persist(practicaTaller);
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.ServicioPracticaTallerService#removeServicioPracticaTaller(es.csa.fdt.cyldigital.servicios.entity.ServicioPracticaTaller)
   */
  public void removeServicioPracticaTaller(ServicioPracticaTaller practicaTaller) {
    if (practicaTaller.getId() != 0) remove(practicaTaller);
  }

  /**
   * Actualiza servicio.
   * 
   * @param practicaTaller
   *           practica taller
   */
  public void actualizaServicio(PracticaTaller practicaTaller) {
	    List<ServicioPracticaTaller> serviciosPracticaTallers = findAll(ServicioPracticaTaller.class);
	    if (serviciosPracticaTallers.size() > 0) {
	      practicaTaller.setServicio(serviciosPracticaTallers.get(0));
	    } else {
	      ServicioPracticaTaller spt = new ServicioPracticaTaller();
	     
	      List<Language> ll = findAll(Language.class);
	      List<ServicioLanguage> lsl = new ArrayList<ServicioLanguage>();
		  for (Language l : ll) {
			  ServicioLanguage sl = new ServicioLanguage();
			  
			  sl.setLanguage(l);
			  sl.setServicio(spt);
			  sl.setNombre(DEFAULT_NOMBRE_SERVICIO);
			  
			  lsl.add(sl);
		  }
		  spt.setTextos(lsl);
		  spt.setEdadMaxima(1);
		  spt.setEdadMinima(1);
	      disableMessages();
	      persist(spt);
	      enableMessages();
	      practicaTaller.setServicio(spt);
	    }
	  }

}
