package es.csa.fdt.cyldigital.servicios.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;
import es.csa.fdt.cyldigital.language.entity.Language;
import es.csa.fdt.cyldigital.language.entity.ServicioLanguage;
import es.csa.fdt.cyldigital.servicios.entity.ServicioWifi;
import es.csa.fdt.cyldigital.servicios.entity.Wifi;


/**
 * Clase ServicioWifiServiceImpl.
 * 
 * @author csa
 */
@Service
@Repository
public class ServicioWifiServiceImpl extends AbstractServiceImpl<ServicioWifi, Long> implements ServicioWifiService {

  private static final long serialVersionUID = -5575228180361917674L;

  private static final String DEFAULT_NOMBRE_SERVICIO = "Wifi";

  /**
   * Construye un nuevo objeto de la clase
   */
  public ServicioWifiServiceImpl() {
    super();
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.ServicioWifiService#persistServicioWifi(es.csa.fdt.cyldigital.servicios.entity.ServicioWifi)
   */
  public void persistServicioWifi(ServicioWifi wifi) {
    persist(wifi);
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.ServicioWifiService#removeServicioWifi(es.csa.fdt.cyldigital.servicios.entity.ServicioWifi)
   */
  public void removeServicioWifi(ServicioWifi wifi) {
    if (wifi.getId() != 0) remove(wifi);
  }

  /**
   * Actualiza servicio.
   * 
   * @param wifi
   *           wifi
   */
  public void actualizaServicio(Wifi wifi) {
    List<ServicioWifi> serviciosWifi = findAll(ServicioWifi.class);
    if (serviciosWifi.size() > 0) {
      wifi.setServicio(serviciosWifi.get(0));
    } else {
      ServicioWifi servAsesor = new ServicioWifi();
      
      List<Language> ll = findAll(Language.class);
      List<ServicioLanguage> lsl = new ArrayList<ServicioLanguage>();
	  for (Language l : ll) {
		  ServicioLanguage sl = new ServicioLanguage();
		  
		  sl.setLanguage(l);
		  sl.setServicio(servAsesor);
		  sl.setNombre(DEFAULT_NOMBRE_SERVICIO);
		  
		  lsl.add(sl);
	  }
	  servAsesor.setTextos(lsl);      
      
      servAsesor.setEdadMaxima(1);
      servAsesor.setEdadMinima(1);
      disableMessages();
      persist(servAsesor);
      enableMessages();
      wifi.setServicio(servAsesor);
    }
  }

}
