package es.csa.fdt.cyldigital.servicios.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import es.csa.fdt.cyldigital.core.service.AbstractServiceImpl;
import es.csa.fdt.cyldigital.servicios.entity.Asesoramiento;
import es.csa.fdt.cyldigital.servicios.entity.TipoAsesoramiento;


/**
 * Clase TipoAsesoramientoServiceImpl.
 * 
 * @author csa
 */
@Service
@Repository
public class TipoAsesoramientoServiceImpl extends AbstractServiceImpl<TipoAsesoramiento, Long> implements
    TipoAsesoramientoService {

  private static final long serialVersionUID = -5575228180361917674L;

  /**
   * Construye un nuevo objeto de la clase
   */
  public TipoAsesoramientoServiceImpl() {
    super();
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.TipoAsesoramientoService#persistTipoAsesoramiento(es.csa.fdt.cyldigital.servicios.entity.TipoAsesoramiento)
   */
  public boolean persistTipoAsesoramiento(TipoAsesoramiento tipoAsesoramiento) {

    persist(tipoAsesoramiento);
    return true;
  }

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.servicios.service.TipoAsesoramientoService#getTiposAsesoramientosDisponibles()
   */
  public List<TipoAsesoramiento> getTiposAsesoramientosDisponibles() {
    return findAll(TipoAsesoramiento.class);
  }

  /**
   * Elimina tipo asesoramiento.
   * 
   * @param tipoAsesoramiento
   *           tipo asesoramiento
   */
  public void removeTipoAsesoramiento(TipoAsesoramiento tipoAsesoramiento) {
    if (tipoAsesoramiento.getId() != 0) {
      for (Asesoramiento a : tipoAsesoramiento.getAsesoramientos()) {
        a.setTipoAsesoramiento(null);
      }
      tipoAsesoramiento.getAsesoramientos().clear();
      remove(tipoAsesoramiento);
    }
  }
}
