package es.csa.fdt.cyldigital.usuarios.service;

import java.util.Date;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.List;

import javax.persistence.EntityManager;

import es.csa.fdt.cyldigital.core.service.AbstractService;
import es.csa.fdt.cyldigital.usuarios.entity.Empleado;
import es.csa.fdt.cyldigital.usuarios.entity.Provincia;
import es.csa.fdt.cyldigital.usuarios.entity.UsuarioCyL;

/**
 * Interfaz del servicio de UsuarioCyL.
 * 
 * @author csa
 */
public interface UsuarioService extends AbstractService<UsuarioCyL, Long> {

  /**
   * Devuelve provincias.
   * 
   * @return provincias
   */
  public List<Provincia> getProvincias();

  /**
   * Persist usuario.
   * 
   * @param usuarioCyL
   *           usuario cy l
   * @param oldUsername
   *           old username
   * @param oldNif
   *           old nif
   * @param id
   *           id
   * @param prereg
   *           prereg
   * @return true, if successful
   */
  public boolean persistUsuario(UsuarioCyL usuarioCyL, String oldUsername, String oldNif, Long id, boolean prereg);


  /**
   * Desactiva un usuario del LDAP
   * 
   * @param usuarioCyL
   * 
   * @return true, if succesful
   * 
   * */
  public boolean desactivarUsuarioLDAP(UsuarioCyL usuarioCyL);

  /**
   * Desactiva un usuario del LDAP
   * 
   * @param usuarioCyL
   * @return true, if succesful
   */
  public boolean desactivarUsuarioLDAPTarea(UsuarioCyL usuarioCyL);
  
  /**
   * 
   * @param ucyl
   */
  public void persistUltimoAcceso(UsuarioCyL ucyl);
  
  /**
   * 
   * @param ucyl
   */
  public void updateLdapLogonTime(UsuarioCyL ucyl);
  
  /**
   * Devuelve la fecha del ultimo acceso del LDAP 
   * 
   * @param empleado
   * 			empleado
   * 
   * @return Date 
   */
  public Date getUltimoAccesoLDAP(UsuarioCyL usuarioCyL);
  
}
