package es.csa.fdt.cyldigital.usuarios.service;

/*
 * #%L
 * Librerías del núcleo - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import es.csa.commons.persistence.browser.Browser;
import es.csa.fdt.cyldigital.usuarios.entity.UsuarioPre;

/**
 * Interfaz UsuariosPreBrowser.
 * 
 * @author csa
 * 
 * @param <C>
 *           generic type
 * @param <O>
 *           generic type
 */
public interface UsuariosPreBrowser<C, O> extends Browser<UsuarioPre, C, O> {
  
  /**
   * Apply custom filter.
   */
  public void applyCustomFilter();

  /**
   * Asigna custom filter property.
   * 
   * @param customFilter
   *          custom filter property
   */
  public void setCustomFilterProperty(String customFilter);

  /**
   * Devuelve custom filter property.
   * 
   * @return custom filter property
   */
  public String getCustomFilterProperty();

  /**
   * Devuelve name filter property.
   * 
   * @return name filter property
   */
  public String getNameFilterProperty();

  /**
   * Asigna name filter property.
   * 
   * @param nameFilterProperty
   *          name filter property
   */
  public void setNameFilterProperty(String nameFilterProperty);

  /**
   * Devuelve surname filter property.
   * 
   * @return surname filter property
   */
  public String getSurnameFilterProperty();

  /**
   * Asigna surname filter property.
   * 
   * @param surnameFilterProperty
   *          surname filter property
   */
  public void setSurnameFilterProperty(String surnameFilterProperty);

  /**
   * Devuelve surname2 filter property.
   * 
   * @return surname2 filter property
   */
  public String getSurname2FilterProperty();

  /**
   * Asigna surname2 filter property.
   * 
   * @param surname2FilterProperty
   *          surname2 filter property
   */
  public void setSurname2FilterProperty(String surname2FilterProperty);

  /**
   * Devuelve phone filter property.
   * 
   * @return phone filter property
   */
  public String getPhoneFilterProperty();

  /**
   * Asigna phone filter property.
   * 
   * @param phoneFilterProperty
   *          phone filter property
   */
  public void setPhoneFilterProperty(String phoneFilterProperty);
}
