/*
 * #%L
 * Servicios Integrados para aplicaciones remotas - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */

function returnByDefaultFunction(event) {
  event.preventDefault(); 
  event.stopPropagation();
  var returnElement=jQuery('.return-by-default-overwrite,.return-by-default',jQuery(event.target).parents('.form')).get(0);
  if (typeof returnElement != 'undefined')
    if(jQuery.isFunction(jQuery(returnElement).click)) jQuery(returnElement).click(); 
    else if (jQuery.isFunction(jQuery(returnElement).onclick)) jQuery(returnElement).onclick();
}

function escByDefaultFunction(event) {
  event.preventDefault(); 
  event.stopPropagation();
  var escElement=jQuery('.esc-by-default-overwrite,.esc-by-default',jQuery(event.target).parents('.form')).get(0);
  if (typeof escElement != 'undefined')
    if(jQuery.isFunction(jQuery(escElement).click)) jQuery(escElement).click(); 
    else if (jQuery.isFunction(jQuery(escElement).onclick)) jQuery(escElement).onclick();
}

function formsInit() {

  jQuery.mask.definitions['A']='[A-Z]';
  jQuery.mask.definitions['1']='[0-1]';
  jQuery.mask.definitions['2']='[0-2]';
  jQuery.mask.definitions['3']='[0-3]';
  jQuery.mask.definitions['5']='[0-5]';
  jQuery.mask.definitions['#']='[0-9.,]';
  jQuery.mask.definitions['$']='[0-9:]';
  
  jQuery('.form textarea[type="textarea"], .form input[type="text"], .form input[type="password"]').focus(function(){
	  jQuery(this).addClass('field-highlight');
	    });
  
  jQuery('.form select').focus(function(event){
	  if (!jQuery.browser.msie) jQuery(this).addClass('field-highlight');
	    });
 
  jQuery('.form textarea[type="textarea"], .form input[type="text"], .form input[type="password"], .form select').blur(function(){
	      jQuery(this).removeClass('field-highlight');
	    });
  
  var focusElement=jQuery('.form  .focus-by-default-overwrite, .form  .focus-by-default');
  focusElement = jQuery(focusElement.get(focusElement.length-1));
  if (typeof focusElement != 'undefined' && jQuery.isFunction(focusElement.focus)) focusElement.focus();
  try { jQuery('.form').unbind('keydown', 'return', returnByDefaultFunction); } catch(error) { }
  jQuery('.form').bind('keydown', 'return', returnByDefaultFunction);
  try { jQuery('.form').unbind('keydown', 'esc', escByDefaultFunction); } catch(error) { }
  jQuery('.form').bind('keydown', 'esc', escByDefaultFunction);
  
  // Añadir * a los requeridos
  
  jQuery('.input-required').each(function() {
    var label = jQuery('label[for=' + jQuery(this).attr('id') + ']');
    if (label.find('span.required').length == 0) label.append('&#160;<span class="required">*</span>');
  });
  
  jQuery('.input-decimal:not(.without-mask)').mask("?########################################",{placeholder:""});
  jQuery('.input-integer:not(.without-mask)').mask("?9999999999999999999999999999999999999999",{placeholder:""});
  jQuery('.input-hour-minutes:not(.without-mask)').mask("?$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",{placeholder:""});
  
  jQuery('.input-time:not(.without-mask)').mask(jQuery_mask_inputTime);
  jQuery('.input-date:not(.without-mask)').mask(jQuery_mask_inputDate);
  jQuery('.input-datetime:not(.without-mask)').mask(jQuery_mask_inputDateTime);
}

A4JUtils.functionsOnComplete.push(formsInit);
jQuery(document).ready(formsInit);
