/*
 * #%L
 * Servicios Integrados para aplicaciones remotas - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */
var data_read = ""; // this variable stores data read from the card
var encoded_xml_to_write = ""; // this variable stores data that will be written to the card
var xml = '<?xml version="1.0" encoding="UTF-8"?>\n';
/*
    This function converts a string to another string of pairs of characters representing
    hexadecimal representation of each character in the original string.
   */
function string2hexstring(string)
{
    var hexstring = "";
    var ii = 0;
    
    var len = string.length;
    
  while ( ii < len ){
    var h1 = string.charCodeAt(ii++).toString(16);
    if ((h1.length % 2) == 1){
      hexstring += "0";
    }
        hexstring += h1;        
  }   
    
    return hexstring;
}

/*
   */
function hexstring2string(hexstring)
{
    var string = "";
    var ii = 0;
    var len = hexstring.length;
    var a, c;
    
    if(len%2)
    {
        return null;
    }
    
  while(ii<len)
    {
        a = hexstring.charCodeAt(ii++);
        if(a>='0'.charCodeAt(0) && a<='9'.charCodeAt(0)) {
            a = a - '0'.charCodeAt(0);
        } else if(a>='A'.charCodeAt(0) && a<='F'.charCodeAt(0)) {
            a = a - 'A'.charCodeAt(0) + 10;
        } else if(a>='a'.charCodeAt(0) && a<='f'.charCodeAt(0)) {
            a = a - 'a'.charCodeAt(0) + 10;
        } else {
            return null;
        }
        
        c = a << 4;
        
        a = hexstring.charCodeAt(ii++);
        if(a>='0'.charCodeAt(0) && a<='9'.charCodeAt(0)) {
            a = a - '0'.charCodeAt(0);
        } else if(a>='A'.charCodeAt(0) && a<='F'.charCodeAt(0)) {
            a = a - 'A'.charCodeAt(0) + 10;
        } else if(a>='a'.charCodeAt(0) && a<='f'.charCodeAt(0)) {
            a = a - 'a'.charCodeAt(0) + 10;
        } else {
            return null;
        }
        
        c = c | a;
        
    string += String.fromCharCode(c);
  }   
    
    return string;
}

/*
    This functions returns a hexadecimal dump of bin along with ascii data
   */
function dump(bin)
{
    var byteperline = 0x10;
  var hexstring = "";
  var dumped = "";
    var ii;
    var linehexstring;
    var linehexrep;
    var lineasciirep;
    
    
    var hexstring = string2hexstring(bin);
    
    while(hexstring.length > 0)
    {
        linehexstring = hexstring.slice(0, byteperline*2);
        
        linehexrep = "";
        lineasciirep = "";
        for(ii=0; ii<linehexstring.length; ii+=2)
        {
            linehexrep += linehexstring.slice(ii, ii+2) + '&nbsp;';
            lineasciirep += '&#x' + linehexstring.slice(ii, ii+2) + ';'; 
        }
        
        for(; ii<byteperline*2; ii+=2)
        {
            linehexrep += '&nbsp;&nbsp;&nbsp;'
        }
        
        dumped += linehexrep + '&nbsp' + lineasciirep + '<br />';
        hexstring = hexstring.slice(byteperline*2);
    }
    return dumped;
}

/*
    This function encodes string in UTF-8
   */
function encodeUTF8(string)
{
    string = string.replace(/\r\n/g,"\n");
    var utftext = "";

    for (var n = 0; n < string.length; n++) {

        var c = string.charCodeAt(n);

        if (c < 128) {
            utftext += String.fromCharCode(c);
        }
        else if((c > 127) && (c < 2048)) {
            utftext += String.fromCharCode((c >> 6) | 192);
            utftext += String.fromCharCode((c & 63) | 128);
        }
        else {
            utftext += String.fromCharCode((c >> 12) | 224);
            utftext += String.fromCharCode(((c >> 6) & 63) | 128);
            utftext += String.fromCharCode((c & 63) | 128);
        }
    }
    return utftext;
}

/*
    Mouse over event for actions
   */
function mouseOver(obj)
{
    obj.style.backgroundColor='#4a79c6';
    obj.style.color='#fff';
    obj.style.border='1px solid #005db5';    
}

/*
    Mouse out event for actions
   */
function mouseOut(obj)
{
    obj.style.backgroundColor='#fff';
    obj.style.color='#666';
    obj.style.border='1px solid #fff';    
}

/*
    Read card action
  */
function doReadCard()
{
    var tmp = document.CyLDigital.readCard();
    showCardOperationResult();
    data_read = hexstring2string(tmp);   
    rep = dump(data_read);
    document.getElementById('read_user_info_xml').innerHTML = rep;    
}

/*
    Update card action
  */
function doUpdateCard()
{
    if(encoded_xml_to_write.length<=0) {        
        document.getElementById('update_result').innerHTML = "<div class='binary_result'><span class='bad'>Rellene los datos y genere el XML</span></div>";
    } else {
        document.getElementById('update_result').innerHTML = "";
        var tmp = string2hexstring(encoded_xml_to_write);
        document.CyLDigital.updateCard(tmp);
        showCardOperationResult();
    }
}

/*
    Compare data action
  */
function doCompareData()
{
    var ii;
    
    var tmp = document.CyLDigital.readCard();
    data_read = hexstring2string(tmp);   
    
    if(encoded_xml_to_write.length != data_read.length) {
        document.getElementById('compare_result').innerHTML = "<div class='binary_result'><span class='bad'>Los datos son diferentes</span></div>";
        return;
    }
    
    for(ii=0; ii<encoded_xml_to_write.length; ii++) {
        if(encoded_xml_to_write.charCodeAt(ii) != data_read.charCodeAt(ii)) {
        document.getElementById('compare_result').innerHTML = "<div class='binary_result'><span class='bad'>Los datos son diferentes</span></div>";
            return;
        }
    }
    
    document.getElementById('compare_result').innerHTML = "<div class='binary_result'><span class='ok'>Los datos son iguales</span></div>";
}
function showCardOperationResult()
{
    var result = document.CyLDigital.getLastErrorString();
    
    if(result == ""){
        document.getElementById('operation_result').innerHTML = "<div class='binary_result'><span class='ok'>OK</span></div>";
        registrarCambio("ok"+new Date().getTime());
        //window.location = "?q=digitalusers-sc-grabar/"+nidUsuario+"/correcto";
    }else{
        document.getElementById('operation_result').innerHTML = "<div class='binary_result'><span class='bad'>ERROR: " + result + "</span></div>";
        registrarCambio("ko"+new Date().getTime());
    }
}
function appletLoaded()
{
    showCardOperationResult();
    inputUserData(document.getElementById('user_data_input'));    
}
