/*
 * #%L
 * Aplicación de Administracion - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * Copyright (C) 2015  Xunta de Galicia <oficinacemit@xunta.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * developed by: Balidea <info@balidea.com>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */
//<![CDATA[
/*!
 * Diplomas Designer v1.0.0 Octubre de 2013
 * http://www.fundetec.es
 * Using: jQuery v1.7.2, jQuery UI v1.10.3 and elFinder V2.0 rc1
 */

var $172 = jQuery.noConflict(true);

var diplomaWidth = 700; //Width of diploma in pixels.
var diplomaHeight = 495; //Height of diploma in pixels.
var diplomaAspectRatio = diplomaWidth / diplomaHeight; //Aspect ratio of diploma. 

var xToMmRatio = 0.4243; //Ratio to convert horizontal coordinates in pixels to milimeters for landscape A4. (297mm -> 700px)
var yToMmRatio = 0.4242; //Ratio to convert vertical coordinates in pixels to milimeters for landscape A4. (210mm -> 495px)

Array.prototype.searchById = function(id) {
	for (i = 0; i < this.length; i++) {
		if (this[i].id == id)
			return this[i];
	}
}

function oDraggable(id, posX, posY, width, height, zIndex, imagePath) {
	this.id = id;
	this.width = width;
	this.height = height;
	this.posX = posX;
	this.posY = posY;
	this.zIndex = zIndex;
	this.imagePath = imagePath;
}

var nDraggables = 0;
var draggables = new Array();
var selectedDraggable = null;

var methodToDefineDiplomaTemplate = 'designer';
var diplomaUploaded = false;

/**
 * 	Sets the selection state to the elements in "elements" parameter.
 *  
 * @param selected
 * 		Boolean indicating the selection state to be set. True value indicates "seleted", false value indicates "not selected".
 * 
 * @param elements
 * 		jQuery object representing a single element or group of elements to be set selection state.
 */
function setSelected(selected, elements) {
	elements.children('div[id^="dResizable"]').toggleClass('resizableOfNotSelected', !selected);
	elements.children('div[id^="dResizable"]').toggleClass('resizableOfSelected', selected);
}

/**
 * Checks if once element is selected in diplomas designer.
 * 		
 * @param element
 * 		jQuery object representing a single element to check if is selected.
 * 
 * @returns {Boolean}
 * 		True if element is selected. False in other case.
 */
function isSelected(element) {
	return (!element.children('div[id^="dResizable"]').hasClass('resizableOfNotSelected') &&
			element.children('div[id^="dResizable"]').hasClass('resizableOfSelected'));
}

/**
 * Sets the visibilty state to the elements in "elements" parameter.
 * 
 * @param visibility
 * 		Boolean indicating the visibility state to be set. True value indicates "visible", false value indicates "hidden".
 * 
 * @param element
 * 		jQuery object representing a single element or group of elements to be set selection state.
 */
function setVisible(visibility, element) {
	element.css('visibility', visibility ? 'visible' : 'hidden');
}

/**
 * Re-positions all draggables elements in their offsets that is set by the "draggables" array. UI offsets can be changed by
 * adding or removing draggables and with this procedure resets UI offsets.
 */
function rePositioningAllDraggables() {
	$172('div.draggable').each(function() {
		var draggable = draggables.searchById($172(this).attr('id'));
		
		$172('#' + draggable.id).offset({
			top:  draggable.posY + $172('#dDiplomaDesigner').offset().top + 1,
			left: draggable.posX + $172('#dDiplomaDesigner').offset().left + 1
		});
	})
}

/**
 * Update the size of the element, represented by "uiface" object, in the tool tip text box of the element. Also resets
 * the tool tip text box if its element has changed position.
 * 
 * @param nDrag
 * 		Integer representing the index of the element that has changed size. 
 * 
 * @param uiface
 * 		Object representing the UI element that has changed size. "uiface" has seven fields: element, helper, originalElement,
 * 		originalPosition, originalSize, position, size.
 * 
 * @param saveToObject
 * 		Boolean indicating if the size of the element will be stored in the associated oDraggable object in the "draggables" array. 
 */
function updateSize(nDrag, uiface, saveToObject) {
	$172('#dDraggableToolTip' + nDrag).offset({left: uiface.helper.offset().left, top: uiface.helper.offset().top - 18});
	
	if (saveToObject) {
		var dDraggable = draggables.searchById('dDraggable' + nDrag);
	
		dDraggable.width = uiface.size.width;
		dDraggable.height = uiface.size.height;
	}
	
	$172('#dDraggableToolTip' + nDrag + ' span').text(uiface.size.width + ' x ' + uiface.size.height);
}

/**
 * Update the position of the element, represented by "helper" jQuery object, in the tool tip text box of the element. Also resets
 * the tool tip text box if its element has changed position.
 * 
 * @param nDrag
 * 		Integer representing the index of the element that has changed position. 
 * 
 * @param helper
 * 		jQuery object representing the helper element that has changed position.
 * 
 * @param saveToObject
 * 		Boolean indicating if the position of the element will be stored in the associated oDraggable object in the
 * 		"draggables" array. 
 */
function updatePosition(nDrag, helper, saveToObject) {
	$172('#dDraggableToolTip' + nDrag).offset({left: helper.offset().left, top: helper.offset().top - 18});

	var posX = (helper.offset().left - $172('#dDiplomaDesigner').offset().left - 1);
	var posY = (helper.offset().top  - $172('#dDiplomaDesigner').offset().top  - 1);
	
	if (saveToObject) {
		var dDraggable = draggables.searchById('dDraggable' + nDrag);
		
		dDraggable.posX = posX;
		dDraggable.posY = posY;
	}
	
	var posXmm = (posX * xToMmRatio).toFixed(1);
	var posYmm = (posY * yToMmRatio).toFixed(1);

	$172('#dDraggableToolTip' + nDrag + ' span').text(posXmm + 'mm x ' + posYmm + 'mm');
}

/**
 * Callback procedure called when user select a image file to be added to diploma in the elFinder browser.
 * 
 * This procedure:
 * 		- Calls to addDraggable procedure to add a draggable and resizable element that shows the image file selected and store
 * 		  a new oDraggable object in the "draggables" array.
 * 		- Hide elFinder.
 * 
 * @param file
 * 		Object array containing information about the file selected.
 */
function getFileFromElFinder(file) {
	var dimensions = file.dim.split('x');

	addDraggable(++nDraggables, file.url, file.path, parseInt(dimensions[0]), parseInt(dimensions[1]));
	
	$172('#elFinderBackground').css('visibility', 'hidden');
	$172('#elFinder').css('visibility', 'hidden');
}

/**
 * Procedure that adds draggable and resizable element, with all necessary properties and event handlers, to the diploma designer.
 * Also store a new oDraggable object, representing the element added to the diploma designer, in the "draggables" array.
 * 
 * @param nDrag
 *		 Integer representing the index of the new element to be created.
 * 
 * @param imageURL
 * 		String representing the URL of the image file to be displayed in the element.
 * 
 * @param imagePath
 * 		String representing the virtual path in elFinder of the image file to be displayed in the element.  
 * 
 * @param draggableWidth
 * 		Integer representing the original width of the image file to be displayed in the element.
 * 
 * @param draggableHeight
 *		Integer representing the original height of the image file to be displayed in the element.
 */
function addDraggable(nDrag, imageURL, imagePath, draggableWidth, draggableHeight) {
	var draggableAspectRatio = draggableWidth / draggableHeight;
	
	if ((draggableWidth > diplomaWidth) || (draggableHeight > diplomaHeight)) {
		if (draggableAspectRatio <= diplomaAspectRatio) {
			draggableHeight = diplomaHeight;
			draggableWidth = Math.round(draggableHeight * draggableAspectRatio);
		}
		else {
			draggableWidth = diplomaWidth;
			draggableHeight = Math.round(draggableWidth / draggableAspectRatio);
		}
	}
	
	$172('#dDraggables').append('<div id="dDraggable' + nDrag + '" ' +
									 'style="background-image: url(\'' + imageURL + '\'); ' +
									 		'width: ' + draggableWidth + 'px; ' +
									 		'height: ' + draggableHeight + 'px;" ' +
									  'class="draggable">' +
									'<div id="dResizable' + nDrag + '"' +
								    	 'style="width: ' + (draggableWidth - 2) + 'px; ' +
								    	 		'height: ' + (draggableHeight - 2) + 'px;"' +
								    	 'class="resizableOfNotSelected">' +
									'</div>' +
								'</div>');
	
	$172('#dDraggablesToolTips').append('<div id="dDraggableToolTip' + nDrag + '" class="draggableToolTip">' +
											'<span>0 x 0</span>' +
										'</div>');

	$172('div#dResizable' + nDrag).resizable({
		containment: "#dDiplomaDesigner",
		aspectRatio: draggableAspectRatio,
	    alsoResize: 'div#dDraggable' + nDrag,
	    start: function(event, uiface) {
	    	setSelected(false, $172('.draggable'))
			
			selectedDraggable = nDrag;
			setSelected(true, $172('div#dDraggable' + nDrag))
			
			updateSize(nDrag, uiface, false);
			
			setVisible(true, $172('#dDraggableToolTip' + nDrag));
	    },
	    resize: function(event, uiface) {
	    	rePositioningAllDraggables();
			
	    	// Si al hacer resize el objeto se sale del diseñador de diplomas por el lado derecho lo mueve hacia la izquierda
	    	// hasta que vuelva a quedar dentro del diseñador de diplomas.
	    	if ((uiface.size.width + uiface.helper.offset().left) > ($172("div#dDiplomaDesigner").width() + $172("div#dDiplomaDesigner").offset().left))
	    		$172('div#dDraggable' + nDrag).offset({left: ($172("div#dDiplomaDesigner").width() + $172("div#dDiplomaDesigner").offset().left) - uiface.size.width + 1});
	    	
	    	// Si al hacer "resize" el objeto se sale del diseñador de diplomas por el lado inferior lo mueve hacia arriba
	    	// hasta que vuelva a quedar dentro del diseñador de diplomas.
	    	if ((uiface.size.height + uiface.helper.offset().top) > ($172("div#dDiplomaDesigner").height() + $172("div#dDiplomaDesigner").offset().top))
	    		$172('div#dDraggable' + nDrag).offset({top: ($172("div#dDiplomaDesigner").height() + $172("div#dDiplomaDesigner").offset().top) - uiface.size.height + 1});
	    	
	    	updateSize(nDrag, uiface, false);
	    },
	    stop: function(event, uiface) {
	    	updateSize(nDrag, uiface, true);
	    	
	    	updatePosition(nDrag, $172('div#dDraggable' + nDrag), true);
	    	
	    	setVisible(false, $172('#dDraggableToolTip' + nDrag));
	    }
	});
	
	$172('div#dDraggable' + nDrag).draggable({
		containment: '#dDiplomaDesigner',
		zIndex: 1,
		scroll: false,
		start: function(event, uiface) {
			setSelected(false, $172('.draggable'))
			
			selectedDraggable = nDrag;
			setSelected(true, $172(this))
			   
			updatePosition(nDrag, uiface.helper, false);
			
			setVisible(true, $172('#dDraggableToolTip' + nDrag));
		},
		drag: function(event, uiface) {
			updatePosition(nDrag, uiface.helper, false);
		},
		stop: function(event, uiface) {
			updatePosition(nDrag, uiface.helper, true);
			
			setVisible(false, $172('#dDraggableToolTip' + nDrag));
		}
	})
	.click(function(event) {
		event.stopPropagation();
   
		if (isSelected($172(this)))
			selectedDraggable = null;
		else {
			selectedDraggable = nDrag;
			setSelected(false, $172('.draggable'));
		}

		setSelected(!isSelected($172(this)), $172(this));
	})
	.offset({top: $172('#dDiplomaDesigner').offset().top + 1,
			 left: $172('#dDiplomaDesigner').offset().left + 1})
	.css('z-index', 1);
	
	draggables.push(new oDraggable('dDraggable' + nDrag, 0, 0, draggableWidth, draggableHeight, 1, imagePath));
}

/**
 * 
 * 
 * @param activeLanguage
 */
function showDiplomaAsistenciaAndHideAprovechamiento(activeLanguage) {
	$172('[id^="dTextoDiplomaAsistencia_' + activeLanguage + '"]').show();
	$172('[id^="dTextoDiplomaAprovechamiento_' + activeLanguage + '"]').hide();
	
	$172('[id^="dTextoExistDiplomaAsistencia_' + activeLanguage + '"]').show();
	$172('[id^="dTextoExistDiplomaAprovechamiento_' + activeLanguage + '"]').hide();
}

/**
 * 
 * 
 * @param event
 */
function showDesignerMethod() {
	methodToDefineDiplomaTemplate = 'designer';
	$172('#diploma\\:ihMethodToDefineDiplomaTemplate').val(methodToDefineDiplomaTemplate);	
	
	$172('#dDiplomaOverlayTexts').show();
		
	$172('#liDesignerMethod').removeClass('tab-inactive').addClass('tab-active');
	$172('#liUploaderMethod').removeClass('tab-active').addClass('tab-inactive');
	
	$172('#DiplomaTemplateDesignerMethod').show();
	$172('#diploma\\:pgDiplomaTemplateUploaderMethod').hide();
}

/**
 * 
 * 
 * @param event
 */
function showUploaderMethod() {
	methodToDefineDiplomaTemplate = 'uploader';
	$172('#diploma\\:ihMethodToDefineDiplomaTemplate').val(methodToDefineDiplomaTemplate);
	
	if (diplomaUploaded)
		$172('#dDiplomaOverlayTexts').show();
	else
		$172('#dDiplomaOverlayTexts').hide();
		
	$172('#liDesignerMethod').removeClass('tab-active').addClass('tab-inactive');
	$172('#liUploaderMethod').removeClass('tab-inactive').addClass('tab-active');

	$172('#DiplomaTemplateDesignerMethod').hide();
	$172('#diploma\\:pgDiplomaTemplateUploaderMethod').show();
}

/**
 * 
 * 
 * @param langButtonActiveClass
 * @param langButtonISOAttr
 */
function switchDiplomaType(langButtonActiveClass, langButtonISOAttr) {
	var activeLanguage = $172('[class="' + langButtonActiveClass + '"]').attr(langButtonISOAttr);

	$172('[id^="dTextoDiplomaAsistencia_' + activeLanguage + '"]').toggle();
	$172('[id^="dTextoDiplomaAprovechamiento_' + activeLanguage + '"]').toggle();
}

// Show or hide the diploma signature depending on check-box state
function showHideSignature() {
	
	var activeLanguage = $172('[class="lang-button on"]').attr('title');
	
	if($172('#diploma\\:itSigned').is(":checked")) {
		if ($172('[id^="dSignatureDiploma_' + activeLanguage + '"]').is(':hidden')) {
			$172('[id^="dSignatureDiploma_' + activeLanguage + '"]').show();
		}
		if ($172('[id^="dSignatureExistDiploma_' + activeLanguage + '"]').is(':hidden')) {
			$172('[id^="dSignatureExistDiploma_' + activeLanguage + '"]').show();
		}
		if ($172('[id^="dResponsableDiploma_' + activeLanguage + '"]').is(':hidden')) {
			$172('[id^="dResponsableDiploma_' + activeLanguage + '"]').show();
		}
		if ($172('[id^="dResponsableExistDiploma_' + activeLanguage + '"]').is(':hidden')) {
			$172('[id^="dResponsableExistDiploma_' + activeLanguage + '"]').show();
		}
	} else {
		if ($172('[id^="dSignatureDiploma_' + activeLanguage + '"]').is(':visible')) {
			$172('[id^="dSignatureDiploma_' + activeLanguage + '"]').hide();
		}
		if ($172('[id^="dSignatureExistDiploma_' + activeLanguage + '"]').is(':visible')) {
			$172('[id^="dSignatureExistDiploma_' + activeLanguage + '"]').hide();
		}
		if ($172('[id^="dResponsableDiploma_' + activeLanguage + '"]').is(':visible')) {
			$172('[id^="dResponsableDiploma_' + activeLanguage + '"]').hide();
		}
		if ($172('[id^="dResponsableExistDiploma_' + activeLanguage + '"]').is(':visible')) {
			$172('[id^="dResponsableExistDiploma_' + activeLanguage + '"]').hide();
		}
	}
}


/**
 * 
 * 
 * @param langButtonClass
 * @param langButtonActiveClass
 * @param langButtonISOAttr
 * @param elFinderConnectorURL
 * @param ifaceISOLanguage
 */
function startDiplomasDesigner(langButtonClass, langButtonActiveClass, langButtonISOAttr, elFinderConnectorURL, ifaceISOLanguage) {
	
	showDiplomaAsistenciaAndHideAprovechamiento($172('[class="' + langButtonActiveClass + '"]').attr(langButtonISOAttr));

	$172('#elFinder').elfinder({
		url : elFinderConnectorURL,
		lang: ifaceISOLanguage,
		onlyMimes: ['image'],
		width: 600,
		commands: ['open', 'reload', 'getfile', 'download', 'rm', 'rename',
				   'mkdir', 'upload', 'copy', 'cut', 'paste', 'info'],
		commandsOptions: {
			getfile: {
				onlyURL: false
			}
		},
		getFileCallback: getFileFromElFinder,
		handlers : {
			upload : function(event, instance) {
				var uploadedFiles = event.data.added;
				
				for (i = 0; i < uploadedFiles.length; i++) {
					if (uploadedFiles[i].mime.substr(0, 5) != 'image')
						event.preventDefault();
				}
			}
		},
		uiOptions : {
			toolbar: [
				['reload'],
				['mkdir', 'upload'],
				['open', 'download', 'getfile'],
				['info'],
				['copy', 'cut', 'paste'],
				['rm'],
				['rename']
			],
			tree : {
				openRootOnLoad : true,
				syncTree : true
			}
		},
		contextmenu : {
			navbar : ['open', '|', 'copy', 'cut', 'paste', '|', 'rm', '|', 'info'],
			cwd: ['reload', '|', 'upload', 'mkdir', 'paste', '|', 'info'],
			files: ['getfile', '|','open', 'download', '|', 'copy', 'cut', 'paste', '|',
					'rm', '|', 'rename', '|', 'info']
		},
		resizable: false
	}).prepend('<div id="elFinderClose">&#215;</div>')
	
	//On click event triggered by language flags buttons, change language of texts in diploma designer.
	$172('.' + langButtonClass).click(function() {
		showDiplomaAsistenciaAndHideAprovechamiento($172(this).attr(langButtonISOAttr));
	});
	
	//On click event triggered by signature check-box, update signature visibility
	$172('#diploma\\:itSigned').click(function() {
		showHideSignature();
	});

	//On visibility change of signatureDiploma elements review its visibility status 
	$172('.signatureDiploma').attrchange({
		callback: function (event) { 
			showHideSignature();
		}
	});
	
	//On keypress keyup and change events triggered by diploma custom text textareas, copy values to diploma designer boxes.
	$172('textarea[id^="diploma\\:itTextoDiploma"]').bind("keypress keyup change", function() {
		var innerHTML = "";
		$172.each($172(this).val().split('\n'), function(index, value) {
			innerHTML += "<p>" + value + "</p>";
		});
		
		$172('#dTextoDiploma' + $172(this).attr('id').substr(22)).html(innerHTML);
		$172('#dTextoExistDiploma' + $172(this).attr('id').substr(22)).html(innerHTML);
	});
	
	//On change event triggered by field selector of diploma custom text textareas, add field code in text of selected option to
	//appropriate textaerea, trigger change event of the same textarea and finally change selected index of field select to
	//the first option.
	$172('select[id^="diploma\\:sFieldsTextoDiploma"]').change(function(event) {
		//Identify appropiate textarea
		var targetSelector = '#diploma\\:itTextoDiploma' + $172(this).attr('id').substr(27);
		
		//Get cursos position of textarea identified
		var cursorPosition = $172(targetSelector).prop('selectionStart');
		
		//Get value of textarea identified
		var taValue = $172(targetSelector).val();
		
		//Modify value of textarea identified adding text code of field selected.
		$172(targetSelector).val(taValue.slice(0, cursorPosition) + $172(this).val() + taValue.slice(cursorPosition))
		
		//Set cursorPosition after text code added
		$172(targetSelector).prop('selectionStart', cursorPosition + $172(this).val().length);
		
		//Trigger identified textarea's change event
		$172(targetSelector).change();
		
		//Select first option of field selector again
		$172(this).prop('selectedIndex', 0);
	});
	
	//On click event triggered by "X" in elFinder, close it.
	$172('#elFinderClose').click(function() {
		$172('#elFinderBackground').css('visibility', 'hidden');
		$172('#elFinder').css('visibility', 'hidden');
	});
	
	//
	$172('#liDesignerMethod').click(function(event) {
		showDesignerMethod();

		event.preventDefault();
	});
	
	//
	$172('#liUploaderMethod').click(function(event) {
		showUploaderMethod();
		
		event.preventDefault();
	});
	
	//On click event triggered by the principal div of diploma designer, unselect all element added.  
	$172('#dDiplomaDesigner').click(function() {
		selectedDraggable = null;

		setSelected(false, $172('.draggable'));
	});
	
	//On click event triggered by "Add element" button, show elFinder.
	$172('#bAdd').click(function() {
		$172('#elFinderBackground').css('visibility', 'visible');
		$172('#elFinder').css('visibility', 'visible');
	});
	
	//On click event triggered by "Remove element" button,
	//remove selected element (if someone is selected), unselect it and repositioning all elements.
	$172('#bRemove').click(function() {
		if (selectedDraggable != null) {
			$172('#dDraggable' + selectedDraggable).remove();
			$172('#dDraggableToolTip' + selectedDraggable).remove();
			
			draggables.splice(draggables.indexOf(draggables.searchById('dDraggable' + selectedDraggable)), 1);
			
			selectedDraggable = null;
			
			rePositioningAllDraggables();
		}
	});
	
	//On click event triggered by "Bring to front" button.
	$172('#bBringToFront').click(function() {
		if (selectedDraggable != null) {
			var zIndex = $172('#dDraggable' + selectedDraggable).draggable("option", "zIndex");
			
			zIndex += 1;
			
			draggables.searchById('dDraggable' + selectedDraggable).zIndex = zIndex;
			
			$172('#dDraggable' + selectedDraggable).draggable("option", "zIndex", zIndex);
			$172('#dDraggable' + selectedDraggable).css("z-index", zIndex);
			
			$172('#dDraggableToolTip' + selectedDraggable).css("z-index", zIndex);
		}
	});
	
	//On click event triggered by "Send to back" button.
	$172('#bSendToBack').click(function() {
		if (selectedDraggable != null) {
			var zIndex = $172('#dDraggable' + selectedDraggable).draggable("option", "zIndex");
			
			if (zIndex > 1) {
				zIndex -= 1;
				
				draggables.searchById('dDraggable' + selectedDraggable).zIndex = zIndex;
				
				$172('#dDraggable' + selectedDraggable).draggable("option", "zIndex", zIndex);
				$172('#dDraggable' + selectedDraggable).css("z-index", zIndex);
				
				$172('#dDraggableToolTip' + selectedDraggable).css("z-index", zIndex);
			}
		}
	});
	
	//On click event triggered by "Show/Hide text" button.
	$172('#bHideShowText').click(function() {
		$172('#dDiplomaOverlayTexts').toggle();
		
		showDiplomaAsistenciaAndHideAprovechamiento($172('[class="' + langButtonActiveClass + '"]').attr(langButtonISOAttr));
	});
	
	//On click event triggered by "Asistencia/Aprovechamiento" switch button.
	$172('#bSwitchDiplomaDesignerType').click(function() {
		switchDiplomaType(langButtonActiveClass, langButtonISOAttr);
	});
	
	//On click event triggered by "Asistencia/Aprovechamiento" of existing diploma switch button.
	$172('#bSwitchExistDiplomaType').click(function() {
		var activeLanguage = $172('[class="' + langButtonActiveClass + '"]').attr(langButtonISOAttr);

		$172('[id^="dTextoExistDiplomaAsistencia_' + activeLanguage + '"]').toggle();
		$172('[id^="dTextoExistDiplomaAprovechamiento_' + activeLanguage + '"]').toggle();
	});
}

/**
 * 
 * 
 * @returns
 */
function getDraggablesJSON() {
	var oJSON;
	var draggablesJSON = [];
    
    for (var i = 0; i < draggables.size(); i++) {
    	oJSON = draggables[i];

    	draggablesJSON[i] = oJSON;
    }
    
    return draggablesJSON.toJSON();
}

/**
 * 
 * 
 * 
 */
function saveDraggablesJSON() {
	$172('#diploma\\:ihDraggablesJSON').val(getDraggablesJSON());
}
//]]>
