/*
 * #%L
 * Aplicación de Administracion - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */
var cal;
jQuery(document).ready(function($) {
	cal = $('#calendar').fullCalendar({
		header: {
          left: 'prev,next today',
          center: 'title',
          right: 'month,agendaWeek,agendaDay'
        },
        editable: false,
        draggable : false,
        defaultView: 'month',
        events: [], // Dejo los eventos iniciales vacíos, luego los rellenos
        theme: true,
        dragToCreate: true,
        dragToCreateFn: function(calEvent){
            resetScheduleForm();
            jQuery('#eventId').val(calEvent._id);
            jQuery('#startTime').val(calEvent.start.getHours()+':'+calEvent.start.getMinutes());
            jQuery('#endTime').val(calEvent.end.getHours()+':'+calEvent.end.getMinutes());
            jQuery('#scheduleDiv').show().dialog('open');

        },

        // Callback del calendario, nada más pulsar el botón de eventos previos
        prev : function(date,view) {
        	if (isEdition()){
        		otherActions($('#calendar').fullCalendar('clientEvents'),false);
        		$('#calendar').fullCalendar('removeEventSource',eventosNoEdit);
	        	getNoEditItems(constructNoEditUrl(date,view,"prev"));
        	}        	
        	else{
        	  $('#calendar').fullCalendar('removeEvents');
        	  getItems(constructUrl(date,view,"prev"));
          }
        },
        // Callback del calendario, nada más pulsar el botón de eventos posteriores
        next : function(date,view) {
        	if (isEdition()){
        		otherActions($('#calendar').fullCalendar('clientEvents'),false);
        		$('#calendar').fullCalendar('removeEventSource',eventosNoEdit);
	        	getNoEditItems(constructNoEditUrl(date,view,"next"));
        	}        	
        	else{
	        	$('#calendar').fullCalendar('removeEvents');
	        	getItems(constructUrl(date,view,"next"));
        	}
        },
        // Callback del calendario, nada más pulsar el botón de eventos de hoy
        today : function(date,view) {
        	if (isEdition()){
        		otherActions($('#calendar').fullCalendar('clientEvents'),false);
        		$('#calendar').fullCalendar('removeEventSource',eventosNoEdit);
	        	getNoEditItems(constructNoEditUrl(date,view,"today"));
        	}        	
        	else{
	        	$('#calendar').fullCalendar('removeEvents');
	        	getItems(constructUrl(date,view,"today"));
        	}
        },
        eventAfterRenderOnGrid : function(event,element,month,view) {
        	var cssName="";
        	if (event.end == null){
        		event.end = new Date();
            	event.end.setTime(event.start.getTime());
        	}
            if (event.festivo){
            	cssName = "fc-festivo";
            	if (view.toLowerCase() == "month"){
                  renderOnGrid(event,$("td.ui-state-default").get(),month,cssName);
            	}
            	else{
            		var pattern = 'td.fc'+ view +'-' + event.start.getDate() + '-' + (event.start.getMonth()+1) + '-' + (event.start.getYear()+1900);
            		renderOnAgenda(event,$(pattern).get(),cssName);
            	}
            }
            if (event.vacaciones){
            	cssName = "fc-vacaciones-empleado";
            	if (view.toLowerCase() == "month"){
                  renderOnGrid(event,$("td.ui-state-default").get(),month,cssName);
            	}
            	else{
            		var startAux = new Date();
            		startAux.setTime(event.start.getTime());
            		while (startAux.getTime() <= event.end.getTime()){
            			var pattern = 'td.fc'+ view +'-' + startAux.getDate() + '-' + (startAux.getMonth()+1) + '-' + (startAux.getYear()+1900);
            			renderOnAgenda(event,$(pattern).get(),cssName);
            			startAux.setDate(startAux.getDate()+1);
            		}
            	}
            }
            //$('a.cal').wTooltip();
        },

        eventAfterRenderOnAgenda : function(event,element) {
        	var cssName="";
            if (event.festivo){
            	cssName = "fc-festivo";
            	var pattern = 'td.fc'+ view +'-' + event.start.getDate() + '-' + (event.start.getMonth()+1) + '-' + (event.start.getYear()+1900);
            	renderOnAgenda(event,$(pattern).get(),cssName);
            }
            if (event.vacaciones){
            	cssName = "fc-vacaciones-empleado";
            	var startAux = new Date();
            	startAux.setTime(event.start.getTime());
            	while (startAux.getTime() <= event.end.getTime()){
            		var pattern = 'td.fc'+ view +'-' + startAux.getDate() + '-' + (startAux.getMonth()+1) + '-' + (startAux.getYear()+1900);
            		renderOnAgenda(event,$(pattern).get(),cssName);
            		startAux.setDate(startAux.getDate()+1);
            	}
            }
            //$('a.cal').wTooltip();
        },
        
        dayClick : function(date, allday) {
        	if (isEdition() && (cal.fullCalendar('getView') || !allday)){
	            resetScheduleForm(date);
	            $('#eventId').val(0);
	            if (date.getHours() == 0){
	            	$('#startTime').val("10:00");
	            	$('#endTime').val("12:00");
	            }
	            else{
		            /*$('#startTime').val(date.getHours()+':'+date.getMinutes());
		            $('#endTime').val((date.getHours()+2)+':'+date.getMinutes());*/
	            	
	            	$('#startTime').val(date.toTimeString().substring(0, 5));
	            	endDate = date;
	            	endDate.setHours(date.getHours() + 2);
		            $('#endTime').val(endDate.toTimeString().substring(0, 5));
	            }
	            $('#scheduleDiv').show().dialog('open');
        	}
        },
        
        eventClick : function(calEvent, $event) {
        	if (isEdition() && calEvent.editable){
	      	  putScheduleForm(calEvent);
	          $('#eventId').val(calEvent._id);
	          $('#startTime').val(calEvent.start.getHours()+':'+calEvent.start.getMinutes());
	          $('#endTime').val(calEvent.end.getHours()+':'+calEvent.end.getMinutes());
	          $('#scheduleDiv').show().dialog('open');
        	}
        }
        
	});
	
    // Agrego los eventos iniciales del calendario.
    getItems(constructUrl(null,null,"today"));

    //Me muevo a una fecha inicial, si se requiere.
    gotoDate();
});

function getItems(url){
	jQuery.getJSON(url, function(eventos){
		jQuery('#calendar').fullCalendar('addEventSource',eventos);
		
		if (isEdition()){
			getNoEditItems(constructNoEditUrl(null, null, "today"));
		}
    });
}

function getNoEditItems(url){
	jQuery.getJSON(url, function(eventos){
		eventosNoEdit = eventos;
		jQuery('#calendar').fullCalendar('addEventSource',eventosNoEdit);		
    });
}

function isSameMonth(event,month){
	return (event.start.getMonth() == month);
}

function renderOnGrid(event,tds,month,cssName){
	var e = event;
	var startAux = new Date();
	startAux.setTime(e.start.getTime());
	jQuery.each(tds,function(i,td){
		if (startAux.getTime() <= e.end.getTime()){
			var ok = false;
			var cName = td.className;
			if(!ie){
			if (td.textContent.trim()==(startAux.getDate()+"") &&
					((isSameMonth(e,month) && (cName.search("fc-other-month")==-1)) ||
					(!isSameMonth(e,month) && (cName.search("fc-other-month")>=0))    )){
				cName = cName.replace("fc-domingo",cssName);
				cName = cName.replace("fc-not-today",cssName);
				cName = cName.replace("fc-today",cssName);
				cName = cName.replace("ui-state-highlight","");
				cName = cName.replace("fc-state-highlight","");
				td.className = cName;
				startAux.setDate(startAux.getDate()+1);
			}
			}
		}
		else{
			return false;
		}
    });
}

function renderOnAgenda(event,tds,cssName){
	var e = event;
	jQuery.each(tds,function(i,td){
    	var cName = td.className;
        cName = cName.replace("fc-domingo",cssName);
        cName = cName.replace("fc-not-today",cssName);
        cName = cName.replace("fc-today",cssName);
        cName = cName.replace("ui-state-highlight","");
        cName = cName.replace("fc-state-highlight","");
        td.className = cName;
        return false;
    });
}
