package es.csa.fdt.cyldigital.controller;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.text.ParseException;
import java.text.SimpleDateFormat;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.support.RequestContextUtils;

import es.csa.fdt.cyldigital.indicadores.ReportHelper;

/**
 * Clase ReportsController.
 */
@Controller
public class ReportsController {
	private class ReportComputation {
		private Long idReport;
		private String requestURI;
		private String reportPath;
		private Map<String, Object> model;
		private Thread thread;
		private Boolean consumed;
		private Long finishTimestamp;
	  
		public ReportComputation(Long idReport, String requetsURI, String reportPath, Map<String, Object> model) {
			this.idReport = idReport;
			this.requestURI = requetsURI;
			this.reportPath = reportPath;
			this.model = model;
			
			this.consumed = false;
			this.finishTimestamp = -1L;
		}
	  
		public Long getIdReport() {
			return idReport;
		}
	  
		public String getRequestURI() {
			return requestURI;
		}
	  
		public String getReportPath() {
			return reportPath;
		}
	  
		public Map<String, Object> getModel() {
			return model;
		}
		
		public Boolean isConsumed() {
			return consumed;
		}
		
		public void setToConsumed() {
			this.consumed = true;
		}
		
		public Long getFinishTimestamp() {
			return finishTimestamp;
		}
		
		public void setFinishTimestamp(Long finishTimestamp) {
			this.finishTimestamp = finishTimestamp;
		}
		
		public Thread getThread() {
			return thread;
		}
		
		public void setThread(Thread thread) {
			this.thread = thread;
		}
	}
	
	private static HashMap<Long, ReportComputation> results = new HashMap<Long, ReportComputation>();
	
  /**
   * Handle.
   * 
   * @param idCentro
   *           id centro
   * @param fechaInicio
   *           fecha inicio
   * @param fechaFin
   *           fecha fin
   * @param idSeccion
   *           id seccion
   * @param idUsuarioPeticion
   *           id usuario peticion
   * @param idProyecto
   *           id proyecto
   * @param request
   *           request
   * @param response
   *           response
   * @return the model and view
   */
	/*
  @RequestMapping("/reportsOld/**")
  public ModelAndView handleOld(@RequestParam("idCentro") String idCentro,
      @RequestParam("fechaInicio") String fechaInicio, @RequestParam("fechaFin") String fechaFin, @RequestParam("seccion") String idSeccion, 
      @RequestParam("idUsuarioPeticion") String idUsuarioPeticion, @RequestParam(required = false, value="idProyecto") String idProyecto,
      HttpServletRequest request, HttpServletResponse response) {
    ServletContext servletContext = request.getSession().getServletContext();
    WebApplicationContext webApplicationContext = RequestContextUtils.getWebApplicationContext(request, servletContext);

    SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy");
    Date fechaFinDate = new Date();
    Date fechaInicioDate = new Date();
    try {
      fechaInicioDate = formateador.parse(fechaInicio);
      fechaFinDate = formateador.parse(fechaFin);
    } catch (ParseException e) {
      // Auto-generated catch block
      e.printStackTrace();
    }
    String reportsRegex = "^(.*)/reports/([a-zA-Z-_/\\\\]*)\\.([a-zA-Z]*)$";
    String requestURI = request.getRequestURI().trim();
    Pattern p = Pattern.compile(reportsRegex);
    Matcher m = p.matcher(requestURI);
    m.matches();
    Map<String, Object> model = new HashMap<String, Object>(50);
    String extension = m.group(3);
    
    String reportId = m.group(2);
    
    String rutaCyl = request.getSession().getServletContext().getRealPath("WEB-INF/reports/centros/logocyl.png");
    String rutaIsis = request.getSession().getServletContext().getRealPath("WEB-INF/reports/centros/logoIsis.png");
    
    List<String> pathsImages = new ArrayList<String>(6);
    pathsImages.add(0, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_XuntaDeGalicia_109x34.png"));	//topLeftImage
    pathsImages.add(1, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_FondoEuropeo_109x32.png")); 	//topCenterImage 
    pathsImages.add(2, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_Amtega_109x48.png"));			//topRightImage
    pathsImages.add(3, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_Galicia_75x24.jpg"));			//bottomLeftImage
    pathsImages.add(4, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo XEA_30x20.png"));				//bottomCenterImage
    pathsImages.add(5, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_Cemit_113x15.jpg"));			//bottomRightImage
    
    model.put("idCentro", idCentro);
    model.put("fechaInicio", fechaInicioDate);
    model.put("fechaFin", fechaFinDate);
    model.put("idSeccion", idSeccion);
    model.put("idUsuarioPeticion", idUsuarioPeticion);
    model.put("idProyecto", idProyecto);
    model.put("rutaIsis", rutaIsis);
    model.put("rutaCyl", rutaCyl);
    model.put("format", extension);
    //model.put("pathsImages", pathsImages);

    // Convertir cosas como oferta-formativa a reportHelperOfertaFormativa
    // y general/oferta-formativa a reportHelperGeneralOfertaFormativa
    String reportControllerId = "reportHelper";
    StringTokenizer reportIdTokenizer = new StringTokenizer(reportId, "-_\\/");
    while (reportIdTokenizer.hasMoreTokens()) {
      String next = reportIdTokenizer.nextToken();
      reportControllerId += StringUtils.capitalize(next);
    }
    
    // Utilizar el helper para añadir parámetros propios del report
    // correspondiente
    ReportHelper helper = (ReportHelper) webApplicationContext.getBean(reportControllerId);
    Map<String, Object> model2 = helper.getReportModel(request.getRequestURI(), model);

    if (model2.get("lista") != null) {
      model.put("lista", model2.get("lista"));
    }

    model.putAll(model2);
    // Devolver el view y el modelo
    return new ModelAndView("reports/" + reportId, model);
  }
  */
  
  /**
   * Handle.
   * 
   * @param idCentro
   *           id centro
   * @param fechaInicio
   *           fecha inicio
   * @param fechaFin
   *           fecha fin
   * @param idSeccion
   *           id seccion
   * @param idUsuarioPeticion
   *           id usuario peticion
   * @param idProyecto
   *           id proyecto
   * @param request
   *           request
   * @param response
   *           response
   * @return the model and view
   */
  @RequestMapping("/reports/**")
  public void handle(@RequestParam("idCentro") String idCentro,
      @RequestParam("fechaInicio") String fechaInicio, @RequestParam("fechaFin") String fechaFin, @RequestParam("seccion") String idSeccion, 
      @RequestParam("idUsuarioPeticion") String idUsuarioPeticion, @RequestParam(required = false, value="idProyecto") String idProyecto,
      HttpServletRequest request, HttpServletResponse response) throws Exception {
    
	  SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
	  Date fechaFinDate = new Date();
	  Date fechaInicioDate = new Date();
	  
	  try {
		  fechaInicioDate = formateador.parse(fechaInicio);
		  fechaFinDate = formateador.parse(fechaFin);
	  } catch (ParseException e) {
		  e.printStackTrace();
	  }
    
	  String reportsRegex = "^(.*)/reports/([a-zA-Z-_/\\\\]*)\\.([a-zA-Z]*)$";
	  String requestURI = request.getRequestURI().trim();
	  Pattern p = Pattern.compile(reportsRegex);
	  Matcher m = p.matcher(requestURI);
	  m.matches();
    
	  Map<String, Object> model = new HashMap<String, Object>(50);
	  String extension = m.group(3);
	  String reportPath = m.group(2);
    
	  String rutaCyl = request.getSession().getServletContext().getRealPath("WEB-INF/reports/centros/logocyl.png");
	  String rutaIsis = request.getSession().getServletContext().getRealPath("WEB-INF/reports/centros/logoIsis.png");
    
	  /*List<String> pathsImages = new ArrayList<String>(6);
	  pathsImages.add(0, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_XuntaDeGalicia_109x34.png"));	//topLeftImage
	  pathsImages.add(1, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_FondoEuropeo_109x32.png")); 	//topCenterImage 
	  pathsImages.add(2, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_Amtega_109x48.png"));			//topRightImage
	  pathsImages.add(3, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_Galicia_75x24.jpg"));			//bottomLeftImage
	  pathsImages.add(4, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo XEA_30x20.png"));				//bottomCenterImage
	  pathsImages.add(5, request.getSession().getServletContext().getRealPath("WEB-INF/reports/images/Logo_Cemit_113x15.jpg"));			//bottomRightImage
      */
	  
	  model.put("idCentro", idCentro);
	  model.put("fechaInicio", fechaInicioDate);
	  model.put("fechaFin", fechaFinDate);
	  model.put("locale", LocaleContextHolder.getLocaleContext().getLocale());
	  model.put("idSeccion", idSeccion);
	  model.put("idUsuarioPeticion", idUsuarioPeticion);
	  model.put("idProyecto", idProyecto);
	  model.put("rutaIsis", rutaIsis);
	  model.put("rutaCyl", rutaCyl);
	  model.put("format", extension);
	  //model.put("pathsImages", pathsImages);

    // Convertir cosas como oferta-formativa a reportHelperOfertaFormativa
    // y general/oferta-formativa a reportHelperGeneralOfertaFormativa
    String reportControllerId = "reportHelper";
    StringTokenizer reportIdTokenizer = new StringTokenizer(reportPath, "-_\\/");
    
    while (reportIdTokenizer.hasMoreTokens()) {
      String next = reportIdTokenizer.nextToken();
      reportControllerId += StringUtils.capitalize(next);
    }
    
    //Asigna un id al informe
    Long idReport = new Date().getTime();
    
    //Crea el objeto con los datos necesarios para la generación del informe
    ReportComputation reportComputation = new ReportComputation(idReport, request.getRequestURI(), reportPath, model);
    
    //Busca el helper del informe y trae el bean
    ServletContext servletContext = request.getSession().getServletContext();
    WebApplicationContext webApplicationContext = RequestContextUtils.getWebApplicationContext(request, servletContext);
    ReportHelper helper = (ReportHelper) webApplicationContext.getBean(reportControllerId);
    
    //Crea y lanza el thread para la computación del informe
    ReportComputationThread reportComputationThread = new ReportComputationThread(reportComputation, helper);
    reportComputation.setThread(reportComputationThread);
    
    synchronized (results) {
    	results.put(reportComputation.getIdReport(), reportComputation);
    }
    
    reportComputationThread.start();
    
    //Redirige a la página de espera y comprobación que informa del procesamiento
    response.sendRedirect(request.getContextPath() + "/spring/informes/procesando?idReport=" + idReport);
  }
  
  private static class ReportComputationThread extends Thread {
	    private ReportComputation reportComputation;
	    private ReportHelper helper;
	 
	    public ReportComputationThread(ReportComputation reportComputation, ReportHelper helper) {
	        this.reportComputation = reportComputation;
	        this.helper = helper;
	    }

	    @Override
	    public void run() {
	    	Map<String, Object> resultModel = null;
	    	
	    	try {
	    		// Utilizar el helper para añadir parámetros propios del report correspondiente
	    		resultModel = helper.getReportModel(reportComputation.getRequestURI(), reportComputation.getModel());
	    	}
	    	catch (Exception e) {
	    		e.printStackTrace();
	    	}
	        
	    	if (resultModel != null) {
	    		reportComputation.getModel().putAll(resultModel);
	    		reportComputation.getModel().remove("locale");
	    	}
	    	else {
	    		reportComputation.getModel().clear();
	    	}
	    	
    		reportComputation.setFinishTimestamp(new Date().getTime());

    		/*synchronized (results) {
    			results.put(reportComputation.getIdReport(), reportComputation);
    		}*/
        
    		//Mientras no se consuma y no hallan pasado 10 minutos desde la generación sin consumirse...
    		while (!reportComputation.isConsumed() && ((new Date().getTime() - reportComputation.getFinishTimestamp()) < 600000L)) {
				synchronized (this) {
					try {
						this.wait(30000L);
					} catch (Exception e) {
	    				e.printStackTrace();
	    			}
				}
    		}

			// Una vez consumido o habiendo pasado 10 minutos sin consumir lo eliminamos de los resultados
    		synchronized (results) {
    			results.remove(reportComputation.getIdReport());
    		}
	    }
	}
  
  @RequestMapping("/isReportGenerated")
  @Transactional(readOnly = true)
  public void isReportGenerated(@RequestParam("idReport") String idReport, HttpServletRequest request, HttpServletResponse response) throws Exception {
	  /*
	  if ((idReport == null) || idReport.isEmpty()) {
		  response.sendRedirect(request.getContextPath());
	  }
	  else {
		  if (results.get(Long.parseLong(idReport)) != null)
			  response.sendRedirect(request.getContextPath() + "/spring/getReport?idReport=" + idReport);
		  else
			  response.sendRedirect(request.getContextPath() + "/spring/informes/procesando?idReport=" + idReport);
	  }
	  */
	  
	  ReportComputation rc = null;
	  
	  if ((idReport == null) || idReport.isEmpty() || ((rc = results.get(Long.parseLong(idReport))) == null))
		  response.sendRedirect(request.getContextPath());
	  else {
		  if (rc.getFinishTimestamp() > -1L)
		  	  response.sendRedirect(request.getContextPath() + "/spring/getReport?idReport=" + idReport);
		  else
			  response.sendRedirect(request.getContextPath() + "/spring/informes/procesando?idReport=" + idReport);
	  }
  }
  
  @RequestMapping("/getReport")
  @Transactional(readOnly = true)
  public ModelAndView getReport(@RequestParam("idReport") String idReport, HttpServletRequest request, HttpServletResponse response) throws Exception {
	  if ((idReport == null) || idReport.isEmpty()) {
		  response.sendRedirect(request.getContextPath());
		  
		  return null;
	  }
	  else {
		  ReportComputation reportComputation = results.get(Long.parseLong(idReport));
		  
		  if (reportComputation != null) {
			  if (reportComputation.getModel().size() > 0) {
				  ModelAndView mv = null;
				  
				  if (reportComputation != null) {
					  mv = new ModelAndView("reports/" + reportComputation.getReportPath(), reportComputation.getModel());
				  
					  reportComputation.setToConsumed();
					  
					  synchronized (reportComputation.getThread()) {
						  reportComputation.getThread().notify();
					  }
				  }
				  
				  return mv;
			  }
			  //Error en la generación del informe
			  else {
				  response.sendRedirect(request.getContextPath() + "/spring/informes/errorInforme");
				  
				  return null;
			  }
		  }
		  else {
			  response.sendRedirect(request.getContextPath());
			  
			  return null;
		  }
	  }
  }
}
