package es.csa.fdt.cyldigital.indicadores.centros;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.text.SimpleDateFormat;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import es.csa.fdt.cyldigital.centros.entity.Centro;
import es.csa.fdt.cyldigital.centros.service.CentroService;
import es.csa.fdt.cyldigital.indicadores.ReportHelper;
import es.csa.fdt.cyldigital.usuarios.entity.UsuarioCyL;
import es.csa.fdt.cyldigital.usuarios.service.UsuarioService;

/**
 * Clase ReportHelperCentros.
 */
@Component("reportHelperCentrosCentros")
public class ReportHelperCentros implements ReportHelper {
  /** servicio. */
  /*******************
  @Autowired
  public UsuarioService servicio;
  */

  /** servicio2. */
  /********************
  @Autowired
  public CentroService servicio2;
  */

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.indicadores.ReportHelper#getReportModel(java.lang.String, java.util.Map)
   */
  /***************************
  @Override
  @Transactional(readOnly = true)
  public Map<String, Object> getReportModel(String string, Map<String, Object> params) {
    Map<String, Object> map = new HashMap<String, Object>();
    List<UsuarioCyL> usuarios = servicio.findAll();
    List<UsuarioCyL> finales = new ArrayList<UsuarioCyL>();
    String pathCyl = (String) (params.get("rutaCyl"));
    String pathIsis = (String) (params.get("rutaIsis"));
    Centro centro = new Centro();
    Integer capital = 0, provincia = 0, burgos = 0, zamora = 0, provinciaBurgos = 0, provinciaZamora = 0, sinprovincia = 0, otraprovincia = 0;
    Long id;

    if ((params.get("idCentro")).toString() != "") {
      id = Long.parseLong((params.get("idCentro")).toString());
    } else {
      id = Long.parseLong("0");
    }
    // SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy");
    Date fechaInicio = new Date();
    Date fechaFin = new Date();

    fechaInicio = (Date) params.get("fechaInicio");
    fechaFin = (Date) params.get("fechaFin");
    Calendar c = new GregorianCalendar();
    c.setTime(fechaFin);
    c.add(Calendar.HOUR, 23);
    c.add(Calendar.MINUTE, 59);
    fechaFin = c.getTime();

    if (id != 0) {
      Iterator<UsuarioCyL> itr = usuarios.iterator();
      while (itr.hasNext()) {
        UsuarioCyL usuario = new UsuarioCyL();
        usuario = itr.next();
        if (usuario.getCentro() != null) {
          if (usuario.getFechaCreacion().compareTo(fechaInicio) >= 0
              && usuario.getFechaCreacion().compareTo(fechaFin) <= 0) {

            centro = usuario.getCentro();

            if (usuario.getCentro().getId() == id) {
              if (usuario.getProvincia() != null) {
                if ((usuario.getProvincia().getCodigo_provincia()) == 9) {
                  if (usuario.getLocalidad() == null || usuario.getLocalidad().getId() == 4619) {
                    burgos++;
                    capital++;
                  } else {
                    provinciaBurgos++;
                    provincia++;
                  }
                } else if ((usuario.getProvincia().getCodigo_provincia()) == 49) {
                  if (usuario.getLocalidad() == null || usuario.getLocalidad().getId() == 45606
                      || usuario.getLocalidad().getId() == 54181) {
                    zamora++;
                    capital++;
                  } else {
                    provinciaZamora++;
                    provincia++;
                  }
                } else if (usuario.getProvincia().getCodigo_provincia() == 24) {
                  if(usuario.getLocalidad() ==null || usuario.getLocalidad().getId() == 25942){
                    capital++;
                  } else{
                    provincia ++;
                  }
                
                }else{
                  otraprovincia++;
                }
              } else {
                sinprovincia++;
              }
              finales.add(usuario);
            }
          }

        }
      }

    } else {
      centro.setNombre("Todos los centros");
      Iterator<UsuarioCyL> itr = usuarios.iterator();
      while (itr.hasNext()) {
        UsuarioCyL usuario = new UsuarioCyL();
        usuario = itr.next();
        if (usuario.getFechaCreacion().compareTo(fechaInicio) > 0 && usuario.getFechaCreacion().compareTo(fechaFin) < 0) {
          if (usuario.getProvincia() != null) {
            if ((usuario.getProvincia().getCodigo_provincia()) == 9) {
              if (usuario.getLocalidad() == null || usuario.getLocalidad().getId() == 4619) {
                burgos++;
                capital++;
              } else {
                provinciaBurgos++;
                provincia++;
              }
            } else if ((usuario.getProvincia().getCodigo_provincia()) == 49) {
              if (usuario.getLocalidad() == null || usuario.getLocalidad().getId() == 45606
                  || usuario.getLocalidad().getId() == 54181) {
                zamora++;
                capital++;
              } else {
                provinciaZamora++;
                provincia++;
              }
            }else if (usuario.getProvincia().getCodigo_provincia() == 24) {
              if(usuario.getLocalidad() ==null || usuario.getLocalidad().getId() == 25942){
                capital++;
              } else{
                provincia ++;
              }
            }else {
              otraprovincia++;
            }
          } else {
            sinprovincia++;
          }
          finales.add(usuario);
        }
      }
    }

    if (id != 0)
    	centro = servicio2.find(id);

    map.put("data", finales);
    map.put("title", "Informe de altas de usuarios.");
    map.put("total", finales.size());
    map.put("nombreCentro", centro.getNombre());
    
    if (finales.size() != 0) {
    	if (id != 0) {
			map.put("provinciaCentro", centro.getProvincia().getNombre());
			map.put("localidadCentro", centro.getLocalidad().getNombre());
			map.put("direccionCentro", centro.getDireccion());
			map.put("telefonoCentro", centro.getTelefono());
			map.put("faxCentro", centro.getFax());
			map.put("emailCentro", centro.getEmail());
    	}
    }

    map.put("fechaInicio", fechaInicio);
    map.put("fechaFin", fechaFin);
    map.put("pathCyl", pathCyl);
    map.put("pathIsis", pathIsis);
    */
    
    /*
    map.put("capital", capital);
    map.put("provincia", provincia);
    map.put("burgos", burgos);
    map.put("provinciaBurgos", provinciaBurgos);
    map.put("zamora", zamora);
    map.put("provinciaZamora", provinciaZamora);
    map.put("sinprovincia", sinprovincia);
    map.put("otraprovincia", otraprovincia);
    */

  /******************************
    return map;
  }*/
  
  
  
  /** usuarioService. */
  @Autowired
  public UsuarioService usuarioService;

  /** centroService. */
  @Autowired
  public CentroService centroService;

  /* (non-Javadoc)
   * @see es.fdt.isis.indicadores.ReportHelper#getReportModel(java.lang.String, java.util.Map)
   */
  @Override
  @Transactional(readOnly = true)
  public Map<String, Object> getReportModel(String string, Map<String, Object> params) {
    Map<String, Object> map = new HashMap<String, Object>();
    
    String pathCyl = (String) (params.get("rutaCyl"));
    String pathIsis = (String) (params.get("rutaIsis"));
    
    Long idCentro;
    if ((params.get("idCentro")).toString() != "")
    	idCentro = Long.parseLong((params.get("idCentro")).toString());
    else
    	idCentro = Long.parseLong("0");

    Date fechaInicio = (Date) params.get("fechaInicio");
    Date fechaFin = (Date) params.get("fechaFin");

    Calendar c = new GregorianCalendar();
    c.setTime(fechaFin);
    c.add(Calendar.HOUR, 23);
    c.add(Calendar.MINUTE, 59);
    c.add(Calendar.SECOND, 59);
    fechaFin = c.getTime();

    List<UsuarioCyL> usuarios;
    
    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
    String strqry;
    if (idCentro != 0) {
    	strqry = "SELECT ucyl " + 
    			 "FROM " + UsuarioCyL.class.getName() + " ucyl " +
    			 "WHERE (ucyl.desactivado = FALSE) AND " +
    			 	   "(ucyl.centro.id = " + idCentro + ") AND " + 
    			 	   "(ucyl.fechaCreacion BETWEEN '" + dateFormat.format(fechaInicio) + "' AND " +
    			 	   							   "'" + dateFormat.format(fechaFin)    + "')";
    }
    else {
    	strqry = "SELECT ucyl " + 
    			 "FROM " + UsuarioCyL.class.getName() + " ucyl " +
    			 "WHERE (ucyl.desactivado = FALSE) AND " +
    			 	   "(ucyl.fechaCreacion BETWEEN '" + dateFormat.format(fechaInicio) + "' AND " +
    			 								   "'" + dateFormat.format(fechaFin)    + "')";
    }

    usuarios = usuarioService.findByQuery(strqry);

    map.put("title", "Informe de altas de usuarios.");
    map.put("data", usuarios);
    map.put("total", usuarios.size());
    
    if (idCentro != 0) {
    	Centro centro = centroService.find(idCentro);

    	map.put("nombreCentro", centro.getNombre());
		map.put("provinciaCentro", centro.getProvincia().getNombre());
		map.put("localidadCentro", centro.getLocalidad().getNombre());
		map.put("direccionCentro", centro.getDireccion());
		map.put("telefonoCentro", centro.getTelefono());
		map.put("faxCentro", centro.getFax());
		map.put("emailCentro", centro.getEmail());
	}
    else
    	map.put("nombreCentro", "N/A");

    map.put("fechaInicio", fechaInicio);
    map.put("fechaFin", fechaFin);
    map.put("pathCyl", pathCyl);
    map.put("pathIsis", pathIsis);
    
    return map;
  }
}
