package es.csa.fdt.cyldigital.indicadores.financiero;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import es.csa.fdt.cyldigital.financiero.entity.Contenedor;
import es.csa.fdt.cyldigital.financiero.service.FacturaService;
import es.csa.fdt.cyldigital.financiero.service.SeccionService;
import es.csa.fdt.cyldigital.indicadores.ReportHelper;

/**
 * Clase ReportHelperFacturas.
 */
@Component("reportHelperFinancieroFacturas")
public class ReportHelperFacturas implements ReportHelper {

  /** servicio. */
  @Autowired
  public FacturaService servicio;
  
  /** service. */
  @Autowired
  public SeccionService service;

  /* (non-Javadoc)
   * @see es.csa.fdt.cyldigital.indicadores.ReportHelper#getReportModel(java.lang.String, java.util.Map)
   */
  @Override
  public Map<String, Object> getReportModel(String string, Map<String, Object> params) {
    Map<String, Object> map = new HashMap<String, Object>();
    List<Contenedor> contenedores = new ArrayList<Contenedor>();
    
    String pathCyl = (String) (params.get("rutaCyl"));
    String pathIsis = (String) (params.get("rutaIsis"));
    String idSeccion = (String) (params.get("idSeccion"));
    Long seccion = Long.parseLong(idSeccion);

    Contenedor contenedor = service.find(Contenedor.class, seccion);
    String subtitle = contenedor.getNombre();
    contenedores.add(contenedor);
    
    if(contenedor.getContenedorProyectoGeneral() == null){
       for(Contenedor contenedorSubproyecto : contenedor.getContenedoresSubproyectos()){
         contenedores.add(contenedorSubproyecto);
       }
       //subtitle = "Centros CyL Digital";
    }else{
      //subtitle = "Centro CyL Digital de ".concat(contenedor.getProyecto().getCentro().getNombre());
    }
    
    
    map.put("data", contenedores);
    map.put("title", "Informe financiero de elemento");
    map.put("subtitle", subtitle);
    map.put("pathCyl", pathCyl);
    map.put("pathIsis", pathIsis);


    return map;
  }

}
