package es.csa.fdt.cyldigital.listings;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2015  Xunta de Galicia <oficinacemit@xunta.es>
 * %%
 * This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Balidea <info@balidea.com>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */

import java.util.Comparator;
import java.util.Date;

/**
 * 
 * @author balidea
 *
 */
public class ListingHelperArrayObjectComparator implements Comparator<Object[]>{

	private int columnIndex = 0;
	
	public ListingHelperArrayObjectComparator(int pColumnIndex){
		columnIndex = pColumnIndex;
	}
	
	@Override
	public int compare(Object[] o1, Object[] o2) {
		Object dato1 =  o1[columnIndex];
		Object dato2 =  o2[columnIndex];
	 	
		if(dato1 != null && dato2 != null){
			if (dato1 instanceof Enum){
				return (((Enum)dato1).name()).compareTo(((Enum)dato2).name());
			} 
			else if (dato1 instanceof Number){
				//Comparacion de numeros Integer, Long, Float, Double
				//(Java 6 no carece del metodo compare para los tipos Integer y Long)
				float floatDato1 = ((Number)dato1).floatValue();
				float floatDato2 = ((Number)dato2).floatValue();
				return Float.compare(Float.valueOf(floatDato1), Float.valueOf(floatDato2));
			}
			else if (dato1 instanceof String){
				return ((String)dato1).compareTo((String)dato2);
			}
			else if (dato1 instanceof Date){
				return ((Date)dato1).compareTo((Date)dato2);
			}
		}

		return 0;
	}

}
