package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Float;
import java.lang.Long;

public class Activities {
	private Long numeroCursos;
	private Long numeroCharlas;
	private Long numeroExternasCA;
	private Long numeroExternasCS;
	private Long numeroExternasCAyS;
	
	private Float numeroHorasAA;
	private Float numeroHorasCursos;
	private Float numeroHorasCharlas;
	private Float numeroHorasExternasCA;
	private Float numeroHorasExternasCS;
	private Float numeroHorasExternasCAyS;
	
	private Float numeroHorasOfertadasCursos;
	private Float numeroHorasOfertadasCharlas;
	private Float numeroHorasOfertadasExternasCA;
	private Float numeroHorasOfertadasExternasCS;
	private Float numeroHorasOfertadasExternasCAyS;
	
	private Float numeroHorasCubiertasCursos;
	private Float numeroHorasCubiertasCharlas;
	private Float numeroHorasCubiertasExternasCA;
	private Float numeroHorasCubiertasExternasCS;
	private Float numeroHorasCubiertasExternasCAyS;
	
	private Float numeroHorasTerminadasCursos;
	private Float numeroHorasTerminadasCharlas;
	private Float numeroHorasTerminadasExternasCA;
	private Float numeroHorasTerminadasExternasCS;
	private Float numeroHorasTerminadasExternasCAyS;
	
	private Long numeroPlazasOfertadasCursos;
	private Long numeroPlazasOfertadasCharlas;
	private Long numeroPlazasOfertadasExternasCA;
	private Long numeroPlazasOfertadasExternasCS;
	private Long numeroPlazasOfertadasExternasCAyS;
	
	private Long numeroPlazasCubiertasCursos;
	private Long numeroPlazasCubiertasCharlas;
	private Long numeroPlazasCubiertasExternasCA;
	private Long numeroPlazasCubiertasExternasCS;
	private Long numeroPlazasCubiertasExternasCAyS;
	
	private Long numeroPlazasTerminadasCursos;
	private Long numeroPlazasTerminadasCharlas;
	private Long numeroPlazasTerminadasExternasCA;
	private Long numeroPlazasTerminadasExternasCS;
	private Long numeroPlazasTerminadasExternasCAyS;
	
	public Activities() {
		this.setNumeroCursos(Long.valueOf(-1L));
		this.setNumeroCharlas(Long.valueOf(-1L));
		this.setNumeroExternasCA(Long.valueOf(-1L));
		this.setNumeroExternasCS(Long.valueOf(-1L));
		this.setNumeroExternasCAyS(Long.valueOf(-1L));

		this.setNumeroHorasAA(-1.0F);
		this.setNumeroHorasCursos(-1.0F);
		this.setNumeroHorasCharlas(-1.0F);
		this.setNumeroHorasExternasCA(-1.0F);
		this.setNumeroHorasExternasCS(-1.0F);
		this.setNumeroHorasExternasCAyS(-1.0F);
		
		this.setNumeroHorasTerminadasCursos(-1.0F);
		this.setNumeroHorasTerminadasCharlas(-1.0F);
		
		this.setNumeroPlazasOfertadasCursos(Long.valueOf(-1L));
		this.setNumeroPlazasOfertadasCharlas(Long.valueOf(-1L));
		this.setNumeroPlazasOfertadasExternasCA(Long.valueOf(-1L));
		this.setNumeroPlazasOfertadasExternasCS(Long.valueOf(-1L));
		this.setNumeroPlazasOfertadasExternasCAyS(Long.valueOf(-1L));
		
		this.setNumeroPlazasCubiertasCursos(Long.valueOf(-1L));
		this.setNumeroPlazasCubiertasCharlas(Long.valueOf(-1L));

		this.setNumeroPlazasTerminadasCursos(Long.valueOf(-1L));
		this.setNumeroPlazasTerminadasCharlas(Long.valueOf(-1L));
		this.setNumeroPlazasTerminadasExternasCA(Long.valueOf(-1L));
		this.setNumeroPlazasTerminadasExternasCS(Long.valueOf(-1L));
		this.setNumeroPlazasTerminadasExternasCAyS(Long.valueOf(-1L));		
	}

	/**
	 * @return the numeroCursos
	 */
	public Long getNumeroCursos() {
		return numeroCursos;
	}

	/**
	 * @param numeroCursos the numeroCursos to set
	 */
	public void setNumeroCursos(Long numeroCursos) {
		this.numeroCursos = numeroCursos;
	}

	/**
	 * @return the numeroCharlas
	 */
	public Long getNumeroCharlas() {
		return numeroCharlas;
	}

	/**
	 * @param numeroCharlas the numeroCharlas to set
	 */
	public void setNumeroCharlas(Long numeroCharlas) {
		this.numeroCharlas = numeroCharlas;
	}

	/**
	 * @return the numeroExternasCA
	 */
	public Long getNumeroExternasCA() {
		return numeroExternasCA;
	}

	/**
	 * @param numeroExternasCA the numeroExternasCA to set
	 */
	public void setNumeroExternasCA(Long numeroExternasCA) {
		this.numeroExternasCA = numeroExternasCA;
	}

	/**
	 * @return the numeroExternasCS
	 */
	public Long getNumeroExternasCS() {
		return numeroExternasCS;
	}

	/**
	 * @param numeroExternasCS the numeroExternasCS to set
	 */
	public void setNumeroExternasCS(Long numeroExternasCS) {
		this.numeroExternasCS = numeroExternasCS;
	}

	/**
	 * @return the numeroExternasCAyS
	 */
	public Long getNumeroExternasCAyS() {
		return numeroExternasCAyS;
	}

	/**
	 * @param numeroExternasCAyS the numeroExternasCAyS to set
	 */
	public void setNumeroExternasCAyS(Long numeroExternasCAyS) {
		this.numeroExternasCAyS = numeroExternasCAyS;
	}
	
	/**
	 * @return the numeroHorasAA
	 */
	public Float getNumeroHorasAA() {
		return numeroHorasAA;
	}

	/**
	 * @param numeroHorasAA the numeroHorasAA to set
	 */
	public void setNumeroHorasAA(Float numeroHorasAA) {
		this.numeroHorasAA = numeroHorasAA;
	}

	/**
	 * @return the numeroHorasCursos
	 */
	public Float getNumeroHorasCursos() {
		return numeroHorasCursos;
	}

	/**
	 * @param numeroHorasCursos the numeroHorasCursos to set
	 */
	public void setNumeroHorasCursos(Float numeroHorasCursos) {
		this.numeroHorasCursos = numeroHorasCursos;
	}

	/**
	 * @return the numeroHorasCharlas
	 */
	public Float getNumeroHorasCharlas() {
		return numeroHorasCharlas;
	}

	/**
	 * @param numeroHorasCharlas the numeroHorasCharlas to set
	 */
	public void setNumeroHorasCharlas(Float numeroHorasCharlas) {
		this.numeroHorasCharlas = numeroHorasCharlas;
	}

	/**
	 * @return the numeroHorasExternasCA
	 */
	public Float getNumeroHorasExternasCA() {
		return numeroHorasExternasCA;
	}

	/**
	 * @param numeroHorasExternasCA the numeroHorasExternasCA to set
	 */
	public void setNumeroHorasExternasCA(Float numeroHorasExternasCA) {
		this.numeroHorasExternasCA = numeroHorasExternasCA;
	}

	/**
	 * @return the numeroHorasExternasCS
	 */
	public Float getNumeroHorasExternasCS() {
		return numeroHorasExternasCS;
	}

	/**
	 * @param numeroHorasExternasCS the numeroHorasExternasCS to set
	 */
	public void setNumeroHorasExternasCS(Float numeroHorasExternasCS) {
		this.numeroHorasExternasCS = numeroHorasExternasCS;
	}

	/**
	 * @return the numeroHorasExternasCAyS
	 */
	public Float getNumeroHorasExternasCAyS() {
		return numeroHorasExternasCAyS;
	}

	/**
	 * @param numeroHorasExternasCAyS the numeroHorasExternasCAyS to set
	 */
	public void setNumeroHorasExternasCAyS(Float numeroHorasExternasCAyS) {
		this.numeroHorasExternasCAyS = numeroHorasExternasCAyS;
	}

	/**
	 * @return the numeroHorasOfertadasCursos
	 */
	public Float getNumeroHorasOfertadasCursos() {
		setNumeroHorasOfertadasCursos(getNumeroHorasCursos() * getNumeroPlazasOfertadasCursos());
		
		return numeroHorasOfertadasCursos;
	}

	/**
	 * @param numeroHorasOfertadasCursos the numeroHorasOfertadasCursos to set
	 */
	private void setNumeroHorasOfertadasCursos(Float numeroHorasOfertadasCursos) {
		this.numeroHorasOfertadasCursos = numeroHorasOfertadasCursos;
	}

	/**
	 * @return the numeroHorasOfertadasCharlas
	 */
	public Float getNumeroHorasOfertadasCharlas() {
		setNumeroHorasOfertadasCharlas(getNumeroHorasCharlas() * getNumeroPlazasOfertadasCharlas());
		
		return numeroHorasOfertadasCharlas;
	}

	/**
	 * @param numeroHorasOfertadasCharlas the numeroHorasOfertadasCharlas to set
	 */
	private void setNumeroHorasOfertadasCharlas(Float numeroHorasOfertadasCharlas) {
		this.numeroHorasOfertadasCharlas = numeroHorasOfertadasCharlas;
	}

	/**
	 * @return the numeroHorasOfertadasExternasCA
	 */
	public Float getNumeroHorasOfertadasExternasCA() {
		setNumeroHorasOfertadasExternasCA(getNumeroHorasExternasCA() * getNumeroPlazasOfertadasExternasCA());
		
		return numeroHorasOfertadasExternasCA;
	}

	/**
	 * @param numeroHorasOfertadasExternasCA the numeroHorasOfertadasExternasCA to set
	 */
	private void setNumeroHorasOfertadasExternasCA(Float numeroHorasOfertadasExternasCA) {
		this.numeroHorasOfertadasExternasCA = numeroHorasOfertadasExternasCA;
	}

	/**
	 * @return the numeroHorasOfertadasExternasCS
	 */
	public Float getNumeroHorasOfertadasExternasCS() {
		setNumeroHorasOfertadasExternasCS(getNumeroHorasExternasCS() * getNumeroPlazasOfertadasExternasCS());
		
		return numeroHorasOfertadasExternasCS;
	}

	/**
	 * @param numeroHorasOfertadasExternasCS the numeroHorasOfertadasExternasCS to set
	 */
	private void setNumeroHorasOfertadasExternasCS(Float numeroHorasOfertadasExternasCS) {
		this.numeroHorasOfertadasExternasCS = numeroHorasOfertadasExternasCS;
	}

	/**
	 * @return the numeroHorasOfertadasExternasCAyS
	 */
	public Float getNumeroHorasOfertadasExternasCAyS() {
		setNumeroHorasOfertadasExternasCAyS(getNumeroHorasExternasCAyS() * getNumeroPlazasOfertadasExternasCAyS());

		return numeroHorasOfertadasExternasCAyS;
	}

	/**
	 * @param numeroHorasOfertadasExternasCAyS the numeroHorasOfertadasExternasCAyS to set
	 */
	private void setNumeroHorasOfertadasExternasCAyS(Float numeroHorasOfertadasExternasCAyS) {
		this.numeroHorasOfertadasExternasCAyS = numeroHorasOfertadasExternasCAyS;
	}

	/**
	 * @return the numeroHorasCubiertasCursos
	 */
	public Float getNumeroHorasCubiertasCursos() {
		setNumeroHorasCubiertasCursos(getNumeroHorasCursos() * getNumeroPlazasCubiertasCursos());
		
		return numeroHorasCubiertasCursos;
	}

	/**
	 * @param numeroHorasCubiertasCursos the numeroHorasCubiertasCursos to set
	 */
	private void setNumeroHorasCubiertasCursos(Float numeroHorasCubiertasCursos) {
		this.numeroHorasCubiertasCursos = numeroHorasCubiertasCursos;
	}

	/**
	 * @return the numeroHorasCubiertasCharlas
	 */
	public Float getNumeroHorasCubiertasCharlas() {
		setNumeroHorasCubiertasCharlas(getNumeroHorasCharlas() * getNumeroPlazasCubiertasCharlas());
		
		return numeroHorasCubiertasCharlas;
	}

	/**
	 * @param numeroHorasCubiertasCharlas the numeroHorasCubiertasCharlas to set
	 */
	private void setNumeroHorasCubiertasCharlas(Float numeroHorasCubiertasCharlas) {
		this.numeroHorasCubiertasCharlas = numeroHorasCubiertasCharlas;
	}

	/**
	 * @return the numeroHorasCubiertasExternasCA
	 */
	public Float getNumeroHorasCubiertasExternasCA() {
		setNumeroHorasCubiertasExternasCA(getNumeroHorasExternasCA() * getNumeroPlazasCubiertasExternasCA());
		
		return numeroHorasCubiertasExternasCA;
	}

	/**
	 * @param numeroHorasCubiertasExternasCA the numeroHorasCubiertasExternasCA to set
	 */
	private void setNumeroHorasCubiertasExternasCA(Float numeroHorasCubiertasExternasCA) {
		this.numeroHorasCubiertasExternasCA = numeroHorasCubiertasExternasCA;
	}

	/**
	 * @return the numeroHorasCubiertasExternasCS
	 */
	public Float getNumeroHorasCubiertasExternasCS() {
		setNumeroHorasCubiertasExternasCS(getNumeroHorasExternasCS() * getNumeroPlazasCubiertasExternasCS());
		
		return numeroHorasCubiertasExternasCS;
	}

	/**
	 * @param numeroHorasCubiertasExternasCS the numeroHorasCubiertasExternasCS to set
	 */
	private void setNumeroHorasCubiertasExternasCS(Float numeroHorasCubiertasExternasCS) {
		this.numeroHorasCubiertasExternasCS = numeroHorasCubiertasExternasCS;
	}

	/**
	 * @return the numeroHorasCubiertasExternasCAyS
	 */
	public Float getNumeroHorasCubiertasExternasCAyS() {
		setNumeroHorasCubiertasExternasCAyS(getNumeroHorasExternasCAyS() * getNumeroPlazasCubiertasExternasCAyS());
		
		return numeroHorasCubiertasExternasCAyS;
	}

	/**
	 * @param numeroHorasCubiertasExternasCAyS the numeroHorasCubiertasExternasCAyS to set
	 */
	private void setNumeroHorasCubiertasExternasCAyS(Float numeroHorasCubiertasExternasCAyS) {
		this.numeroHorasCubiertasExternasCAyS = numeroHorasCubiertasExternasCAyS;
	}

	/**
	 * @return the numeroHorasTerminadasCursos
	 */
	public Float getNumeroHorasTerminadasCursos() {
		return numeroHorasTerminadasCursos;
	}

	/**
	 * @param numeroHorasTerminadasCursos the numeroHorasTerminadasCursos to set
	 */
	public void setNumeroHorasTerminadasCursos(Float numeroHorasTerminadasCursos) {
		this.numeroHorasTerminadasCursos = numeroHorasTerminadasCursos;
	}

	/**
	 * @return the numeroHorasTerminadasCharlas
	 */
	public Float getNumeroHorasTerminadasCharlas() {
		return numeroHorasTerminadasCharlas;
	}

	/**
	 * @param numeroHorasTerminadasCharlas the numeroHorasTerminadasCharlas to set
	 */
	public void setNumeroHorasTerminadasCharlas(Float numeroHorasTerminadasCharlas) {
		this.numeroHorasTerminadasCharlas = numeroHorasTerminadasCharlas;
	}

	/**
	 * @return the numeroHorasTerminadasExternasCA
	 */
	public Float getNumeroHorasTerminadasExternasCA() {
		setNumeroHorasTerminadasExternasCA(getNumeroHorasExternasCA() * getNumeroPlazasTerminadasExternasCA());
		
		return numeroHorasTerminadasExternasCA;
	}

	/**
	 * @param numeroHorasTerminadasExternasCA the numeroHorasTerminadasExternasCA to set
	 */
	private void setNumeroHorasTerminadasExternasCA(Float numeroHorasTerminadasExternasCA) {
		this.numeroHorasTerminadasExternasCA = numeroHorasTerminadasExternasCA;
	}

	/**
	 * @return the numeroHorasTerminadasExternasCS
	 */
	public Float getNumeroHorasTerminadasExternasCS() {
		setNumeroHorasTerminadasExternasCS(getNumeroHorasExternasCS() * getNumeroPlazasTerminadasExternasCS());
		
		return numeroHorasTerminadasExternasCS;
	}

	/**
	 * @param numeroHorasTerminadasExternasCS the numeroHorasTerminadasExternasCS to set
	 */
	private void setNumeroHorasTerminadasExternasCS(Float numeroHorasTerminadasExternasCS) {
		this.numeroHorasTerminadasExternasCS = numeroHorasTerminadasExternasCS;
	}

	/**
	 * @return the numeroHorasTerminadasExternasCAyS
	 */
	public Float getNumeroHorasTerminadasExternasCAyS() {
		setNumeroHorasTerminadasExternasCAyS(getNumeroHorasExternasCAyS() * getNumeroPlazasTerminadasExternasCAyS());
		
		return numeroHorasTerminadasExternasCAyS;
	}

	/**
	 * @param numeroHorasTerminadasExternasCAyS the numeroHorasTerminadasExternasCAyS to set
	 */
	private void setNumeroHorasTerminadasExternasCAyS(Float numeroHorasTerminadasExternasCAyS) {
		this.numeroHorasTerminadasExternasCAyS = numeroHorasTerminadasExternasCAyS;
	}

	/**
	 * @return the numeroPlazasOfertadasCursos
	 */
	public Long getNumeroPlazasOfertadasCursos() {
		return numeroPlazasOfertadasCursos;
	}

	/**
	 * @param numeroPlazasOfertadasCursos the numeroPlazasOfertadasCursos to set
	 */
	public void setNumeroPlazasOfertadasCursos(Long numeroPlazasOfertadasCursos) {
		this.numeroPlazasOfertadasCursos = numeroPlazasOfertadasCursos;
	}

	/**
	 * @return the numeroPlazasOfertadasCharlas
	 */
	public Long getNumeroPlazasOfertadasCharlas() {
		return numeroPlazasOfertadasCharlas;
	}

	/**
	 * @param numeroPlazasOfertadasCharlas the numeroPlazasOfertadasCharlas to set
	 */
	public void setNumeroPlazasOfertadasCharlas(Long numeroPlazasOfertadasCharlas) {
		this.numeroPlazasOfertadasCharlas = numeroPlazasOfertadasCharlas;
	}

	/**
	 * @return the numeroPlazasOfertadasExternasCA
	 */
	public Long getNumeroPlazasOfertadasExternasCA() {
		return numeroPlazasOfertadasExternasCA;
	}

	/**
	 * @param numeroPlazasOfertadasExternasCA the numeroPlazasOfertadasExternasCA to set
	 */
	public void setNumeroPlazasOfertadasExternasCA(Long numeroPlazasOfertadasExternasCA) {
		this.numeroPlazasOfertadasExternasCA = numeroPlazasOfertadasExternasCA;
	}

	/**
	 * @return the numeroPlazasOfertadasExternasCS
	 */
	public Long getNumeroPlazasOfertadasExternasCS() {
		return numeroPlazasOfertadasExternasCS;
	}

	/**
	 * @param numeroPlazasOfertadasExternasCS the numeroPlazasOfertadasExternasCS to set
	 */
	public void setNumeroPlazasOfertadasExternasCS(Long numeroPlazasOfertadasExternasCS) {
		this.numeroPlazasOfertadasExternasCS = numeroPlazasOfertadasExternasCS;
	}

	/**
	 * @return the numeroPlazasOfertadasExternasCAyS
	 */
	public Long getNumeroPlazasOfertadasExternasCAyS() {
		return numeroPlazasOfertadasExternasCAyS;
	}

	/**
	 * @param numeroPlazasOfertadasExternasCAyS the numeroPlazasOfertadasExternasCAyS to set
	 */
	public void setNumeroPlazasOfertadasExternasCAyS(Long numeroPlazasOfertadasExternasCAyS) {
		this.numeroPlazasOfertadasExternasCAyS = numeroPlazasOfertadasExternasCAyS;
	}

	/**
	 * @return the numeroPlazasCubiertasCursos
	 */
	public Long getNumeroPlazasCubiertasCursos() {
		return numeroPlazasCubiertasCursos;
	}

	/**
	 * @param numeroPlazasCubiertasCursos the numeroPlazasCubiertasCursos to set
	 */
	public void setNumeroPlazasCubiertasCursos(Long numeroPlazasCubiertasCursos) {
		this.numeroPlazasCubiertasCursos = numeroPlazasCubiertasCursos;
	}

	/**
	 * @return the numeroPlazasCubiertasCharlas
	 */
	public Long getNumeroPlazasCubiertasCharlas() {
		return numeroPlazasCubiertasCharlas;
	}

	/**
	 * @param numeroPlazasCubiertasCharlas the numeroPlazasCubiertasCharlas to set
	 */
	public void setNumeroPlazasCubiertasCharlas(Long numeroPlazasCubiertasCharlas) {
		this.numeroPlazasCubiertasCharlas = numeroPlazasCubiertasCharlas;
	}

	/**
	 * @return the numeroPlazasCubiertasExternasCA
	 */
	public Long getNumeroPlazasCubiertasExternasCA() {
		return numeroPlazasCubiertasExternasCA;
	}

	/**
	 * @param numeroPlazasCubiertasExternasCA the numeroPlazasCubiertasExternasCA to set
	 */
	private void setNumeroPlazasCubiertasExternasCA(Long numeroPlazasCubiertasExternasCA) {
		this.numeroPlazasCubiertasExternasCA = numeroPlazasCubiertasExternasCA;
	}

	/**
	 * @return the numeroPlazasCubiertasExternasCS
	 */
	public Long getNumeroPlazasCubiertasExternasCS() {
		return numeroPlazasCubiertasExternasCS;
	}

	/**
	 * @param numeroPlazasCubiertasExternasCS the numeroPlazasCubiertasExternasCS to set
	 */
	private void setNumeroPlazasCubiertasExternasCS(Long numeroPlazasCubiertasExternasCS) {
		this.numeroPlazasCubiertasExternasCS = numeroPlazasCubiertasExternasCS;
	}

	/**
	 * @return the numeroPlazasCubiertasExternasCAyS
	 */
	public Long getNumeroPlazasCubiertasExternasCAyS() {
		return numeroPlazasCubiertasExternasCAyS;
	}

	/**
	 * @param numeroPlazasCubiertasExternasCAyS the numeroPlazasCubiertasExternasCAyS to set
	 */
	private void setNumeroPlazasCubiertasExternasCAyS(Long numeroPlazasCubiertasExternasCAyS) {
		this.numeroPlazasCubiertasExternasCAyS = numeroPlazasCubiertasExternasCAyS;
	}

	/**
	 * @return the numeroPlazasTerminadasCursos
	 */
	public Long getNumeroPlazasTerminadasCursos() {
		return numeroPlazasTerminadasCursos;
	}

	/**
	 * @param numeroPlazasTerminadasCursos the numeroPlazasTerminadasCursos to set
	 */
	public void setNumeroPlazasTerminadasCursos(Long numeroPlazasTerminadasCursos) {
		this.numeroPlazasTerminadasCursos = numeroPlazasTerminadasCursos;
	}

	/**
	 * @return the numeroPlazasTerminadasCharlas
	 */
	public Long getNumeroPlazasTerminadasCharlas() {
		return numeroPlazasTerminadasCharlas;
	}

	/**
	 * @param numeroPlazasTerminadasCharlas the numeroPlazasTerminadasCharlas to set
	 */
	public void setNumeroPlazasTerminadasCharlas(Long numeroPlazasTerminadasCharlas) {
		this.numeroPlazasTerminadasCharlas = numeroPlazasTerminadasCharlas;
	}

	/**
	 * @return the numeroPlazasTerminadasExternasCA
	 */
	public Long getNumeroPlazasTerminadasExternasCA() {
		return numeroPlazasTerminadasExternasCA;
	}

	/**
	 * @param numeroPlazasTerminadasExternasCA the numeroPlazasTerminadasExternasCA to set
	 */
	public void setNumeroPlazasTerminadasExternasCA(Long numeroPlazasTerminadasExternasCA) {
		setNumeroPlazasCubiertasExternasCA(numeroPlazasTerminadasExternasCA);
		this.numeroPlazasTerminadasExternasCA = numeroPlazasTerminadasExternasCA;
	}

	/**
	 * @return the numeroPlazasTerminadasExternasCS
	 */
	public Long getNumeroPlazasTerminadasExternasCS() {
		return numeroPlazasTerminadasExternasCS;
	}

	/**
	 * @param numeroPlazasTerminadasExternasCS the numeroPlazasTerminadasExternasCS to set
	 */
	public void setNumeroPlazasTerminadasExternasCS(Long numeroPlazasTerminadasExternasCS) {
		setNumeroPlazasCubiertasExternasCS(numeroPlazasTerminadasExternasCS);
		this.numeroPlazasTerminadasExternasCS = numeroPlazasTerminadasExternasCS;
	}

	/**
	 * @return the numeroPlazasTerminadasExternasCAyS
	 */
	public Long getNumeroPlazasTerminadasExternasCAyS() {
		return numeroPlazasTerminadasExternasCAyS;
	}

	/**
	 * @param numeroPlazasTerminadasExternasCAyS the numeroPlazasTerminadasExternasCAyS to set
	 */
	public void setNumeroPlazasTerminadasExternasCAyS(Long numeroPlazasTerminadasExternasCAyS) {
		setNumeroPlazasCubiertasExternasCAyS(numeroPlazasTerminadasExternasCAyS);
		this.numeroPlazasTerminadasExternasCAyS = numeroPlazasTerminadasExternasCAyS;
	}
}
