package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Float;
import java.lang.Long;

import java.util.Comparator;

public class ActivitiesAndRankingOfCenter {
		private Long idCentro;
		
		private Long numeroActividades;
		private Long rankingNumeroActividades;
		
		private Float horas;
		private Long rankingHoras;
		
		private Long usuarios;
		private Long rankingUsuarios;
		
		private Long plazasOfertadas;
		private Long rankingPlazasOfertadas;
		
		public static Comparator<ActivitiesAndRankingOfCenter> comparatorNumeroActividadesDESC = new Comparator<ActivitiesAndRankingOfCenter>() {
			public int compare(ActivitiesAndRankingOfCenter o1, ActivitiesAndRankingOfCenter o2) {
				if (o1.getNumeroActividades() > o2.getNumeroActividades())
					return -1;
				else if (o1.getNumeroActividades() < o2.getNumeroActividades())
					return 1;
				else // if (o1.getNumeroActividades() == o2.getNumeroActividades())
					return 0;
			}
		};
		
		public static Comparator<ActivitiesAndRankingOfCenter> comparatorHorasDESC = new Comparator<ActivitiesAndRankingOfCenter>() {
			public int compare(ActivitiesAndRankingOfCenter o1, ActivitiesAndRankingOfCenter o2) {
				if (o1.getHoras() > o2.getHoras())
					return -1;
				else if (o1.getHoras() < o2.getHoras())
					return 1;
				else // if (o1.getHoras() == o2.getHoras())
					return 0;
			}
		};
		
		public static Comparator<ActivitiesAndRankingOfCenter> comparatorUsuariosDESC = new Comparator<ActivitiesAndRankingOfCenter>() {
			public int compare(ActivitiesAndRankingOfCenter o1, ActivitiesAndRankingOfCenter o2) {
				if (o1.getUsuarios() > o2.getUsuarios())
					return -1;
				else if (o1.getUsuarios() < o2.getUsuarios())
					return 1;
				else // if (o1.getUsuarios() == o2.getUsuarios())
					return 0;
			}
		};
		
		public static Comparator<ActivitiesAndRankingOfCenter> comparatorPlazasOfertadasDESC = new Comparator<ActivitiesAndRankingOfCenter>() {
			public int compare(ActivitiesAndRankingOfCenter o1, ActivitiesAndRankingOfCenter o2) {
				if (o1.getPlazasOfertadas() > o2.getPlazasOfertadas())
					return -1;
				else if (o1.getPlazasOfertadas() < o2.getPlazasOfertadas())
					return 1;
				else // if (o1.getPlazasOfertadas() == o2.getPlazasOfertadas())
					return 0;
			}
		};
		
		public ActivitiesAndRankingOfCenter() {
			this.setIdCentro(Long.valueOf(-1L));
			
			this.setNumeroActividades(Long.valueOf(0L));
			this.setRankingNumeroActividades(Long.valueOf(-1L));
			
			this.setHoras(0.0F);
			this.setRankingHoras(Long.valueOf(-1L));
			
			this.setUsuarios(Long.valueOf(0L));
			this.setRankingUsuarios(Long.valueOf(-1L));
			
			this.setPlazasOfertadas(Long.valueOf(0L));
			this.setRankingPlazasOfertadas(Long.valueOf(-1L));
		}
		
		public ActivitiesAndRankingOfCenter(Long idCentro,
											Long numeroActividades, Long rankingNumeroActividades,
											Float horas, Long rankingHoras,
											Long usuarios, Long rankingUsuarios,
											Long plazasOfertadas, Long rankingPlazasOfertadas) {
			this.setIdCentro(idCentro);
			
			this.setNumeroActividades(numeroActividades);
			this.setRankingNumeroActividades(rankingNumeroActividades);
			
			this.setHoras(horas);
			this.setRankingHoras(rankingHoras);
			
			this.setUsuarios(usuarios);
			this.setRankingUsuarios(rankingUsuarios);
			
			this.setPlazasOfertadas(plazasOfertadas);
			this.setRankingPlazasOfertadas(rankingPlazasOfertadas);
		}

		/**
		 * @return the idCentro
		 */
		public Long getIdCentro() {
			return idCentro;
		}

		/**
		 * @param idCentro the idCentro to set
		 */
		public void setIdCentro(Long idCentro) {
			this.idCentro = idCentro;
		}

		/**
		 * @return the numeroActividades
		 */
		public Long getNumeroActividades() {
			return numeroActividades;
		}

		/**
		 * @param numeroActividades the numeroActividades to set
		 */
		public void setNumeroActividades(Long numeroActividades) {
			this.numeroActividades = numeroActividades;
		}

		/**
		 * @return the rankingNumeroActividades
		 */
		public Long getRankingNumeroActividades() {
			return rankingNumeroActividades;
		}

		/**
		 * @param rankingNumeroActividades the rankingNumeroActividades to set
		 */
		public void setRankingNumeroActividades(Long rankingNumeroActividades) {
			this.rankingNumeroActividades = rankingNumeroActividades;
		}

		/**
		 * @return the horas
		 */
		public Float getHoras() {
			return horas;
		}

		/**
		 * @param horas the horas to set
		 */
		public void setHoras(Float horas) {
			this.horas = horas;
		}

		/**
		 * @return the rankingHoras
		 */
		public Long getRankingHoras() {
			return rankingHoras;
		}

		/**
		 * @param rankingHoras the rankingHoras to set
		 */
		public void setRankingHoras(Long rankingHoras) {
			this.rankingHoras = rankingHoras;
		}

		/**
		 * @return the usuarios
		 */
		public Long getUsuarios() {
			return usuarios;
		}

		/**
		 * @param usuarios the usuarios to set
		 */
		public void setUsuarios(Long usuarios) {
			this.usuarios = usuarios;
		}

		/**
		 * @return the rankingUsuarios
		 */
		public Long getRankingUsuarios() {
			return rankingUsuarios;
		}

		/**
		 * @param rankingUsuarios the rankingUsuarios to set
		 */
		public void setRankingUsuarios(Long rankingUsuarios) {
			this.rankingUsuarios = rankingUsuarios;
		}

		/**
		 * @return the plazasOfertadas
		 */
		public Long getPlazasOfertadas() {
			return plazasOfertadas;
		}

		/**
		 * @param plazasOfertadas the plazasOfertadas to set
		 */
		public void setPlazasOfertadas(Long plazasOfertadas) {
			this.plazasOfertadas = plazasOfertadas;
		}

		/**
		 * @return the rankingPlazasOfertadas
		 */
		public Long getRankingPlazasOfertadas() {
			return rankingPlazasOfertadas;
		}

		/**
		 * @param rankingPlazasOfertadas the rankingPlazasOfertadas to set
		 */
		public void setRankingPlazasOfertadas(Long rankingPlazasOfertadas) {
			this.rankingPlazasOfertadas = rankingPlazasOfertadas;
		}
	}
