package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Float;
import java.lang.Long;

import es.csa.fdt.cyldigital.usuarios.entity.Provincia;
import es.csa.fdt.cyldigital.centros.entity.Centro;

public class ActivitiesByCenter {
	private Provincia provincia;
	private Centro centro;
	private Long numeroCursos;
	private Long numeroCharlas;
	private Long numeroExternasCA;
	private Long numeroExternasCAyS;
	private Float numeroHorasAA;
	private Float numeroHorasCursos;
	private Float numeroHorasCharlas;
	private Float numeroHorasExternasCA;
	private Float numeroHorasExternasCAyS;
	private Long numeroUsuariosCursos;
	private Long numeroUsuariosCharlas;
	private Long numeroUsuariosExternasCA;
	private Long numeroUsuariosExternasCAyS;
	
	public ActivitiesByCenter() {
		this.setProvincia(null);
		this.setCentro(null);

		this.setNumeroCursos(Long.valueOf(-1L));
		this.setNumeroCharlas(Long.valueOf(-1L));
		this.setNumeroExternasCA(Long.valueOf(-1L));
		this.setNumeroExternasCAyS(Long.valueOf(-1L));

		this.setNumeroHorasAA(-1.0F);
		this.setNumeroHorasCursos(-1.0F);
		this.setNumeroHorasCharlas(-1.0F);
		this.setNumeroHorasExternasCA(-1.0F);
		this.setNumeroHorasExternasCAyS(-1.0F);

		this.setNumeroUsuariosCursos(Long.valueOf(-1L));
		this.setNumeroUsuariosCharlas(Long.valueOf(-1L));
		this.setNumeroUsuariosExternasCA(Long.valueOf(-1L));
		this.setNumeroUsuariosExternasCAyS(Long.valueOf(-1L));
	}
	
	public ActivitiesByCenter(Provincia provincia, Centro centro,
										 Long numeroCursos, Long numeroCharlas, Long numeroExternasCA, Long numeroExternasCAyS,
										 Float numeroHorasAA, Float numeroHorasCursos, Float numeroHorasCharlas,
										 Float numeroHorasExternasCA, Float numeroHorasExternasCAyS, Long numeroUsuariosCursos,
										 Long numeroUsuariosCharlas, Long numeroUsuariosExternasCA, Long numeroUsuariosExternasCAyS) {
		this.setProvincia(provincia);
		this.setCentro(centro);

		this.setNumeroCursos(numeroCursos);
		this.setNumeroCharlas(numeroCharlas);
		this.setNumeroExternasCA(numeroExternasCA);
		this.setNumeroExternasCAyS(numeroExternasCAyS);

		this.setNumeroHorasAA(numeroHorasAA);
		this.setNumeroHorasCursos(numeroHorasCursos);
		this.setNumeroHorasCharlas(numeroHorasCharlas);
		this.setNumeroHorasExternasCA(numeroHorasExternasCA);
		this.setNumeroHorasExternasCAyS(numeroHorasExternasCAyS);

		this.setNumeroUsuariosCursos(numeroUsuariosCursos);
		this.setNumeroUsuariosCharlas(numeroUsuariosCharlas);
		this.setNumeroUsuariosExternasCA(numeroUsuariosExternasCA);
		this.setNumeroUsuariosExternasCAyS(numeroUsuariosExternasCAyS);
	}

	/**
	 * @return the provincia
	 */
	public Provincia getProvincia() {
		return provincia;
	}

	/**
	 * @param provincia the provincia to set
	 */
	public void setProvincia(Provincia provincia) {
		this.provincia = provincia;
	}

	/**
	 * @return the centro
	 */
	public Centro getCentro() {
		return centro;
	}

	/**
	 * @param centro the centro to set
	 */
	public void setCentro(Centro centro) {
		this.centro = centro;
	}

	/**
	 * @return the numeroCursos
	 */
	public Long getNumeroCursos() {
		return numeroCursos;
	}

	/**
	 * @param numeroCursos the numeroCursos to set
	 */
	public void setNumeroCursos(Long numeroCursos) {
		this.numeroCursos = numeroCursos;
	}

	/**
	 * @return the numeroCharlas
	 */
	public Long getNumeroCharlas() {
		return numeroCharlas;
	}

	/**
	 * @param numeroCharlas the numeroCharlas to set
	 */
	public void setNumeroCharlas(Long numeroCharlas) {
		this.numeroCharlas = numeroCharlas;
	}

	/**
	 * @return the numeroExternasCA
	 */
	public Long getNumeroExternasCA() {
		return numeroExternasCA;
	}

	/**
	 * @param numeroExternasCA the numeroExternasCA to set
	 */
	public void setNumeroExternasCA(Long numeroExternasCA) {
		this.numeroExternasCA = numeroExternasCA;
	}

	/**
	 * @return the numeroExternasCAyS
	 */
	public Long getNumeroExternasCAyS() {
		return numeroExternasCAyS;
	}

	/**
	 * @param numeroExternasCAyS the numeroExternasCAyS to set
	 */
	public void setNumeroExternasCAyS(Long numeroExternasCAyS) {
		this.numeroExternasCAyS = numeroExternasCAyS;
	}
	
	/**
	 * @return the numeroHorasAA
	 */
	public Float getNumeroHorasAA() {
		return numeroHorasAA;
	}
	
	/**
	 * @param numeroHorasAA the numeroHorasAA to set
	 */
	public void setNumeroHorasAA(Float numeroHorasAA) {
		this.numeroHorasAA = numeroHorasAA;
	}

	/**
	 * @return the numeroHorasCursos
	 */
	public Float getNumeroHorasCursos() {
		return numeroHorasCursos;
	}

	/**
	 * @param numeroHorasCursos the numeroHorasCursos to set
	 */
	public void setNumeroHorasCursos(Float numeroHorasCursos) {
		this.numeroHorasCursos = numeroHorasCursos;
	}

	/**
	 * @return the numeroHorasCharlas
	 */
	public Float getNumeroHorasCharlas() {
		return numeroHorasCharlas;
	}

	/**
	 * @param numeroHorasCharlas the numeroHorasCharlas to set
	 */
	public void setNumeroHorasCharlas(Float numeroHorasCharlas) {
		this.numeroHorasCharlas = numeroHorasCharlas;
	}

	/**
	 * @return the numeroHorasExternasCA
	 */
	public Float getNumeroHorasExternasCA() {
		return numeroHorasExternasCA;
	}

	/**
	 * @param numeroHorasExternasCA the numeroHorasExternasCA to set
	 */
	public void setNumeroHorasExternasCA(Float numeroHorasExternasCA) {
		this.numeroHorasExternasCA = numeroHorasExternasCA;
	}

	/**
	 * @return the numeroHorasExternasCAyS
	 */
	public Float getNumeroHorasExternasCAyS() {
		return numeroHorasExternasCAyS;
	}

	/**
	 * @param numeroHorasExternasCAyS the numeroHorasExternasCAyS to set
	 */
	public void setNumeroHorasExternasCAyS(Float numeroHorasExternasCAyS) {
		this.numeroHorasExternasCAyS = numeroHorasExternasCAyS;
	}

	/**
	 * @return the numeroUsuariosCursos
	 */
	public Long getNumeroUsuariosCursos() {
		return numeroUsuariosCursos;
	}

	/**
	 * @param numeroUsuariosCursos the numeroUsuariosCursos to set
	 */
	public void setNumeroUsuariosCursos(Long numeroUsuariosCursos) {
		this.numeroUsuariosCursos = numeroUsuariosCursos;
	}

	/**
	 * @return the numeroUsuariosCharlas
	 */
	public Long getNumeroUsuariosCharlas() {
		return numeroUsuariosCharlas;
	}

	/**
	 * @param numeroUsuariosCharlas the numeroUsuariosCharlas to set
	 */
	public void setNumeroUsuariosCharlas(Long numeroUsuariosCharlas) {
		this.numeroUsuariosCharlas = numeroUsuariosCharlas;
	}

	/**
	 * @return the numeroUsuariosExternasCA
	 */
	public Long getNumeroUsuariosExternasCA() {
		return numeroUsuariosExternasCA;
	}

	/**
	 * @param numeroUsuariosExternasCA the numeroUsuariosExternasCA to set
	 */
	public void setNumeroUsuariosExternasCA(Long numeroUsuariosExternasCA) {
		this.numeroUsuariosExternasCA = numeroUsuariosExternasCA;
	}

	/**
	 * @return the numeroUsuariosExternasCAyS
	 */
	public Long getNumeroUsuariosExternasCAyS() {
		return numeroUsuariosExternasCAyS;
	}

	/**
	 * @param numeroUsuariosExternasCAyS the numeroUsuariosExternasCAyS to set
	 */
	public void setNumeroUsuariosExternasCAyS(Long numeroUsuariosExternasCAyS) {
		this.numeroUsuariosExternasCAyS = numeroUsuariosExternasCAyS;
	}
}
