package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Long;
import java.util.Locale;
import java.util.ResourceBundle;

import es.csa.fdt.cyldigital.servicios.entity.Servicio.Nivel;

public class ActivitiesByLevel {
	
	private Nivel nivel;
	private String nombreNivel;
	private Long numeroCursosDP;
	private Long numeroCursosFP;
	private Long numeroExternasDP;
	private Long numeroExternasFP;

	public ActivitiesByLevel() {
		this.setNivel(null);
		this.setNombreNivel(null);

		this.setNumeroCursosDP(Long.valueOf(-1L));
		this.setNumeroCursosFP(Long.valueOf(-1L));
		this.setNumeroExternasDP(Long.valueOf(-1L));
		this.setNumeroExternasFP(Long.valueOf(-1L));
	}
	
	public ActivitiesByLevel(Nivel level, Long numeroCursosDP, Long numeroCursosFP,
										  Long numeroExternasDP, Long numeroExternasFP,
							 Locale locale) {
		ResourceBundle rb = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.messages", locale);

		this.setNivel(level);
		this.setNombreNivel(rb.getString("nivel." + nivel.toString()));

		this.setNumeroCursosDP(numeroCursosDP);
		this.setNumeroCursosFP(numeroCursosFP);
		this.setNumeroExternasDP(numeroExternasDP);
		this.setNumeroExternasFP(numeroExternasFP);
	}

	/**
	 * @return the nivel
	 */
	public Nivel getNivel() {
		return nivel;
	}

	/**
	 * @param nivel the nivel to set
	 */
	public void setNivel(Nivel nivel) {
		this.nivel = nivel;
	}

	/**
	 * @return the nombreNivel
	 */
	public String getNombreNivel() {
		return nombreNivel;
	}

	/**
	 * @param nombreNivel the nombreNivel to set
	 */
	public void setNombreNivel(String nombreNivel) {
		this.nombreNivel = nombreNivel;
	}

	/**
	 * @return the numeroCursosDP
	 */
	public Long getNumeroCursosDP() {
		return numeroCursosDP;
	}

	/**
	 * @param numeroCursosDP the numeroCursosDP to set
	 */
	public void setNumeroCursosDP(Long numeroCursosDP) {
		this.numeroCursosDP = numeroCursosDP;
	}

	/**
	 * @return the numeroCursosFP
	 */
	public Long getNumeroCursosFP() {
		return numeroCursosFP;
	}

	/**
	 * @param numeroCursosFP the numeroCursosFP to set
	 */
	public void setNumeroCursosFP(Long numeroCursosFP) {
		this.numeroCursosFP = numeroCursosFP;
	}

	/**
	 * @return the numeroExternasDP
	 */
	public Long getNumeroExternasDP() {
		return numeroExternasDP;
	}

	/**
	 * @param numeroExternasDP the numeroExternasDP to set
	 */
	public void setNumeroExternasDP(Long numeroExternasDP) {
		this.numeroExternasDP = numeroExternasDP;
	}

	/**
	 * @return the numeroExternasFP
	 */
	public Long getNumeroExternasFP() {
		return numeroExternasFP;
	}

	/**
	 * @param numeroExternasFP the numeroExternasFP to set
	 */
	public void setNumeroExternasFP(Long numeroExternasFP) {
		this.numeroExternasFP = numeroExternasFP;
	}
}
