package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Float;
import java.lang.Long;

import es.csa.fdt.cyldigital.centros.entity.Centro;

public class ActivitiesByService {
	private Long idTematicaL1;
	private String nombreTematicaL1;
	
	private Long idTematicaL2;
	private String nombreTematicaL2;
	
	private Long idServicio;
	private String nombreServicio;
	
	private Long numeroActividades;
	private Float horas;
	private Long usuarios;
	private Long plazasOfertadas;

	public ActivitiesByService() {
		this.setIdTematicaL1(Long.valueOf(-1L));
		this.setNombreTematicaL1("");
		
		this.setIdTematicaL2(Long.valueOf(-1L));
		this.setNombreTematicaL2("");
		
		this.setIdServicio(Long.valueOf(-1L));
		this.setNombreServicio("");

		this.setNumeroActividades(Long.valueOf(0L));
		this.setHoras(0.0F);
		this.setUsuarios(Long.valueOf(0L));
		this.setPlazasOfertadas(Long.valueOf(0L));
	}
	
	public ActivitiesByService(Long idTematicaL1, String nombreTematicaL1,
										Long idTematicaL2, String nombreTematicaL2,
										Long idServicio, String nombreServicio,
										Long numeroActividades, Float horas, Long usuarios, Long plazasOfertadas) {
		this.setIdTematicaL1(idTematicaL1);
		this.setNombreTematicaL1(nombreTematicaL1);
		
		this.setIdTematicaL2(idTematicaL2);
		this.setNombreTematicaL2(nombreTematicaL2);
		
		this.setIdServicio(idServicio);
		this.setNombreServicio(nombreServicio);

		this.setNumeroActividades(numeroActividades);
		this.setHoras(horas);
		this.setUsuarios(usuarios);
		this.setPlazasOfertadas(plazasOfertadas);
	}

	/**
	 * @return the idTematicaL1
	 */
	public Long getIdTematicaL1() {
		return idTematicaL1;
	}

	/**
	 * @param idTematicaL1 the idTematicaL1 to set
	 */
	public void setIdTematicaL1(Long idTematicaL1) {
		this.idTematicaL1 = idTematicaL1;
	}

	/**
	 * @return the nombreTematicaL1
	 */
	public String getNombreTematicaL1() {
		return nombreTematicaL1;
	}

	/**
	 * @param nombreTematicaL1 the nombreTematicaL1 to set
	 */
	public void setNombreTematicaL1(String nombreTematicaL1) {
		this.nombreTematicaL1 = nombreTematicaL1;
	}

	/**
	 * @return the idTematicaL2
	 */
	public Long getIdTematicaL2() {
		return idTematicaL2;
	}

	/**
	 * @param idTematicaL2 the idTematicaL2 to set
	 */
	public void setIdTematicaL2(Long idTematicaL2) {
		this.idTematicaL2 = idTematicaL2;
	}

	/**
	 * @return the nombreTematicaL2
	 */
	public String getNombreTematicaL2() {
		return nombreTematicaL2;
	}

	/**
	 * @param nombreTematicaL2 the nombreTematicaL2 to set
	 */
	public void setNombreTematicaL2(String nombreTematicaL2) {
		this.nombreTematicaL2 = nombreTematicaL2;
	}

	/**
	 * @return the idServicio
	 */
	public Long getIdServicio() {
		return idServicio;
	}

	/**
	 * @param idServicio the idServicio to set
	 */
	public void setIdServicio(Long idServicio) {
		this.idServicio = idServicio;
	}

	/**
	 * @return the nombreServicio
	 */
	public String getNombreServicio() {
		return nombreServicio;
	}

	/**
	 * @param nombreServicio the nombreServicio to set
	 */
	public void setNombreServicio(String nombreServicio) {
		this.nombreServicio = nombreServicio;
	}

	/**
	 * @return the numeroActividades
	 */
	public Long getNumeroActividades() {
		return numeroActividades;
	}

	/**
	 * @param numeroActividades the numeroActividades to set
	 */
	public void setNumeroActividades(Long numeroActividades) {
		this.numeroActividades = numeroActividades;
	}

	/**
	 * @return the horas
	 */
	public Float getHoras() {
		return horas;
	}

	/**
	 * @param horas the horas to set
	 */
	public void setHoras(Float horas) {
		this.horas = horas;
	}

	/**
	 * @return the usuarios
	 */
	public Long getUsuarios() {
		return usuarios;
	}

	/**
	 * @param usuarios the usuarios to set
	 */
	public void setUsuarios(Long usuarios) {
		this.usuarios = usuarios;
	}

	/**
	 * @return the plazasOfertadas
	 */
	public Long getPlazasOfertadas() {
		return plazasOfertadas;
	}

	/**
	 * @param plazasOfertadas the plazasOfertadas to set
	 */
	public void setPlazasOfertadas(Long plazasOfertadas) {
		this.plazasOfertadas = plazasOfertadas;
	}
}
