package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Float;
import java.lang.String;

public class AverageRatingOfQuestion {
	private String question;
	
	private Float minimumValue;
	private Float maximumValue;
	
	private Float periodAverageRating;
	private Float globalAverageRating;
	
	public AverageRatingOfQuestion() {
		this.setQuestion("");
		
		this.setMinimumValue(Float.valueOf(-1.0F));
		this.setMaximumValue(Float.valueOf(-1.0F));
		
		this.setPeriodAverageRating(Float.valueOf(-1.0F));
		this.setGlobalAverageRating(Float.valueOf(-1.0F));
	}
	
	public AverageRatingOfQuestion(String question,
								   Float minimumValue, Float maximumValue,
								   Float periodAverageRating, Float globalAverageRating) {
		this.setQuestion(question);
		
		this.setMinimumValue(minimumValue);
		this.setMaximumValue(maximumValue);
		
		this.setPeriodAverageRating(periodAverageRating);
		this.setGlobalAverageRating(globalAverageRating);
	}

	/**
	 * @return the question
	 */
	public String getQuestion() {
		return question;
	}

	/**
	 * @param question the question to set
	 */
	public void setQuestion(String question) {
		this.question = question;
	}

	/**
	 * @return the minimumValue
	 */
	public Float getMinimumValue() {
		return minimumValue;
	}

	/**
	 * @param minimumValue the minimumValue to set
	 */
	public void setMinimumValue(Float minimumValue) {
		this.minimumValue = minimumValue;
	}

	/**
	 * @return the maximumValue
	 */
	public Float getMaximumValue() {
		return maximumValue;
	}

	/**
	 * @param maximumValue the maximumValue to set
	 */
	public void setMaximumValue(Float maximumValue) {
		this.maximumValue = maximumValue;
	}

	/**
	 * @return the periodAverageRating
	 */
	public Float getPeriodAverageRating() {
		return periodAverageRating;
	}

	/**
	 * @param periodAverageRating the periodAverageRating to set
	 */
	public void setPeriodAverageRating(Float periodAverageRating) {
		this.periodAverageRating = periodAverageRating;
	}

	/**
	 * @return the globalAverageRating
	 */
	public Float getGlobalAverageRating() {
		return globalAverageRating;
	}

	/**
	 * @param globalAverageRating the globalAverageRating to set
	 */
	public void setGlobalAverageRating(Float globalAverageRating) {
		this.globalAverageRating = globalAverageRating;
	}
}
