package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Float;
import java.util.Comparator;

import es.csa.fdt.cyldigital.usuarios.entity.Proveedor;

public class AverageRatingOfQuestionsByCollaborativeEntity {
	private Proveedor entidadColaboradora;
	
	private Float periodAverageRating;
	private Float historicalAverageRating;

	private Long rankingHistoricalAverageRatingGlobal;
	
	public static Comparator<AverageRatingOfQuestionsByCollaborativeEntity> comparatorCollaborativeEntityASC = new Comparator<AverageRatingOfQuestionsByCollaborativeEntity>() {
		public int compare(AverageRatingOfQuestionsByCollaborativeEntity o1, AverageRatingOfQuestionsByCollaborativeEntity o2) {
			if (o1.getEntidadColaboradora().getNombre().compareToIgnoreCase(o2.getEntidadColaboradora().getNombre()) < 0)
				return -1;
			else if (o1.getEntidadColaboradora().getNombre().compareToIgnoreCase(o2.getEntidadColaboradora().getNombre()) > 0)
				return 1;
			else // if (o1.getEntidadColaboradora().getNombre().compareToIgnoreCase(o2.getEntidadColaboradora().getNombre()) == 0)
				return 0;
		}
	};
	
	public static Comparator<AverageRatingOfQuestionsByCollaborativeEntity> comparatorHistoricalAverageRatingDESC = new Comparator<AverageRatingOfQuestionsByCollaborativeEntity>() {
		public int compare(AverageRatingOfQuestionsByCollaborativeEntity o1, AverageRatingOfQuestionsByCollaborativeEntity o2) {
			if (o1.getHistoricalAverageRating() > o2.getHistoricalAverageRating())
				return -1;
			else if (o1.getHistoricalAverageRating() < o2.getHistoricalAverageRating())
				return 1;
			else // if (o1.getHistoricalAverageRating() == o2.getHistoricalAverageRating())
				return 0;
		}
	};
	
	public AverageRatingOfQuestionsByCollaborativeEntity() {
		this.setEntidadColaboradora(null);
		
		this.setPeriodAverageRating(Float.valueOf(-1.0F));
		this.setHistoricalAverageRating(Float.valueOf(-1.0F));
		
		this.setRankingHistoricalAverageRatingGlobal(Long.valueOf(-1L));
	}
	
	public AverageRatingOfQuestionsByCollaborativeEntity(Proveedor entidadColaboradora,
														 Float periodAverageRating, Float historicalAverageRating,
														 Long rankingGlobalHistorico) {
		this.setEntidadColaboradora(entidadColaboradora);
		
		this.setPeriodAverageRating(periodAverageRating);
		this.setHistoricalAverageRating(historicalAverageRating);

		this.setRankingHistoricalAverageRatingGlobal(rankingGlobalHistorico);
	}

	/**
	 * @return the entidadColaboradora
	 */
	public Proveedor getEntidadColaboradora() {
		return entidadColaboradora;
	}

	/**
	 * @param entidadColaboradora the entidadColaboradora to set
	 */
	public void setEntidadColaboradora(Proveedor entidadColaboradora) {
		this.entidadColaboradora = entidadColaboradora;
	}

	/**
	 * @return the periodAverageRating
	 */
	public Float getPeriodAverageRating() {
		return periodAverageRating;
	}

	/**
	 * @param periodAverageRating the periodAverageRating to set
	 */
	public void setPeriodAverageRating(Float periodAverageRating) {
		this.periodAverageRating = periodAverageRating;
	}

	/**
	 * @return the historicalAverageRating
	 */
	public Float getHistoricalAverageRating() {
		return historicalAverageRating;
	}

	/**
	 * @param historicalAverageRating the historicalAverageRating to set
	 */
	public void setHistoricalAverageRating(Float historicalAverageRating) {
		this.historicalAverageRating = historicalAverageRating;
	}

	/**
	 * @return the rankingHistoricalAverageRatingGlobal
	 */
	public Long getRankingHistoricalAverageRatingGlobal() {
		return rankingHistoricalAverageRatingGlobal;
	}

	/**
	 * @param rankingHistoricalAverageRatingGlobal the rankingHistoricalAverageRatingGlobal to set
	 */
	public void setRankingHistoricalAverageRatingGlobal(
			Long rankingHistoricalAverageRatingGlobal) {
		this.rankingHistoricalAverageRatingGlobal = rankingHistoricalAverageRatingGlobal;
	}
}
