package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Long;

import java.util.Comparator;

import es.csa.fdt.cyldigital.usuarios.entity.Provincia;
import es.csa.fdt.cyldigital.centros.entity.Centro;

public class RegisteredUsersByCenter {
	private Provincia provincia;
	private Centro centro;
	
	private Long registeredUsersSC;
	private Long registeredUsersB;
	private Long registeredUsersNU;
	private Long registeredUsersTA;
	
	private Long rankingProvincial;
	private Long rankingGlobal;
	
	public static Comparator<RegisteredUsersByCenter> comparatorProvinciaASCCentroASC = new Comparator<RegisteredUsersByCenter>() {
		public int compare(RegisteredUsersByCenter o1, RegisteredUsersByCenter o2) {
			if (o1.getProvincia().getNombre().compareToIgnoreCase(o2.getProvincia().getNombre()) < 0)
				return -1;
			else if (o1.getProvincia().getNombre().compareToIgnoreCase(o2.getProvincia().getNombre()) > 0)
				return 1;
			else { // if (o1.getProvincia().getNombre().compareToIgnoreCase(o2.getProvincia().getNombre()) == 0)
				if (o1.getCentro().getNombre().compareToIgnoreCase(o2.getCentro().getNombre()) < 0)
					return -1;
				else if (o1.getCentro().getNombre().compareToIgnoreCase(o2.getCentro().getNombre()) > 0)
					return 1;
				else  // if (o1.getCentro().getNombre().compareToIgnoreCase(o2.getCentro().getNombre()) == 0)
					return 0;
			}
		}
	};
	
	public static Comparator<RegisteredUsersByCenter> comparatorRegisteredUsersDESC = new Comparator<RegisteredUsersByCenter>() {
		public int compare(RegisteredUsersByCenter o1, RegisteredUsersByCenter o2) {
			Long registeredUsers1 = o1.getRegisteredUsersSC() + o1.getRegisteredUsersB() + o1.getRegisteredUsersNU() + o1.getRegisteredUsersTA();
			Long registeredUsers2 = o2.getRegisteredUsersSC() + o2.getRegisteredUsersB() + o2.getRegisteredUsersNU() + o2.getRegisteredUsersTA();
				
			if (registeredUsers1 > registeredUsers2)
				return -1;
			else if (registeredUsers1 < registeredUsers2)
				return 1;
			else // if (registeredUsers1 == registeredUsers2)
				return 0;
		}
	};
	
	public static Comparator<RegisteredUsersByCenter> comparatorProvinciaASCRegisteredUsersDESC = new Comparator<RegisteredUsersByCenter>() {
		public int compare(RegisteredUsersByCenter o1, RegisteredUsersByCenter o2) {
			if (o1.getProvincia().getNombre().compareToIgnoreCase(o2.getProvincia().getNombre()) < 0)
				return -1;
			else if (o1.getProvincia().getNombre().compareToIgnoreCase(o2.getProvincia().getNombre()) > 0)
				return 1;
			else { // if (o1.getProvincia().getNombre().compareToIgnoreCase(o2.getProvincia().getNombre()) == 0)
				Long registeredUsers1 = o1.getRegisteredUsersSC() + o1.getRegisteredUsersB() + o1.getRegisteredUsersNU() + o1.getRegisteredUsersTA();
				Long registeredUsers2 = o2.getRegisteredUsersSC() + o2.getRegisteredUsersB() + o2.getRegisteredUsersNU() + o2.getRegisteredUsersTA();

				if (registeredUsers1 > registeredUsers2)
					return -1;
				else if (registeredUsers1 < registeredUsers2)
					return 1;
				else // if (registeredUsers1 == registeredUsers2)
					return 0;
			}
		}
	};

	public RegisteredUsersByCenter() {
		this.setProvincia(null);
		this.setCentro(null);

		this.setRegisteredUsersSC(Long.valueOf(-1L));
		this.setRegisteredUsersB(Long.valueOf(-1L));
		this.setRegisteredUsersNU(Long.valueOf(-1L));
		this.setRegisteredUsersTA(Long.valueOf(-1L));
		
		this.setRankingProvincial(Long.valueOf(-1L));
		this.setRankingGlobal(Long.valueOf(-1L));
	}
	
	public RegisteredUsersByCenter(Provincia provincia, Centro centro,
								   Long registeredUsersSC, Long registeredUsersB, Long registeredUsersNU, Long registeredUsersTA,
								   Long rankingProvincial, Long rankingGlobal) {
		this.setProvincia(provincia);
		this.setCentro(centro);

		this.setRegisteredUsersSC(registeredUsersSC);
		this.setRegisteredUsersB(registeredUsersB);
		this.setRegisteredUsersNU(registeredUsersNU);
		this.setRegisteredUsersTA(registeredUsersTA);
		
		this.setRankingProvincial(rankingProvincial);
		this.setRankingGlobal(rankingGlobal);
	}

	/**
	 * @return the provincia
	 */
	public Provincia getProvincia() {
		return provincia;
	}

	/**
	 * @param provincia the provincia to set
	 */
	public void setProvincia(Provincia provincia) {
		this.provincia = provincia;
	}

	/**
	 * @return the centro
	 */
	public Centro getCentro() {
		return centro;
	}

	/**
	 * @param centro the centro to set
	 */
	public void setCentro(Centro centro) {
		this.centro = centro;
	}

	/**
	 * @return the registeredUsersSC
	 */
	public Long getRegisteredUsersSC() {
		return registeredUsersSC;
	}

	/**
	 * @param registeredUsersSC the registeredUsersSC to set
	 */
	public void setRegisteredUsersSC(Long registeredUsersSC) {
		this.registeredUsersSC = registeredUsersSC;
	}

	/**
	 * @return the registeredUsersB
	 */
	public Long getRegisteredUsersB() {
		return registeredUsersB;
	}

	/**
	 * @param registeredUsersB the registeredUsersB to set
	 */
	public void setRegisteredUsersB(Long registeredUsersB) {
		this.registeredUsersB = registeredUsersB;
	}

	/**
	 * @return the registeredUsersNU
	 */
	public Long getRegisteredUsersNU() {
		return registeredUsersNU;
	}

	/**
	 * @param registeredUsersNU the registeredUsersNU to set
	 */
	public void setRegisteredUsersNU(Long registeredUsersNU) {
		this.registeredUsersNU = registeredUsersNU;
	}

	/**
	 * @return the registeredUsersTA
	 */
	public Long getRegisteredUsersTA() {
		return registeredUsersTA;
	}

	/**
	 * @param registeredUsersTA the registeredUsersTA to set
	 */
	public void setRegisteredUsersTA(Long registeredUsersTA) {
		this.registeredUsersTA = registeredUsersTA;
	}
	
	/**
	 * @return the total registeredUsers
	 */
	public Long getCenterRegisteredUsers() {
		return (registeredUsersSC + registeredUsersB + registeredUsersNU + registeredUsersTA);
	}

	/**
	 * @return the rankingProvincial
	 */
	public Long getRankingProvincial() {
		return rankingProvincial;
	}

	/**
	 * @param rankingProvincial the rankingProvincial to set
	 */
	public void setRankingProvincial(Long rankingProvincial) {
		this.rankingProvincial = rankingProvincial;
	}

	/**
	 * @return the rankingGlobal
	 */
	public Long getRankingGlobal() {
		return rankingGlobal;
	}

	/**
	 * @param rankingGlobal the rankingGlobal to set
	 */
	public void setRankingGlobal(Long rankingGlobal) {
		this.rankingGlobal = rankingGlobal;
	}
}
