package es.fdt.isis.reports.entity;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * %%
 * ﻿This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */


import java.lang.Long;
import java.lang.String;

public class UsersExamPassedByServices {
	public class Index {
		private Long id;
		private String nombre;
		
		Index() {
			this.setId(Long.valueOf(-1L));
			this.setNombre("");
		}
		
		Index(Long id, String nombre) {
			this.setId(id);
			this.setNombre(nombre);
		}
		
		/**
		 * @return the id
		 */
		public Long getId() {
			return id;
		}
		/**
		 * @param id the id to set
		 */
		public void setId(Long id) {
			this.id = id;
		}
		/**
		 * @return the nombre
		 */
		public String getNombre() {
			return nombre;
		}
		/**
		 * @param nombre the nombre to set
		 */
		public void setNombre(String nombre) {
			this.nombre = nombre;
		}
	}

	private Index servicio;
	
	private Long numUsuariosExamen;
	private Long numUsuariosExamenAprobado;

	public UsersExamPassedByServices() {
		this.setServicio(null);

		this.setNumUsuariosExamen(Long.valueOf(0L));
		this.setNumUsuariosExamenAprobado(Long.valueOf(0L));
	}
	
	public UsersExamPassedByServices(Long idServicio, String nombreServicio, Long numUsuariosExamen, Long numUsuariosExamenAprobado) {
		this.setServicio(new Index(idServicio, nombreServicio));

		this.setNumUsuariosExamen(numUsuariosExamen);
		this.setNumUsuariosExamenAprobado(numUsuariosExamenAprobado);
	}

	/**
	 * @return the servicio
	 */
	public Index getServicio() {
		return servicio;
	}

	/**
	 * @param servicio the servicio to set
	 */
	public void setServicio(Index servicio) {
		this.servicio = servicio;
	}

	/**
	 * @return the numUsuariosExamen
	 */
	public Long getNumUsuariosExamen() {
		return numUsuariosExamen;
	}

	/**
	 * @param numUsuariosExamen the numUsuariosExamen to set
	 */
	public void setNumUsuariosExamen(Long numUsuariosExamen) {
		this.numUsuariosExamen = numUsuariosExamen;
	}

	/**
	 * @param numUsuariosExamenAprobado the numUsuariosExamenAprobado to set
	 */
	public void setNumUsuariosExamenAprobado(Long numUsuariosExamenAprobado) {
		this.numUsuariosExamenAprobado = numUsuariosExamenAprobado;
	}

	/**
	 * @return the numUsuariosExamenAprobado
	 */
	public Long getNumUsuariosExamenAprobado() {
		return numUsuariosExamenAprobado;
	}
}
