package es.csa.fdt.cyldigital.listings;

import java.io.ByteArrayInputStream;

/*
 * #%L
 * Librerías del núcleo para Web - Gestion Integral de Centros CeMIT
 * %%
 * Copyright (C) 2011 - 2014 Fundetec <soporte@fundetec.es>
 * Copyright (C) 2015  Xunta de Galicia <oficinacemit@xunta.es>
 * %%
 * This file is part of "XEA" ("Gestion Integral de Centros CeMIT").
 * 
 * developed by: Fundetec <soporte@fundetec.es>
 * developed by: Balidea <info@balidea.com>
 * 
 * "XEA" is free software: you can redistribute it and/or modify
 * it under the terms of:
 * -  Apache License, Version 2.0 (the "License");  
 * -  or the European Union Public License, either Version 1.1 or,
 *    as soon they will be approved by the European Commission,
 *    subsequent versions ofthe EUPL;
 * 
 * "XEA" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Apache License or European Union Public License for
 * more details.
 * 
 * You may obtain a copy of the Apache License, Version 2.0 at:
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * You may obtain a copy of the European Union Public Licence at:
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 * #L%
 */

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.OutputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.persistence.Query;

import org.apache.commons.codec.binary.Base64;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFDataFormat;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRichTextString;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.context.SecurityContextHolder;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.google.common.base.Charsets;

import es.csa.fdt.cyldigital.calendario.entity.ActividadCalendarItem;
import es.csa.fdt.cyldigital.calendario.entity.AsistenciaCalendarItem;
import es.csa.fdt.cyldigital.centros.entity.Centro;
import es.csa.fdt.cyldigital.controller.ExcelControllerImpl.EDocumentFormats;
import es.csa.fdt.cyldigital.financiero.entity.DocumentoFactura.EstadoDocumentoFactura;
import es.csa.fdt.cyldigital.financiero.entity.EstadoFactura.TipoEstadoFactura;
import es.csa.fdt.cyldigital.financiero.entity.Factura;
import es.csa.fdt.cyldigital.incidencias.entity.CategoriaIncidencia;
import es.csa.fdt.cyldigital.incidencias.entity.Incidencia;
import es.csa.fdt.cyldigital.incidencias.entity.Incidencia.Criticidad;
import es.csa.fdt.cyldigital.incidencias.entity.Incidencia.EstadoIncidencia;
import es.csa.fdt.cyldigital.language.entity.ActividadExternaLanguage;
import es.csa.fdt.cyldigital.language.entity.CharlaLanguage;
import es.csa.fdt.cyldigital.language.entity.CursoLanguage;
import es.csa.fdt.cyldigital.language.entity.ServicioCursoLanguage;
import es.csa.fdt.cyldigital.language.entity.ServicioLanguage;
import es.csa.fdt.cyldigital.language.entity.TematicaLanguage;
import es.csa.fdt.cyldigital.language.entity.TipoPracticaLanguage;
import es.csa.fdt.cyldigital.notificacion.service.InformesNotificationsBrowserImpl.EActivityTypes;
import es.csa.fdt.cyldigital.notificacion.service.InformesNotificationsBrowserImpl.EReportDatosTypes;
import es.csa.fdt.cyldigital.notificacion.service.InformesNotificationsBrowserImpl.EReportType;
import es.csa.fdt.cyldigital.recursos.entity.CategoriaRecurso;
import es.csa.fdt.cyldigital.recursos.entity.Recurso;
import es.csa.fdt.cyldigital.recursos.entity.Recurso.EstadoRecurso;
//import es.csa.fdt.cyldigital.reports.ReportHelperByCentro;
import es.csa.fdt.cyldigital.servicios.entity.ActividadExterna;
import es.csa.fdt.cyldigital.servicios.entity.Asesoramiento;
import es.csa.fdt.cyldigital.servicios.entity.Charla;
import es.csa.fdt.cyldigital.servicios.entity.Curso;
import es.csa.fdt.cyldigital.servicios.entity.MatriculaCharla;
import es.csa.fdt.cyldigital.servicios.entity.MatriculaCurso;
import es.csa.fdt.cyldigital.servicios.entity.MatriculaTaller;
import es.csa.fdt.cyldigital.servicios.entity.PracticaTaller;
import es.csa.fdt.cyldigital.servicios.entity.Servicio;
import es.csa.fdt.cyldigital.servicios.entity.ServicioCurso;
import es.csa.fdt.cyldigital.servicios.entity.ServicioTaller;
import es.csa.fdt.cyldigital.servicios.entity.Taller;
import es.csa.fdt.cyldigital.servicios.entity.Tematica;
import es.csa.fdt.cyldigital.servicios.entity.Wifi;
import es.csa.fdt.cyldigital.usuarios.entity.Empleado;
import es.csa.fdt.cyldigital.usuarios.entity.Empleado.Puesto;
import es.csa.fdt.cyldigital.usuarios.entity.Proveedor;
import es.csa.fdt.cyldigital.usuarios.entity.UsuarioCyL;
import es.csa.fdt.cyldigital.usuarios.entity.UsuarioCyL.Sexo;
import es.csa.fdt.cyldigital.usuarios.entity.UsuarioLdap;
import es.csa.fdt.cyldigital.usuarios.entity.UsuarioPre;
import es.csa.fdt.cyldigital.usuarios.service.UsuarioService;

/**
 * @author rsbono
 * @param <E>
 * 
 */
@Component("listingHelperXLSGenerator")
public class ListingHelperXLSGenerator<E> {
	@Autowired
	private UsuarioService service;
	
	//3.4.8 - RF_15_20 Consulta e exportación da información das actividades
	private Date periodoInicio;
	
	private Date periodoFin;
	
	private final int NUMERO_FILAS_HOJA = 65536;

	private EDocumentFormats formato;
	
	private Query q = null;
	
	//private Logger logger = LoggerFactory.getLogger(ReportHelperByCentro.class);
	//private Long startTime;
	
	/**
	 * Constructor
	 */
	public ListingHelperXLSGenerator() {

	}
	
	/**
	 * Devuelve fecha inicio periodo
	 * @return
	 */
	
	public Date getPeriodoInicio() {
		return periodoInicio;
	}
	
	/**
	 * Inicia fecha inicio periodo
	 * @param periodoInicio
	 */
	
	public void setPeriodoInicio(Date periodoInicio) {
		this.periodoInicio = periodoInicio;
	}
	
	/**
	 * Devuelve fecha fin periodo
	 * @return
	 */
	
	public Date getPeriodoFin() {
		return periodoFin;
	}
	
	/**
	 * Inicia fecha fin periodo
	 * @param periodoInicio
	 */
	
	public void setPeriodoFin(Date periodoFin) {
		this.periodoFin = periodoFin;
	}
	
	/**
	 * Devuelve formato 
	 * @return
	 */
	public EDocumentFormats getFormato(){
	    return this.formato;
	}
	
	/**
	 * Inicia formato
	 * @param formato
	 */
	public void setFormato(EDocumentFormats formato){
	    this.formato = formato; 
	}
	
	/*
	 * 
	 */
	private float calculateHours(List<ActividadCalendarItem> laci) {
		Float hours = 0.0F;
		Long milliseconds = 0L;

		for (ActividadCalendarItem aci : laci) {
			milliseconds += aci.getEnd().getTime() - aci.getStart().getTime();
		}

		hours = milliseconds / 3600000.0F;

		return hours;
	}
	
	/*
	 * 
	 */
	private float calculateHoursAsistencia(List<AsistenciaCalendarItem> laci) {
		Float hours = 0.0F;
		Long milliseconds = 0L;

		for (AsistenciaCalendarItem aci : laci) {
			milliseconds += aci.getEnd().getTime() - aci.getStart().getTime();
		}

		hours = milliseconds / 3600000.0F;

		return hours;
	}
	
	private String GetServicioNombre(Servicio s, Locale locale) {
		String idioma = locale.toString();
		//String nombreServicio = "";

		if (s != null) {
			/* 
			 * List<ServicioLanguage> lsl = s.getTextos();
			 * for (ServicioLanguage sl : lsl)
			 * 	if (sl.getLanguage().getISO().compareTo(idioma) == 0)
			 * 		nombreServicio = sl.getNombre();
			 * 
			 * return (nombreServicio);
			 */
			
			Map<String, Object> properties = new HashMap<String, Object>();
			properties.put("servicio.id", s.getId());
			properties.put("language.ISO", idioma);
			
			ServicioLanguage sl = (ServicioLanguage)service.findOneWhere(ServicioLanguage.class, properties);
			
			if (sl != null)
				return(sl.getNombre());
			else
				return("");
		}
		else
			return ("");
	}

	private String GetTematicaNombre(Tematica t, Locale locale) {
		String idioma = locale.toString();
		//String nombreTematica = "";

		if (t != null) {
			/*
			 * List<TematicaLanguage> ltl = t.getTextos();
			 * 
			 * for (TematicaLanguage tl : ltl)
			 * 	if (tl.getLanguage().getISO().compareTo(idioma) == 0)
			 * 		nombreTematica = tl.getNombre();
			 * 
			 * return (nombreTematica);
			 */
			
			Map<String, Object> properties = new HashMap<String, Object>();
			properties.put("tematica.id", t.getId());
			properties.put("language.ISO", idioma);
			
			TematicaLanguage tl = (TematicaLanguage)service.findOneWhere(TematicaLanguage.class, properties);
			
			if (tl != null)
				return(tl.getNombre());
			else
				return "";
		}
		else
			return ("");
	}

	private String GetServicioDescripcion(Servicio s, Locale locale) {
		String idioma = locale.toString();
		//String nombreDescripcion = "";

		if (s != null) {
			/*
			 * List<ServicioLanguage> lsl = s.getTextos();
			 * for (ServicioLanguage sl : lsl)
			 * 	if (sl.getLanguage().getISO().compareTo(idioma) == 0)
			 * 		nombreDescripcion = sl.getDescripcion();
			 * 
			 * return (nombreDescripcion);
			 */
			
			Map<String, Object> properties = new HashMap<String, Object>();
			properties.put("servicio.id", s.getId());
			properties.put("language.ISO", idioma);
			
			ServicioLanguage sl = (ServicioLanguage)service.findOneWhere(ServicioLanguage.class, properties);
			
			if (sl != null)
				return(sl.getNombre());
			else
				return "";
		}
		else
			return ("");
	}

	private String GetActividadApoyo(Curso c, Locale locale) {
		String idioma = locale.toString();
		//String apodo = "";
		
		if (c != null) {
			/*
			 * List<CursoLanguage> lcl = c.getTextosCurso();
			 * 
			 * for (CursoLanguage cl : lcl)
			 * 	if (cl.getLanguage().getISO().compareTo(idioma) == 0)
			 * 		apodo = cl.getApodo();
			 * 
			 * return (apodo);
			 */
			
			Map<String, Object> properties = new HashMap<String, Object>();
			properties.put("curso.id", c.getId());
			properties.put("language.ISO", idioma);
			
			CursoLanguage cl = (CursoLanguage)service.findOneWhere(CursoLanguage.class, properties);
			
			if (cl != null)
				return(cl.getApodo());
			else
				return "";
		}
		else
			return ("");
	}

	private String GetActividadNombre(Charla c, Locale locale) {
		String idioma = locale.toString();
		//String nombreAct = "";
		
		if (c != null) {
			/*
			 * List<CharlaLanguage> lcl = c.getTextosCharla();
			 * 
			 * for (CharlaLanguage cl : lcl)
			 * 	if (cl.getLanguage().getISO().compareTo(idioma) == 0)
			 * 		nombreAct = cl.getNombre();
			 * 
			 * return (nombreAct);
			 */
			
			Map<String, Object> properties = new HashMap<String, Object>();
			properties.put("charla.id", c.getId());
			properties.put("language.ISO", idioma);
			
			CharlaLanguage cl = (CharlaLanguage)service.findOneWhere(CharlaLanguage.class, properties);
			
			if (cl != null)
				return(cl.getNombre());
			else
				return "";
		}
		else
			return ("");
	}

	private String GetActividadExtApodo(ActividadExterna ae, Locale locale) {
		String idioma = locale.toString();
		//String ApodoActExt = "";
		
		if (ae != null) {
			/*
			 * List<ActividadExternaLanguage> laxl = ae.getTextosExterna();
			 * 
			 * for (ActividadExternaLanguage ael : laxl)
			 * 	if (ael.getLanguage().getISO().compareTo(idioma) == 0)
			 * 		ApodoActExt = ael.getApodo();
			 * 
			 * return (ApodoActExt);
			 */
			
			Map<String, Object> properties = new HashMap<String, Object>();
			properties.put("externa.id", ae.getId());
			properties.put("language.ISO", idioma);
			
			ActividadExternaLanguage ael = (ActividadExternaLanguage)service.findOneWhere(ActividadExternaLanguage.class, properties);
			
			if (ael != null)
				return(ael.getApodo());
			else
				return "";
		}
		else
			return ("");
	}

	private String GetServicioGuionPdf(ServicioCurso sc, Locale locale) {
		String idioma = locale.toString();
		//String nombrePdf = "";

		if (sc != null) {
			/*
			 * List<ServicioCursoLanguage> lscl = sc.getGuiones();
			 * 
			 * for (ServicioCursoLanguage scl : lscl)
			 * 	if (scl.getLanguage().getISO().compareTo(idioma) == 0)
			 * 		nombrePdf = (scl.getGuionPdf() != null) ? scl.getGuionPdf().getNombre() : "NO";
			 * 
			 * return (nombrePdf);
			 */
			
			Map<String, Object> properties = new HashMap<String, Object>();
			properties.put("servicioCurso.id", sc.getId());
			properties.put("language.ISO", idioma);
			
			ServicioCursoLanguage scl = (ServicioCursoLanguage)service.findOneWhere(ServicioCursoLanguage.class, properties);
			
			if (scl != null)
				return((scl.getGuionPdf() != null) ? scl.getGuionPdf().getNombre() : "NO");
			else
				return "";
		}
		else
			return ("");
	}

	/*
	 * 
	 */
	private List<Incidencia> getIncidenciasVisibles(List<Incidencia> incidencias2) {
		List<Incidencia> incidencias = new ArrayList<Incidencia>();
		UsuarioLdap u = (UsuarioLdap) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
		
		Empleado e = (Empleado)service.find(Empleado.class, u.getUser().getId());

		if (u.getUser() instanceof Empleado) {
			for (Incidencia incidencia : incidencias2) {
				if (incidencia.getCategoriaIncidencia().isEspecial()) {
					if (e.getPuesto().equals(Puesto.ADMIN)
							|| e.getCategoriasIncidencia().contains(incidencia.getCategoriaIncidencia()))
						incidencias.add(incidencia);
				}
				else if (e.getPuesto().equals(Puesto.ADMIN) || e.getPuesto().equals(Puesto.MANAGER)
						|| e.getPuesto().equals(Puesto.TRAINER_COORDINATOR) || e.isResponsableIncidencias())
					incidencias.add(incidencia);
				else if (e.getPuesto().equals(Puesto.INFORMER) || e.getPuesto().equals(Puesto.TRAINER)
						|| e.getPuesto().equals(Puesto.EXTERNAL_PERSONAL)) {
					if (e.getCategoriasIncidencia().contains(incidencia.getCategoriaIncidencia())
							|| e.equals(incidencia.getUsuario()))
						incidencias.add(incidencia);
				}
				else if (e.getPuesto().equals(Puesto.AREA_MANAGER)) {
					if (e.getCategoriasIncidencia().contains(incidencia.getCategoriaIncidencia())
							|| e.equals(incidencia.getUsuario()) || e.getCentro().equals(incidencia.getCentro()))
						incidencias.add(incidencia);
				}
				else if (e.getPuesto().equals(Puesto.DIGITAL_ALLY_MANAGER)) {
					if (e.getCategoriasIncidencia().contains(incidencia.getCategoriaIncidencia())
							|| e.equals(incidencia.getUsuario()) || e.getCentro().equals(incidencia.getCentro()))
						incidencias.add(incidencia);
				}
			}
		}
		
		return incidencias;
	}
	
	private boolean isContain(String ci, String cis){
        String pattern = "\\b"+ci+"\\b";
        Pattern p=Pattern.compile(pattern);
        Matcher m=p.matcher(cis);
        return m.find();
   }
	
	
	/*
	 * Generar documento.
	 * 
	 * @param out
	 *            out
	 * @param cabeceras
	 *            cabeceras
	 * @param datos
	 *            datos
	 * @param nombreElemento
	 *            nombre elemento
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarDocumento(OutputStream out, List<String> cabeceras, List<List<Object>> datos, String nombreElemento) throws IOException {
	    
	    if (this.getFormato() == EDocumentFormats.XLS){
	    	generarXls(out, cabeceras, datos, nombreElemento);
	    }
	    else if (this.getFormato() == EDocumentFormats.CSV){
	    	generarCSV(out, cabeceras, datos, nombreElemento);
	    }
	    else{
	    	generarXls(out, cabeceras, datos, nombreElemento);
	    }
	    return;
	}
	
	/*
	 * Generar xls.
	 * 
	 * @param out
	 *            out
	 * @param cabeceras
	 *            cabeceras
	 * @param datos
	 *            datos
	 * @param nombreElemento
	 *            nombre elemento
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXls(OutputStream out, List<String> cabeceras, List<List<Object>> datos, String nombreElemento) throws IOException {

	    // Crear un libro de trabajo
	    HSSFWorkbook libro = new HSSFWorkbook();
		
	    // Declarar una referencia a fila
	    HSSFRow fila = null;
		
	    // Declarar una referencia a celda
	    HSSFCell celda = null;
		
	    // Declalar una referencia a un estilo de celda
	    HSSFCellStyle estiloDefault;
	    HSSFCellStyle estiloCabecera;
	    HSSFCellStyle estiloNumeroSinDec;
	    HSSFCellStyle estiloNumeroConDec;
	    HSSFCellStyle estiloFecha;
		
	    // Crear un manejador de formatos
	    HSSFDataFormat formato = libro.createDataFormat();
		
	    // Se definen los estilos
	    estiloDefault = libro.createCellStyle();
		
	    estiloCabecera = libro.createCellStyle();
	    HSSFFont oFont = libro.createFont();
	    oFont.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
	    estiloCabecera.setFont(oFont);
		
	    estiloNumeroSinDec = libro.createCellStyle();
	    estiloNumeroSinDec.setDataFormat(formato.getFormat("0"));
		
	    estiloNumeroConDec = libro.createCellStyle();
	    estiloNumeroConDec.setDataFormat(formato.getFormat("###########0.00"));
		
	    estiloFecha = libro.createCellStyle();
	    estiloFecha.setDataFormat(formato.getFormat("dd/mm/yyyy hh:MM"));
		
	    int n_fila = 0; //Numero de fila
	    int n = 0; //Numero de hoja
	    
	    while (n_fila < datos.size()){
	    	HSSFSheet hoja = libro.createSheet();
	    	libro.setSheetName(n,  "Hoja - " + (n+1));
	    	
	    	//Crear la primera fila con el nombre del elemento (fila 0)
	    	fila = hoja.createRow(0);
	    	celda = fila.createCell(0);
	    	celda.setCellValue(new HSSFRichTextString(nombreElemento));
	    	celda.setCellStyle(estiloCabecera);
    
	    	// Crear la segunda fila de cabeceras (fila 1)
	    	fila = hoja.createRow(1);
			int i = 0;
			for (String cabecera : cabeceras) {
			    celda = fila.createCell(i);
			    celda.setCellValue(new HSSFRichTextString(cabecera));
			    celda.setCellStyle(estiloCabecera);
			    i++;
			}
      
			// Rellenar los datos
			int iRow = 2; // Numero de fila inicial en la hoja

			// Para cada cuestionario crear una nueva fila
			while (iRow < NUMERO_FILAS_HOJA && n_fila < datos.size()) {
			    fila = hoja.createRow(iRow);
			    List<Object> row = datos.get(n_fila);
			    int s = 0;//Numero de celda
			    for (Object dato : row) {
				celda = fila.createCell(s);
    
				if (dato == null)
				    celda.setCellType(HSSFCell.CELL_TYPE_BLANK);
					else if (dato instanceof String) {
					    celda.setCellValue(new HSSFRichTextString((String) dato));
					} else if (dato instanceof Integer) {					
					    celda.setCellStyle(estiloNumeroSinDec);
					    celda.setCellValue(((Integer) dato).doubleValue());
					} else if (dato instanceof Float) {
					    //estilo = libro.createCellStyle();
					    //estilo.setDataFormat(formato.getFormat("###########0.00"));					
					    celda.setCellValue(((Float) dato));					
					    celda.setCellStyle(estiloNumeroConDec);
					} else if (dato instanceof Long) {
					    //estilo = libro.createCellStyle();
					    //estilo.setDataFormat(formato.getFormat("############"));					
					    celda.setCellValue(((Long) dato));					
					    celda.setCellStyle(estiloNumeroSinDec);
					} else if (dato instanceof Double) {
					    //estilo = libro.createCellStyle();
					    //estilo.setDataFormat(formato.getFormat("###########0.00"));					
					    celda.setCellValue(((Double) dato));					
					    celda.setCellStyle(estiloNumeroConDec);
					} else if (dato instanceof Date) {
					    //estilo = libro.createCellStyle();
					    //estilo.setDataFormat(forma	to.getFormat("dd/mm/yyyy hh:MM"));					
					    celda.setCellValue((Date) dato);					
					    celda.setCellStyle(estiloFecha);
					}
					s++; 
			    }
			    iRow++; //Numero de fila en la hoja
			    n_fila++;
		    }
			n++; // Numero de hoja
	    	}
	    libro.write(out);
	    return;
	}

	/*
	 * Generar csv.
	 * 
	 * @param out
	 *            out
	 * @param cabeceras
	 *            cabeceras
	 * @param datos
	 *            datos
	 * @param nombreElemento
	 *            nombre elemento
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarCSV(OutputStream out, List<String> cabeceras, List<List<Object>> datos, String nombreElemento) throws IOException {
		
	    StringBuilder csv = new StringBuilder();
	    csv.append(nombreElemento);
	    csv.append("\n");
	    for (String cabecera : cabeceras) {
	    	csv.append("\"");
			csv.append(cabecera);
			csv.append("\"");
			csv.append(";");
	    }
	    csv.append("\n");
	    for (List<Object> row: datos){
		for(Object dato : row){		    
		    if (dato == null){
		    } else if (dato instanceof String) {
		    	csv.append("\"");
		    	csv.append((String)dato);
		    	csv.append("\"");
		    } else if (dato instanceof Integer) {
		    	String sDato = dato.toString();
		    	sDato.replaceAll(".", ",");
		    	csv.append(sDato);
		    } else if (dato instanceof Float) {
		    	String sDato = dato.toString();
		    	sDato.replaceAll(".", ",");
		    	csv.append(sDato);
		    } else if (dato instanceof Long) {
		    	String sDato = dato.toString();
		    	sDato.replaceAll(".", ",");
		    	csv.append(sDato);
		    } else if (dato instanceof Double) {
		    	String sDato = dato.toString();
		    	sDato.replaceAll(".", ",");
		    	csv.append(sDato);
		    } else if (dato instanceof Date) {
		    	String sDato = dato.toString();
		    	csv.append(sDato);
		    }
		    csv.append(";");		    
		   }
		csv.append("\n");
	    }
	    out.write(csv.toString().getBytes(Charsets.ISO_8859_1));
	    return;
	}
	
	/*
	 * Recoge los datos de todos los cursos, o los próximos, o cursos con plazas
	 * libres.
	 * 
	 * @param cursos
	 *            Cursos a exportar.
	 * @param out
	 *            out
	 * @param proximos
	 *            Filtro de cursos no empezados.
	 * @param conPlaza
	 *            Filtro de cursos con plazas libres.
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	@SuppressWarnings("unchecked")
	private void generarXlsCursos(List<Curso> cursos, Long indPlazasLibres, boolean proximos, boolean conPlaza, Locale locale, OutputStream out) throws IOException {
		String nombreTematicaXlsCurso = "";

		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		DateFormat hourformatter = new SimpleDateFormat("HH:mm", locale);
		DateFormat dateformatter = new SimpleDateFormat("dd/MM/yyyy", locale);

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add(res.getString("excel.Servicio"));
		cabeceras.add(res.getString("excel.Apodo"));
		cabeceras.add(res.getString("excel.Centro"));
		cabeceras.add(res.getString("excel.Profesor"));
		cabeceras.add(res.getString("excel.Area"));
		cabeceras.add(res.getString("excel.PlazTotales"));
		cabeceras.add(res.getString("excel.PlazLibres"));
		cabeceras.add(res.getString("excel.PlazSolicitadas"));
		cabeceras.add(res.getString("excel.Asistentes"));
		cabeceras.add(res.getString("excel.Estado"));
		cabeceras.add(res.getString("excel.FInicio"));
		cabeceras.add(res.getString("excel.FFin"));
		cabeceras.add(res.getString("excel.HInicio"));
		cabeceras.add(res.getString("excel.HFin"));
		cabeceras.add(res.getString("excel.HPeriodo"));
		cabeceras.add(res.getString("excel.HTotales"));
		cabeceras.add(res.getString("excel.Tipologia"));
		cabeceras.add(res.getString("excel.IniciativaSingular"));
		cabeceras.add(res.getString("excel.Videoconferencia"));
		cabeceras.add(res.getString("excel.Valoracion"));

		for (Curso c : cursos) {
			// Si se quieren TODOS los cursos, o solo los que tienen plazas
			// libres, o los cursos que no han empezado.
			if ((!proximos || (c.getFechaInicio().getTime() >= (new Date()).getTime()))
					&& (!conPlaza || (c.getNumeroInscritos() < c.getNumeroPlazas()))) {
				
				//indPlazasLibres (0-todos;1-Si;2-No)
				//Filtramos segun el parametro de indicadores
				if(indPlazasLibres.longValue()==1){
					if(c.getNumeroInscritos() >= c.getNumeroPlazas())
						continue;
				}					
				else if(indPlazasLibres.longValue()==2){
					if(c.getNumeroInscritos() < c.getNumeroPlazas())
						continue;
				}									
				
				List<Object> row = new ArrayList<Object>();
				
				//Hibernate.initialize(c.getCentro());
				//Hibernate.initialize(c.getProfesor());
				//Hibernate.initialize(c.getAula());
				//Hibernate.initialize(c.Servicio());
				//Hibernate.initialize(c.Servicio().getTematica());
				
				row.add(c.getId());
				row.add((String)GetServicioNombre(c.getServicio(), locale));
				row.add((String)GetActividadApoyo(c, locale));
				row.add(c.getCentro().getNombre());
				row.add(c.getProfesor() != null ? c.getProfesor().getNombreCompleto() : res.getString("excel.NoDef"));
				row.add(c.getAula() != null ? c.getAula().getNombre() : res.getString("excel.NoDef"));
				row.add(c.getNumeroPlazas());
				row.add(c.getNumeroPlazas() - c.getNumeroConfirmados());
				row.add(c.getNumeroListaEsperaWeb());
				// 3.4.8 - RF_15_20
				row.add(c.getNumeroAsistentes());
				row.add(c.isCerrada() ? res.getString("excel.EstadoCerrado") : res.getString("excel.EstadoAbierto"));
				//row.add(c.isCerrada() ? c.getNumeroAsistentes() : "Abierto");
				row.add(dateformatter.format(c.getFechaInicio()));
				row.add(dateformatter.format(c.getFechaFin()));
				row.add(hourformatter.format(c.getHoraInicio()));
				row.add(hourformatter.format(c.getHoraFin()));
				// 3.4.8 - RF_15_20
				//Calculo del número de horas del periodo
				q = service.getEntityManager().createQuery(
						"SELECT a " + 
						"FROM " + ActividadCalendarItem.class.getName() + " a " + 
						"WHERE a.actividad.id = ? AND a.start <= ? AND a.end >= ?");
				q.setParameter(1, c.getId());
				q.setParameter(2, (periodoFin != null ? periodoFin : c.getFechaFin()));
				q.setParameter(3, (periodoInicio != null ? periodoInicio : c.getFechaInicio()));
				
				row.add(q.getResultList() == null ? 0 : calculateHours((List<ActividadCalendarItem>)q.getResultList()));
				row.add(c.getNumeroHoras());

				nombreTematicaXlsCurso = (c.getServicio().getTematica() != null) ? GetTematicaNombre(c.getServicio().getTematica(), locale) : "";
				row.add(nombreTematicaXlsCurso);

				row.add(c.isIniciativaSingular() ? res.getString("excel.Si") : res.getString("excel.No"));
				row.add(c.isVideoconferencia() ? res.getString("excel.Si") : res.getString("excel.No"));
				
				row.add(c.getValoracion());

				datos.add(row);
			}
		}

		generarDocumento(out, cabeceras, datos, "Cursos");
	}

	/*
	 * Recoge los datos de todos los talleres, o los próximos, o talleres con
	 * plazas libres.
	 * 
	 * @param talleres
	 *            Talleres a exportar.
	 * @param out
	 *            out
	 * @param proximos
	 *            Filtro de talleres no empezados.
	 * @param conPlaza
	 *            Filtro de talleres con plazas libres.
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsTalleres(List<Taller> talleres, boolean proximos, boolean conPlaza, Locale locale, OutputStream out) throws IOException {

		String nombreServicioXlsTalleres = "";
		String nombreTematicaXlsTalleres = "";

		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		DateFormat hourformatter = new SimpleDateFormat("HH:mm", locale);
		DateFormat dateformatter = new SimpleDateFormat("dd/MM/yyyy", locale);

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add("Servicio");
		cabeceras.add("Apodo");
		cabeceras.add("Centro");
		cabeceras.add("Profesor");
		cabeceras.add("Plazas totales");
		cabeceras.add("Plazas libres");
		cabeceras.add("Plazas libres en reserva");
		cabeceras.add("Asistentes");
		cabeceras.add("Fecha de inicio");
		cabeceras.add("Fecha de fin");
		cabeceras.add("Hora de inicio");
		cabeceras.add("Hora de fin");
		cabeceras.add("Temática");

		for (Taller t : talleres) {
			// Si se quieren TODOS los talleres, o solo los que tienen plazas
			// libres, o los talleres que no han empezado.
			if ((!proximos || t.getFechaInicio().getTime() >= (new Date()).getTime())
					&& (!conPlaza || t.getNumeroInscritos() < t.getNumeroPlazas())) {
				List<Object> row = new ArrayList<Object>();

				row.add(t.getIdTaller());
				
				nombreServicioXlsTalleres = GetServicioNombre(t.getServicio(), locale);
				row.add(nombreServicioXlsTalleres);
				
				row.add(t.getApodo());
				row.add(t.getCentro().getNombre());
				row.add(t.getProfesor() != null ? t.getProfesor().getNombreCompleto() : "no definido");
				row.add(t.getNumeroPlazas());
				row.add(t.getNumeroPlazas() - t.getNumeroInscritos());
				row.add(t.getNumeroPlazasListaEspera() - (t.getNumeroInscritos() - t.getNumeroMatriculados()));
				row.add(t.isCerrada() ? t.getNumeroAsistentes() : "Abierto");
				row.add(dateformatter.format(t.getFechaInicio()));
				row.add(dateformatter.format(t.getFechaFin()));
				row.add(hourformatter.format(t.getHoraInicio()));
				row.add(hourformatter.format(t.getHoraFin()));

				nombreTematicaXlsTalleres = GetTematicaNombre(t.getServicio().getTematica(), locale);
				row.add((t.getServicio().getTematica() != null) ? nombreTematicaXlsTalleres : "");

				datos.add(row);
			}
		}
		generarDocumento(out, cabeceras, datos, "Talleres");
	}

	/*
	 * Generar xls charlas.
	 * 
	 * @param charlas
	 *            charlas
	 * @param out
	 *            out
	 * @param proximos
	 *            proximos
	 * @param conPlaza
	 *            con plaza
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	@SuppressWarnings("unchecked")
	private void generarXlsCharlas(List<Charla> charlas, Long indPlazasLibres, boolean proximos, boolean conPlaza, Locale locale, OutputStream out) throws IOException {
		String nombreActividadXlsCharla = "";
		String nombreTematicaXlsCharlas = "";

		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();
		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		DateFormat hourformatter = new SimpleDateFormat("HH:mm", locale);
		DateFormat dateformatter = new SimpleDateFormat("dd/MM/yyyy", locale);

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add(res.getString("excel.Nombre"));
		cabeceras.add(res.getString("excel.Centro"));
		cabeceras.add(res.getString("excel.Profesor"));
		cabeceras.add(res.getString("excel.Area"));
		cabeceras.add(res.getString("excel.PlazTotales"));
		cabeceras.add(res.getString("excel.PlazLibres"));
		cabeceras.add(res.getString("excel.PlazSolicitadas"));
		cabeceras.add(res.getString("excel.Asistentes"));
		cabeceras.add(res.getString("excel.Estado"));
		cabeceras.add(res.getString("excel.FInicio"));
		cabeceras.add(res.getString("excel.FFin"));
		cabeceras.add(res.getString("excel.HInicio"));
		cabeceras.add(res.getString("excel.HFin"));
		cabeceras.add(res.getString("excel.HPeriodo"));
		cabeceras.add(res.getString("excel.HTotales"));
		cabeceras.add(res.getString("excel.Tipologia"));
		cabeceras.add(res.getString("excel.IniciativaSingular"));
		cabeceras.add(res.getString("excel.Videoconferencia"));

		for (Charla c : charlas) {
			// Si se quieren TODAS las charlas, o solo las que tienen plazas
			// libres, o las charlas que no han empezado.
			if ((!proximos || (c.getFechaInicio().getTime() >= (new Date())
					.getTime()))
					&& (!conPlaza || (c.getNumeroInscritos() < c
							.getNumeroPlazas()))) {
				
				//indPlazasLibres (0-todos;1-Si;2-No)
				//Filtramos segun el parametro de indicadores
				if(indPlazasLibres.longValue()==1){
					if(c.getNumeroInscritos() >= c.getNumeroPlazas())
						continue;
				}					
				else if(indPlazasLibres.longValue()==2){
					if(c.getNumeroInscritos() < c.getNumeroPlazas())
						continue;
				}	
				
				List<Object> row = new ArrayList<Object>();

				row.add(c.getId());

				nombreActividadXlsCharla = GetActividadNombre(c, locale);
				row.add(nombreActividadXlsCharla);

				row.add(c.getCentro().getNombre());
				row.add(c.getProfesor() != null ? c.getProfesor()
						.getNombreCompleto() : res.getString("excel.NoDef"));
				row.add(c.getAula() != null ? c.getAula().getNombre() : res
						.getString("excel.NoDef"));
				row.add(c.getNumeroPlazas());
				row.add(c.getNumeroPlazas() - c.getNumeroConfirmados());
				row.add(c.getNumeroListaEsperaWeb());
				// 3.4.8 - RF_15_20
				row.add(c.getNumeroAsistentes());
				row.add(c.isCerrada() ? res.getString("excel.EstadoCerrado") : res.getString("excel.EstadoAbierto"));
				//row.add(c.isCerrada() ? c.getNumeroAsistentes() : "Abierto");
				row.add(dateformatter.format(c.getFechaInicio()));
				row.add(dateformatter.format(c.getFechaFin()));
				row.add(hourformatter.format(c.getHoraInicio()));
				row.add(hourformatter.format(c.getHoraFin()));
				// 3.4.8 - RF_15_20
				//Calculo del número de horas del periodo
				q = service.getEntityManager().createQuery(
						"SELECT a " + 
						"FROM " + ActividadCalendarItem.class.getName() + " a " + 
						"WHERE a.actividad.id = ? AND a.start <= ? AND a.end >= ?");
				q.setParameter(1, c.getId());
				q.setParameter(2, (periodoFin != null ? periodoFin : c.getFechaFin()));
				q.setParameter(3, (periodoInicio != null ? periodoInicio : c.getFechaInicio()));
				
				row.add(q.getResultList() == null ? 0 : calculateHours((List<ActividadCalendarItem>)q.getResultList()));
				row.add(calculateHours(c.getCalendarItems()));

				nombreTematicaXlsCharlas = GetTematicaNombre(c.getTematica(), locale);
				row.add((c.getTematica() != null) ? nombreTematicaXlsCharlas
						: "no definida");

				row.add(c.isIniciativaSingular() ? res.getString("excel.Si") : res.getString("excel.No"));
				row.add(c.isVideoconferencia() ? res.getString("excel.Si") : res.getString("excel.No"));
				
				datos.add(row);
			}
		}

		generarDocumento(out, cabeceras, datos, "Charlas");
	}

	/*
	 * Generar xls curso.
	 * 
	 * @param c
	 *            c
	 * @param out
	 *            out
	 * @param nombreCurso
	 *            nombre curso
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsCurso(Curso c, String nombreCurso, Locale locale, OutputStream out) throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		// Cabecearas
		cabeceras.add(res.getString("excel.FechaMatriculacion"));
		cabeceras.add(res.getString("excel.PreMatriculadoWeb"));
		cabeceras.add(res.getString("excel.EstadoMatricula"));
		cabeceras.add(res.getString("excel.Asistencia"));
		cabeceras.add(res.getString("excel.Nota"));
		cabeceras.add(res.getString("excel.UserId"));
		cabeceras.add(res.getString("excel.Username"));
		cabeceras.add(res.getString("excel.Extranjero"));
		cabeceras.add(res.getString("excel.Nif"));
		cabeceras.add(res.getString("excel.Nombre"));
		cabeceras.add(res.getString("excel.Apellido1"));
		cabeceras.add(res.getString("excel.Apellido2"));
		cabeceras.add(res.getString("excel.Edad"));
		cabeceras.add(res.getString("excel.Menor14SinNif"));
		cabeceras.add(res.getString("excel.NifAutorizador"));
		cabeceras.add(res.getString("excel.NombreAutorizador"));
		cabeceras.add(res.getString("excel.Sexo"));
		cabeceras.add(res.getString("excel.FechaAlta"));
		cabeceras.add(res.getString("excel.Centro"));
		cabeceras.add(res.getString("excel.Direccion"));
		cabeceras.add(res.getString("excel.CP"));
		cabeceras.add(res.getString("excel.Provincia"));
		cabeceras.add(res.getString("excel.Localidad"));
		cabeceras.add(res.getString("excel.Telefonos"));
		cabeceras.add(res.getString("excel.Email"));
		cabeceras.add(res.getString("excel.PadeceDiscapacidad"));
		cabeceras.add(res.getString("excel.TieneOrdeandor"));
		cabeceras.add(res.getString("excel.TieneAccesoInternet"));
		cabeceras.add(res.getString("excel.TipoUsuario"));
		cabeceras.add(res.getString("excel.MedioPublicidad"));
		cabeceras.add(res.getString("excel.MedioPublicidadOtro"));
		cabeceras.add(res.getString("excel.FrecuenciaInternet"));
		cabeceras.add(res.getString("excel.UtilidadInternet"));
		cabeceras.add(res.getString("excel.SoftwareLibre"));
		cabeceras.add(res.getString("excel.Ocupacion"));
		cabeceras.add(res.getString("excel.Colectivo"));
		cabeceras.add(res.getString("excel.SectorProfesional"));
		cabeceras.add(res.getString("excel.Estudios"));
		cabeceras.add(res.getString("excel.ComunicacionTlf"));
		cabeceras.add(res.getString("excel.ComunicacionEmail"));
		cabeceras.add(res.getString("excel.CesionDatos"));

		// Datos
		for (MatriculaCurso m : c.getMatriculas()) {
			List<Object> row = new ArrayList<Object>();

			UsuarioCyL u = (UsuarioCyL)service.find(UsuarioCyL.class, m.getUsuario().getId());

			row.add(m.getFechaMatricula());
			row.add(m.isPreMatriculadoWeb() ? res.getString("excel.Si") : res.getString("excel.No"));

			if (m.isPreMatriculadoWeb() && m.isEnListaEspera() && !m.isAdmitido())
				row.add(res.getString("excel.EstadoMatriculaEspera"));
			else if (!m.isEnListaEspera() && m.isAdmitido())
				row.add(res.getString("excel.EstadoMatriculaMatriculado"));
			else if (!m.isEnListaEspera() && !m.isAdmitido() && !m.isCancelada())
				row.add(res.getString("excel.EstadoMatriculaRechazado"));
			else if(!m.isEnListaEspera() && !m.isAdmitido() && m.isCancelada())
				row.add(res.getString("excel.EstadoMatriculaCancelado"));

			row.add(m.getAsistencia() + "%");
			row.add(m.getNota());
			row.add(u.getId());
			row.add(u.getUsername());
			row.add(u.isExtranjero() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isExtranjero() ? u.getPasaporte() : u.getNif());
			row.add(u.getNombre());
			row.add(u.getApellido1());
			row.add(u.getApellido2());
			row.add(u.getEdad());
			row.add(u.isMenor() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add((u.getNifAutorizado() != null) ? u.getNifAutorizado() : "");
			row.add((u.getNombreCompletoAutorizado() != null) ? u
					.getNombreCompletoAutorizado() : "");
			row.add(u.getSexo().equals(Sexo.H) ? res.getString("excel.Hombre")
					: res.getString("excel.Mujer"));
			row.add(u.getFechaCreacion());
			row.add(u.getCentro().getNombre());
			row.add((u.getDireccion() != null) ? u.getDireccion() : "");
			row.add((u.getCp() != null) ? u.getCp() : "");
			row.add(((u.getProvincia() == null) || (u.getProvincia().getId() == 0)) ? "N/A" : u.getProvincia().getNombre());
			row.add(((u.getLocalidad() == null) || (u.getLocalidad().getId() == 0)) ? "N/A" : u.getLocalidad().getNombre());
			row.add(u.getTelefonos());
			row.add(u.getEmail());
			row.add(res.getString("excel.PadeceDiscapacidad." + u.getTipoDiscapacidad().toString()));
			row.add(u.isPoseeOrdenador() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isAccesoInternet() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(res.getString("excel.TipoUsuario." + u.getTipoUsuario().toString()));
			row.add(res.getString("excel.MedioPublicidad." + u.getMedioPublicidad().toString()));
			row.add((u.getMedioPublicidadOtro() != null) ? u.getMedioPublicidadOtro() : "");
			row.add(res.getString("excel.FrecuenciaInternet." + u.getTipoFrecuenciaInternet().toString()));
			row.add((u.getTipoUtilidadInternet() != null) ? res.getString("excel.UtilidadInternet." + u.getTipoUtilidadInternet().toString()) : "N/A");
			row.add((u.getTipoUtilizarSwLibre() == UsuarioCyL.TipoUtilizarSwLibre.SI) ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(res.getString("excel.Ocupacion." + u.getTipoOcupacion().toString()));
			row.add(res.getString("excel.Colectivo." + u.getTipoColectivo().toString()));
			row.add((u.getTipoSectorProfesional() != null) ? res.getString("excel.SectorProfesional." + u.getTipoSectorProfesional().toString()) : "N/A");
			row.add(res.getString("excel.Estudios." + u.getTipoEstudiosRealizados().toString()));
			row.add(u.iscomunicacionTlf() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.iscomunicacionMail() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isCesionPermitida() ? res.getString("excel.Si") : res.getString("excel.No"));

			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, nombreCurso);
	}

	/*
	 * Generar xls taller.
	 * 
	 * @param t
	 *            t
	 * @param out
	 *            out
	 * @param nombreTaller
	 *            nombre taller
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsTaller(Taller t, String nombreTaller, Locale locale, OutputStream out) throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();
		
		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		// Cabecearas
		cabeceras.add("Fecha de matrícula");
		cabeceras.add("IdUsuario");
		cabeceras.add("Nombre");
		cabeceras.add("Apellido1");
		cabeceras.add("Apellido2");
		cabeceras.add("Confirmado");
		cabeceras.add("Asistencia");
		cabeceras.add("Nota");

		// Datos
		for (MatriculaTaller m : t.getMatriculas()) {
			List<Object> row = new ArrayList<Object>();
			
			row.add(m.getFechaMatricula());
			row.add(m.getUsuario().getId());
			row.add(m.getUsuario().getNombre());
			row.add(m.getUsuario().getApellido1());
			row.add(m.getUsuario().getApellido2());
			row.add(m.isAdmitido() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(m.getAsistencia());
			row.add(m.getNota());
			
			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, nombreTaller);
	}

	/*
	 * Generar xls servicios cursos.
	 * 
	 * @param t
	 *            t
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsServiciosCursos(List<ServicioCurso> t, Locale locale, OutputStream out) throws IOException {
		String nombreServicioXlsServiciosCursos = "";
		String nombreTematicaXlsServiciosCursos = "";
		String descripcionXlsServiciosCursos = "";

		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();
		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		// Cabecearas
		cabeceras.add("ID");
		cabeceras.add(res.getString("excel.Nombre"));
		cabeceras.add(res.getString("excel.NivelDificultad"));

		//cabeceras.add(res.getString("excel.UsuInteresados"));
		cabeceras.add(res.getString("excel.DisponibleColaborador"));
		cabeceras.add(res.getString("excel.AjenoPlanFormativo"));
		cabeceras.add(res.getString("excel.Tipologia"));
		cabeceras.add(res.getString("excel.CodigoJunta"));
		cabeceras.add(res.getString("excel.Descripcion"));
		cabeceras.add(res.getString("excel.Guion"));

		// Datos
		for (ServicioCurso m : t) {
			List<Object> row = new ArrayList<Object>();

			row.add(m.getId());

			nombreServicioXlsServiciosCursos = GetServicioNombre(m, locale);
			row.add(nombreServicioXlsServiciosCursos);

			if (m.getNivel().name() == "A")
				row.add(res.getString("nivel.A"));
			else if (m.getNivel().name() == "B")
				row.add(res.getString("nivel.B"));
			else
				row.add(res.getString("nivel.M"));

			row.add(m.isDisponibleColaborador() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(m.isAjenoPlanFormativo() ? res.getString("excel.Si") : res.getString("excel.No"));

			/*
			 * row.add(m.getNumeroPreinscripciones()); se filtran los desactivados
			 */

			nombreTematicaXlsServiciosCursos = GetTematicaNombre(m.getTematica(), locale);
			row.add((m.getTematica() != null) ? nombreTematicaXlsServiciosCursos : "");

			row.add(m.getCodigoJunta());

			descripcionXlsServiciosCursos = GetServicioDescripcion(m, locale);
			row.add(descripcionXlsServiciosCursos);

			String GuionPdf = GetServicioGuionPdf(m, locale);
			row.add(GuionPdf);

			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, "Servicios de Cursos");
	}

	/*
	 * Generar xls servicios talleres.
	 * 
	 * @param t
	 *            t
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsServiciosTalleres(List<ServicioTaller> t, Locale locale, OutputStream out) throws IOException {

		String nombreServicioXlsServiciosTalleres = "";
		String nombreTematicaXlsServiciosTalleres = "";
		String descripcionXlsServiciosTalleres = "";

		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		// Cabecearas
		cabeceras.add("ID");
		cabeceras.add("Nombre");
		cabeceras.add("Nivel de dificultad");
		cabeceras.add("Usuarios Interesados");
		cabeceras.add("Temática");
		cabeceras.add("Código de la Junta");
		cabeceras.add("Descripción");
		cabeceras.add("Guión");

		// Datos
		for (ServicioTaller m : t) {
			List<Object> row = new ArrayList<Object>();
			
			row.add(m.getIdServicioTaller());

			nombreServicioXlsServiciosTalleres = GetServicioNombre(m, locale);
			row.add(nombreServicioXlsServiciosTalleres);

			row.add((m.getNivel().name()));
			row.add(m.getNumeroPreinscripciones());

			nombreTematicaXlsServiciosTalleres = GetTematicaNombre(m.getTematica(), locale);
			row.add((m.getTematica() != null) ? nombreTematicaXlsServiciosTalleres : "");

			row.add(m.getCodigoJunta());
			
			descripcionXlsServiciosTalleres = GetServicioDescripcion(m, locale);
			row.add(descripcionXlsServiciosTalleres);

			//String GuionPdf = GetServicioGuionPdf(m, locale);
			//row.add(GuionPdf);

			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, "Servicios de Talleres");
	}

	/*
	 * Generar xls charla.
	 * 
	 * @param c
	 *            c
	 * @param out
	 *            out
	 * @param nombreCharla
	 *            nombre charla
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsCharla(Charla c, String nombreCharla, Locale locale, OutputStream out)
			throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		// Cabecearas
		cabeceras.add(res.getString("excel.FechaMatriculacion"));
		cabeceras.add(res.getString("excel.PreMatriculadoWeb"));
		cabeceras.add(res.getString("excel.EstadoMatricula"));
		cabeceras.add(res.getString("excel.Asistencia"));
		cabeceras.add(res.getString("excel.UserId"));
		cabeceras.add(res.getString("excel.Username"));
		cabeceras.add(res.getString("excel.Extranjero"));
		cabeceras.add(res.getString("excel.Nif"));
		cabeceras.add(res.getString("excel.Nombre"));
		cabeceras.add(res.getString("excel.Apellido1"));
		cabeceras.add(res.getString("excel.Apellido2"));
		cabeceras.add(res.getString("excel.Edad"));
		cabeceras.add(res.getString("excel.Menor14SinNif"));
		cabeceras.add(res.getString("excel.NifAutorizador"));
		cabeceras.add(res.getString("excel.NombreAutorizador"));
		cabeceras.add(res.getString("excel.Sexo"));
		cabeceras.add(res.getString("excel.FechaAlta"));
		cabeceras.add(res.getString("excel.Centro"));
		cabeceras.add(res.getString("excel.Direccion"));
		cabeceras.add(res.getString("excel.CP"));
		cabeceras.add(res.getString("excel.Provincia"));
		cabeceras.add(res.getString("excel.Localidad"));
		cabeceras.add(res.getString("excel.Telefonos"));
		cabeceras.add(res.getString("excel.Email"));
		cabeceras.add(res.getString("excel.PadeceDiscapacidad"));
		cabeceras.add(res.getString("excel.TieneOrdeandor"));
		cabeceras.add(res.getString("excel.TieneAccesoInternet"));
		cabeceras.add(res.getString("excel.TipoUsuario"));
		cabeceras.add(res.getString("excel.MedioPublicidad"));
		cabeceras.add(res.getString("excel.MedioPublicidadOtro"));
		cabeceras.add(res.getString("excel.FrecuenciaInternet"));
		cabeceras.add(res.getString("excel.UtilidadInternet"));
		cabeceras.add(res.getString("excel.SoftwareLibre"));
		cabeceras.add(res.getString("excel.Ocupacion"));
		cabeceras.add(res.getString("excel.Colectivo"));
		cabeceras.add(res.getString("excel.SectorProfesional"));
		cabeceras.add(res.getString("excel.Estudios"));
		cabeceras.add(res.getString("excel.ComunicacionTlf"));
		cabeceras.add(res.getString("excel.ComunicacionEmail"));
		cabeceras.add(res.getString("excel.CesionDatos"));

		// Datos
		for (MatriculaCharla a : c.getMatriculas()) {
			List<Object> row = new ArrayList<Object>();

			UsuarioCyL u = (UsuarioCyL)service.find(UsuarioCyL.class, a.getUsuario().getId());

			row.add(a.getFechaConfirmacion());
			row.add(a.isPreMatriculadoWeb() ? res.getString("excel.Si") : res.getString("excel.No"));

			if (a.isPreMatriculadoWeb() && a.isEnListaEspera() && !a.isAdmitido())
				row.add(res.getString("excel.EstadoMatriculaEspera"));
			else if (!a.isEnListaEspera() && a.isAdmitido())
				row.add(res.getString("excel.EstadoMatriculaMatriculado"));
			else if (!a.isEnListaEspera() && !a.isAdmitido() && !a.isCancelada())
				row.add(res.getString("excel.EstadoMatriculaRechazado"));
			else if(!a.isEnListaEspera() && !a.isAdmitido() && a.isCancelada())
				row.add(res.getString("excel.EstadoMatriculaCancelado"));

			row.add(a.getAsistencia() + "%");
			row.add(u.getId());
			row.add(u.getUsername());
			row.add(u.isExtranjero() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isExtranjero() ? u.getPasaporte() : u.getNif());
			row.add(u.getNombre());
			row.add(u.getApellido1());
			row.add(u.getApellido2());
			row.add(u.getEdad());
			row.add(u.isMenor() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add((u.getNifAutorizado() != null) ? u.getNifAutorizado() : "");
			row.add((u.getNombreCompletoAutorizado() != null) ? u.getNombreCompletoAutorizado() : "");
			row.add(u.getSexo().equals(Sexo.H) ? res.getString("excel.Hombre") : res.getString("excel.Mujer"));
			row.add(u.getFechaCreacion());
			row.add(u.getCentro().getNombre());
			row.add((u.getDireccion() != null) ? u.getDireccion() : "");
			row.add((u.getCp() != null) ? u.getCp() : "");
			row.add(((u.getProvincia() == null) || (u.getProvincia().getId() == 0)) ? "N/A" : u.getProvincia().getNombre());
			row.add(((u.getLocalidad() == null) || (u.getLocalidad().getId() == 0)) ? "N/A" : u.getLocalidad().getNombre());
			row.add(u.getTelefonos());
			row.add(u.getEmail());
			row.add(res.getString("excel.PadeceDiscapacidad." + u.getTipoDiscapacidad().toString()));
			row.add(u.isPoseeOrdenador() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isAccesoInternet() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(res.getString("excel.TipoUsuario." + u.getTipoUsuario().toString()));
			row.add(res.getString("excel.MedioPublicidad." + u.getMedioPublicidad().toString()));
			row.add((u.getMedioPublicidadOtro() != null) ? u.getMedioPublicidadOtro() : "");
			row.add(res.getString("excel.FrecuenciaInternet." + u.getTipoFrecuenciaInternet().toString()));
			row.add((u.getTipoUtilidadInternet() != null) ? res.getString("excel.UtilidadInternet." + u.getTipoUtilidadInternet().toString()) : "N/A");
			row.add((u.getTipoUtilizarSwLibre() == UsuarioCyL.TipoUtilizarSwLibre.SI) ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(res.getString("excel.Ocupacion." + u.getTipoOcupacion().toString()));
			row.add(res.getString("excel.Colectivo."+ u.getTipoColectivo().toString()));
			row.add((u.getTipoSectorProfesional() != null) ? res.getString("excel.SectorProfesional." + u.getTipoSectorProfesional().toString()) : "N/A");
			row.add(res.getString("excel.Estudios." + u.getTipoEstudiosRealizados().toString()));
			row.add(u.iscomunicacionTlf() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.iscomunicacionMail() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isCesionPermitida() ? res.getString("excel.Si") : res.getString("excel.No"));

			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, nombreCharla);
	}

	
	/*
	 * Generar xls empleados.
	 * 
	 * @param empleados
	 *            empleados
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsEmpleados(List<Empleado> empleados, Locale locale, OutputStream out) throws IOException {
		
		List<String> cabeceras = new ArrayList<String>();

		List<List<Object>> datos = new ArrayList<List<Object>>();

		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		// Cabeceras
		cabeceras.add(res.getString("excel.staff.col.id"));
		cabeceras.add(res.getString("excel.staff.col.username"));
		cabeceras.add(res.getString("excel.staff.col.nin"));
		cabeceras.add(res.getString("excel.staff.col.job"));
		cabeceras.add(res.getString("excel.staff.col.center"));
		cabeceras.add(res.getString("excel.staff.col.associate"));
		cabeceras.add(res.getString("excel.staff.col.telephone"));
		cabeceras.add(res.getString("excel.staff.col.email"));
		cabeceras.add(res.getString("excel.staff.col.isIssueManager"));
		cabeceras.add(res.getString("excel.staff.col.isTeacher"));
		cabeceras.add(res.getString("excel.staff.col.isFinancialManager"));
		cabeceras.add(res.getString("excel.staff.col.comments"));

		// Datos
		for (Empleado e : empleados) {
			
			List<Object> row = new ArrayList<Object>();
			row.add(e.getId());
			row.add(e.getNombre());
			row.add(e.getNif());
			row.add((e.getPuesto() != null) ? res.getString("excel.staff.col.job." + e.getPuesto().name()) : "N/A");
			row.add(e.getCentro().getNombre());
			row.add(((e.getProveedor() == null) || (e.getProveedor().getId() == 0)) ? "N/A" : e.getProveedor().getNombre());
			row.add(e.getTelefono());
			row.add(e.getEmail());
			row.add(e.isResponsableIncidencias() ? res.getString("excel.staff.col.isSomeKindOf.Yes") : res.getString("excel.staff.col.isSomeKindOf.Not"));
			row.add(e.isProfesor() ? res.getString("excel.staff.col.isSomeKindOf.Yes") : res.getString("excel.staff.col.isSomeKindOf.Not"));
			row.add(e.isAccesibleFinanciera() ? res.getString("excel.staff.col.isSomeKindOf.Yes") : res.getString("excel.staff.col.isSomeKindOf.Not"));
			row.add(e.getObservaciones());

			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, res.getString("excel.staff.name"));
	}	
	
	/*
	 * Generar xls proveedores.
	 * 
	 * @param proveedores
	 *            proveedores
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsProveedores(List<Proveedor> proveedores, Locale locale, OutputStream out) throws IOException {
		
		List<String> cabeceras = new ArrayList<String>();

		List<List<Object>> datos = new ArrayList<List<Object>>();

		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);
				
		// Cabeceras
		cabeceras.add(res.getString("excel.associates.col.id"));
		cabeceras.add(res.getString("excel.associates.col.name"));
		cabeceras.add(res.getString("excel.associates.col.nin"));
		cabeceras.add(res.getString("excel.associates.col.address"));
		cabeceras.add(res.getString("excel.associates.col.city"));
		cabeceras.add(res.getString("excel.associates.col.state"));
		cabeceras.add(res.getString("excel.associates.col.postcode"));
		cabeceras.add(res.getString("excel.associates.col.telephone"));
		cabeceras.add(res.getString("excel.associates.col.fax"));
		cabeceras.add(res.getString("excel.associates.col.email"));
		cabeceras.add(res.getString("excel.associates.col.type"));
		cabeceras.add(res.getString("excel.associates.col.sector"));
		cabeceras.add(res.getString("excel.associates.col.comments"));

		// Datos
		for (Proveedor p : proveedores) {
			
			List<Object> row = new ArrayList<Object>();
			row.add(p.getId());
			row.add(p.getNombre());
			row.add(p.getCif());
			row.add(p.getDireccion());
			row.add(((p.getLocalidad() == null) || (p.getLocalidad().getId() == 0)) ? "N/A" : p.getLocalidad().getNombre());
			row.add(((p.getProvincia() == null) || (p.getProvincia().getId() == 0)) ? "N/A" : p.getProvincia().getNombre());
			row.add(p.getCp());
			row.add(p.getTelefono());
			row.add(p.getFax());
			row.add(p.getEmail());
			row.add((p.getTipoEmpresa() != null) ? res.getString("excel.associates.col.type." + p.getTipoEmpresa().name()) : "N/A");
			row.add((p.getSector() != null) ? res.getString("excel.associates.col.sector." + p.getSector().name()) : "N/A");
			row.add(p.getComentarios());

			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, res.getString("excel.associates.name"));
	}
	
	
	/*
	 * Generar xls usuarios.
	 * 
	 * @param usuarioCyLs
	 *            usuario cy ls
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsUsuarios(List<UsuarioCyL> usuarioCyLs, Locale locale, OutputStream out) throws IOException {
		List<String> cabeceras = new ArrayList<String>();

		List<List<Object>> datos = new ArrayList<List<Object>>();

		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		// Cabecearas
		cabeceras.add(res.getString("excel.UserId"));
		cabeceras.add(res.getString("excel.Username"));
		cabeceras.add(res.getString("excel.Extranjero"));
		cabeceras.add(res.getString("excel.Nif"));
		cabeceras.add(res.getString("excel.Nombre"));
		cabeceras.add(res.getString("excel.Apellido1"));
		cabeceras.add(res.getString("excel.Apellido2"));
		cabeceras.add(res.getString("excel.Edad"));
		cabeceras.add(res.getString("excel.Menor14SinNif"));
		cabeceras.add(res.getString("excel.NifAutorizador"));
		cabeceras.add(res.getString("excel.NombreAutorizador"));
		cabeceras.add(res.getString("excel.Sexo"));
		cabeceras.add(res.getString("excel.FechaAlta"));
		cabeceras.add(res.getString("excel.FechaUltimoAcceso"));
		cabeceras.add(res.getString("excel.LDAPActivo"));
		cabeceras.add(res.getString("excel.Centro"));
		cabeceras.add(res.getString("excel.CP"));
		cabeceras.add(res.getString("excel.Provincia"));
		cabeceras.add(res.getString("excel.Localidad"));
		cabeceras.add(res.getString("excel.Telefonos"));
		cabeceras.add(res.getString("excel.Email"));
		cabeceras.add(res.getString("excel.PadeceDiscapacidad"));
		cabeceras.add(res.getString("excel.TieneOrdeandor"));
		cabeceras.add(res.getString("excel.TieneAccesoInternet"));
		cabeceras.add(res.getString("excel.TipoUsuario"));
		cabeceras.add(res.getString("excel.MedioPublicidad"));
		cabeceras.add(res.getString("excel.MedioPublicidadOtro"));
		cabeceras.add(res.getString("excel.FrecuenciaInternet"));
		cabeceras.add(res.getString("excel.UtilidadInternet"));
		cabeceras.add(res.getString("excel.SoftwareLibre"));
		cabeceras.add(res.getString("excel.Ocupacion"));
		cabeceras.add(res.getString("excel.Colectivo"));
		cabeceras.add(res.getString("excel.SectorProfesional"));
		cabeceras.add(res.getString("excel.Estudios"));
		cabeceras.add(res.getString("excel.ComunicacionTlf"));
		cabeceras.add(res.getString("excel.ComunicacionEmail"));
		cabeceras.add(res.getString("excel.CesionDatos"));
		// cabeceras.add(res.getString("excel.Peso"));

		// Datos
		for (UsuarioCyL u : usuarioCyLs) {
			List<Object> row = new ArrayList<Object>();
			row.add(u.getId());
			row.add(u.getUsername());
			row.add(u.isExtranjero() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isExtranjero() ? u.getPasaporte() : u.getNif());
			row.add(u.getNombre());
			row.add(u.getApellido1());
			row.add(u.getApellido2());
			row.add(u.getEdad());
			row.add(u.isMenor() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add((u.getNifAutorizado() != null) ? u.getNifAutorizado() : "");
			row.add((u.getNombreCompletoAutorizado() != null) ? u.getNombreCompletoAutorizado() : "");
			row.add(u.getSexo().equals(Sexo.H) ? res.getString("excel.Hombre") : res.getString("excel.Mujer"));
			row.add(u.getFechaCreacion());
			row.add(u.getUltimoAcceso());
			row.add(u.isDesactivadoLDAP() ? res.getString("excel.No") : res.getString("excel.Si"));
			row.add(u.getCentro().getNombre());
			row.add((u.getCp() != null) ? u.getCp() : "");
			row.add(((u.getProvincia() == null) || (u.getProvincia().getId() == 0)) ? "N/A" : u.getProvincia().getNombre());
			row.add(((u.getLocalidad() == null) || (u.getLocalidad().getId() == 0)) ? "N/A" : u.getLocalidad().getNombre());
			row.add(u.getTelefonos());
			row.add(u.getEmail());
			row.add(res.getString("excel.PadeceDiscapacidad." + u.getTipoDiscapacidad().toString()));
			row.add(u.isPoseeOrdenador() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isAccesoInternet() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(res.getString("excel.TipoUsuario." + u.getTipoUsuario().toString()));
			row.add(res.getString("excel.MedioPublicidad." + u.getMedioPublicidad().toString()));
			row.add((u.getMedioPublicidadOtro() != null) ? u.getMedioPublicidadOtro() : "");
			row.add(res.getString("excel.FrecuenciaInternet." + u.getTipoFrecuenciaInternet().toString()));
			row.add((u.getTipoUtilidadInternet() != null) ? res.getString("excel.UtilidadInternet." + u.getTipoUtilidadInternet().toString()) : "N/A");
			row.add((u.getTipoUtilizarSwLibre() == UsuarioCyL.TipoUtilizarSwLibre.SI) ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(res.getString("excel.Ocupacion." + u.getTipoOcupacion().toString()));
			row.add(res.getString("excel.Colectivo." + u.getTipoColectivo().toString()));
			row.add((u.getTipoSectorProfesional() != null) ? res.getString("excel.SectorProfesional." + u.getTipoSectorProfesional().toString()) : "N/A");
			row.add(res.getString("excel.Estudios." + u.getTipoEstudiosRealizados().toString()));
			row.add(u.iscomunicacionTlf() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.iscomunicacionMail() ? res.getString("excel.Si") : res.getString("excel.No"));
			row.add(u.isCesionPermitida() ? res.getString("excel.Si") : res.getString("excel.No"));
			// row.add(u.getPeso());

			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos,
				res.getString("excel.UsuariosRegistrados"));
	}

	/*
	 * Generar xls usuarios pre.
	 * 
	 * @param usuarioPres
	 *            usuario pres
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsUsuariosPre(List<UsuarioPre> usuarioPres, Locale locale, OutputStream out) throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		// Cabecearas
		cabeceras.add("Id");
		cabeceras.add("Nombre");
		cabeceras.add("Apellido1");
		cabeceras.add("Apellido2");
		cabeceras.add("Teléfono");

		// Datos
		for (UsuarioPre u : usuarioPres) {
			List<Object> row = new ArrayList<Object>();
			row.add(u.getId());
			row.add(u.getNombre());
			row.add(u.getApellido1());
			row.add(u.getApellido2());
			row.add(u.getTelefono());
			datos.add(row);
		}
		generarDocumento(out, cabeceras, datos, "Usuarios Pre-registrados");
	}

	/*
	 * Generar xls inventario.
	 * 
	 * @param recursos
	 *            recursos
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsInventario(List<Recurso> recursos, Locale locale, OutputStream out) throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add("Nombre");
		cabeceras.add("Categoría");
		cabeceras.add("Centro");
		cabeceras.add("Área");
		cabeceras.add("Estado");
		cabeceras.add("Cód.Etiqueta");

		for (Recurso r : recursos) {
			List<Object> row = new ArrayList<Object>();
			row.add(r.getId());
			row.add(r.getNombre());
			row.add(r.getCategoria().getNombre());
			row.add(r.getCentro().getNombre());
			row.add(r.getAula() != null ? r.getAula().getNombre() : "no definido");
			row.add(r.getEstado().toString());
			row.add(r.getCodEtiqueta());
			datos.add(row);

		}

		generarDocumento(out, cabeceras, datos, "Inventario");
	}

	/*
	 * Generar xls incidencias.
	 * 
	 * @param incidencias
	 *            incidencias
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsIncidencias(List<Incidencia> incidencias, Locale locale, OutputStream out) throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();
		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.messages");

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add("Nombre");
		cabeceras.add("Fecha Alta");
		cabeceras.add("Criticidad");
		cabeceras.add("Estado");
		cabeceras.add("Categoria");
		cabeceras.add("Usuario que abrió la incidencia");
		cabeceras.add("Centro");
		cabeceras.add("Responsable");
		cabeceras.add("Descripción");

		for (Incidencia i : incidencias) {
			List<Object> row = new ArrayList<Object>();
			
			row.add(i.getId());
			row.add(i.getNombre());
			row.add(i.getFechaIncidencia());
			row.add(i.getCriticidad().toString());
			row.add(res.getString("estado.incidencia." + i.getEstado()));
			row.add(i.getCategoriaIncidencia().getNombre());
			row.add(i.getUsuario().getNombreCompleto());
			row.add(i.getCentro() == null ? "" : i.getCentro().getNombre());
			row.add(i.getEmpleado() == null ? "" : i.getEmpleado().getNombreCompleto());
			row.add(i.getDescripcion() == null ? "" : i.getDescripcion());
			
			datos.add(row);

		}
		
		generarDocumento(out, cabeceras, datos, "Incidencias");
	}

	/*
	 * Generar xls asesoramientos.
	 * 
	 * @param asesoramientos
	 *            asesoramientos
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsAsesoramientos(List<Asesoramiento> asesoramientos, Locale locale, OutputStream out) throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();
		DateFormat dateformatterFecha = new SimpleDateFormat("dd/MM/yyyy", locale);
		DateFormat dateformatterHora = new SimpleDateFormat("HH:mm", locale);

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add("Tipo");
		cabeceras.add("Tema");
		cabeceras.add("Colectivo");
		cabeceras.add("Centro");
		cabeceras.add("Dinamizador");
		cabeceras.add("IdUsuario");
		cabeceras.add("Usuario");
		cabeceras.add("Fecha");
		cabeceras.add("Duración");
		cabeceras.add("Resolución");

		for (Asesoramiento a : asesoramientos) {
			List<Object> row = new ArrayList<Object>();
			row.add(a.getIdAsesoramiento());
			row.add(a.getTipoAsesoramiento().getNombre());
			row.add(a.getTema());
			row.add(a.getColectivo().toString());
			row.add(a.getCentro().getNombre());
			row.add(a.getDinamizador().getNombreCompleto());
			row.add(a.getUsuario().getId());
			row.add(a.getUsuario().getNombreCompleto());
			row.add(dateformatterFecha.format(a.getFecha()) + " " + dateformatterHora.format(a.getHora()));
			row.add(a.getDuracion());
			row.add(a.isResolucion() ? "Sí" : "No");
			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, "Asesoramientos");
	}

	/*
	 * Generar xls wifis.
	 * 
	 * @param wifis
	 *            wifis
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsWifis(List<Wifi> wifis, Locale locale, OutputStream out)
			throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();
		DateFormat dateformatter = new SimpleDateFormat("dd/MM/yyyy HH:mm");

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add("Centro");
		cabeceras.add("IdUsuario");
		cabeceras.add("Usuario");
		cabeceras.add("Fecha");

		for (Wifi w : wifis) {
			List<Object> row = new ArrayList<Object>();

			row.add(w.getId());
			row.add(w.getCentro().getNombre());
			row.add(w.getUsuario().getId());
			row.add(w.getUsuario().getNombreCompleto());
			row.add(dateformatter.format(w.getFecha()));
			
			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, "Wifis");
	}

	/*
	 * Generar xls practicas talleres.
	 * 
	 * @param practicasTalleres
	 *            practicas talleres
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsPracticasTalleres(List<PracticaTaller> practicasTalleres, Locale locale, OutputStream out) throws IOException {
		String nombrePTaller = "";
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();
		
		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		DateFormat dateformatterFecha = new SimpleDateFormat("dd/MM/yyyy", locale);
		DateFormat dateformatterHora = new SimpleDateFormat("HH:mm", locale);

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add(res.getString("excel.Tipo"));
		cabeceras.add(res.getString("excel.Centro"));
		cabeceras.add("IdUsuario");
		cabeceras.add(res.getString("excel.Usuario"));
		cabeceras.add(res.getString("excel.Ordenador"));
		cabeceras.add(res.getString("excel.Fecha"));

		for (PracticaTaller p : practicasTalleres) {
			List<Object> row = new ArrayList<Object>();
			row.add(p.getId());

			String idioma = locale.toString();
			List<TipoPracticaLanguage> ltpl = p.getTipoPractica().getTextos();
			for (TipoPracticaLanguage tpl : ltpl)
				if (tpl.getLanguage().getISO().compareTo(idioma) == 0)
					nombrePTaller = tpl.getNombre();

			row.add(nombrePTaller);

			row.add(p.getCentro().getNombre());
			row.add(p.getUsuario().getId());
			row.add(p.getUsuario().getNombreCompleto());
			row.add(p.getOrdenador().getNombre());
			row.add(dateformatterFecha.format(p.getFecha()) + " " + dateformatterHora.format(p.getHora()));
			datos.add(row);
		}

		generarDocumento(out, cabeceras, datos, "Prácticas de Talleres");
	}

	/*
	 * Generar xls externas.
	 * 
	 * @param externas
	 *            externas
	 * @param out
	 *            out
	 * @param proximos
	 *            proximos
	 * @param conPlaza
	 *            con plaza
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	@SuppressWarnings("unchecked")
	private void generarXlsExternas(List<ActividadExterna> externas, boolean proximos, Locale locale, OutputStream out) throws IOException {
		String nombreServicioXlsExternas = "";
		String nombreTematicaXlsExternas = "";
		String apodoActividadExternaXls = "";

		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.excel", locale);

		DateFormat hourformatter = new SimpleDateFormat("HH:mm", locale);
		DateFormat dateformatter = new SimpleDateFormat("dd/MM/yyyy", locale);

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add(res.getString("excel.Servicio"));
		cabeceras.add(res.getString("excel.Apodo"));
		cabeceras.add(res.getString("excel.Centro"));
		cabeceras.add(res.getString("excel.ProfExterno"));
		cabeceras.add(res.getString("excel.Area"));
		cabeceras.add(res.getString("excel.PlazTotales"));
		cabeceras.add(res.getString("excel.Asistentes"));
		cabeceras.add(res.getString("excel.FInicio"));
		cabeceras.add(res.getString("excel.FFin"));
		cabeceras.add(res.getString("excel.HInicio"));
		cabeceras.add(res.getString("excel.HFin"));
		cabeceras.add(res.getString("excel.HPeriodo"));
		cabeceras.add(res.getString("excel.HTotales"));
		cabeceras.add(res.getString("excel.Tipologia"));
		cabeceras.add(res.getString("excel.IniciativaSingular"));
		cabeceras.add(res.getString("excel.Videoconferencia"));
		cabeceras.add(res.getString("excel.Valoracion"));

		for (ActividadExterna e : externas) {
			// Si se quieren TODAS las actividades externas, o solo las que
			// tienen plazas libres, o las actividades externas que no han
			// empezado.
			if ((!proximos || (e.getFechaInicio().getTime() >= (new Date()).getTime()))) {
				List<Object> row = new ArrayList<Object>();

				row.add(e.getId());

				nombreServicioXlsExternas = GetServicioNombre(e.getServicio(), locale);
				row.add(nombreServicioXlsExternas);

				apodoActividadExternaXls = GetActividadExtApodo(e, locale);
				row.add(apodoActividadExternaXls);

				row.add((e.getCentro() != null) ? e.getCentro().getNombre() : res.getString("excel.CesionServ"));
				row.add(e.getColaborador() != null ? e.getColaborador().getNombreCompleto() : res.getString("excel.NoDef"));

				row.add(e.getAula() != null ? e.getAula().getNombre() : res.getString("excel.NoDef"));
				row.add(e.getNumeroPlazas());
				row.add(e.getNumeroAsistentes());

				row.add(dateformatter.format(e.getFechaInicio()));
				row.add(dateformatter.format(e.getFechaFin()));
				row.add(hourformatter.format(e.getHoraInicio()));
				row.add(hourformatter.format(e.getHoraFin()));
				// 3.4.8 - RF_15_20
				//Calculo del número de horas del periodo
				q = service.getEntityManager().createQuery(
						"SELECT a " + 
						"FROM " + ActividadCalendarItem.class.getName() + " a " + 
						"WHERE a.actividad.id = ? AND a.start <= ? AND a.end >= ?");
				q.setParameter(1, e.getId());
				q.setParameter(2, (periodoFin != null ? periodoFin : e.getFechaFin()));
				q.setParameter(3, (periodoInicio != null ? periodoInicio : e.getFechaInicio()));
				
				row.add(q.getResultList() == null ? 0 : calculateHours((List<ActividadCalendarItem>)q.getResultList()));
				row.add(calculateHours(e.getCalendarItems()));

				nombreTematicaXlsExternas = GetTematicaNombre(e.getTematica(), locale);
				row.add((e.getTematica() != null) ? nombreTematicaXlsExternas : res.getString("excel.NoDef"));

				row.add(e.isIniciativaSingular() ? res.getString("excel.Si") : res.getString("excel.No"));
				row.add(e.isVideoconferencia() ? res.getString("excel.Si") : res.getString("excel.No"));
				
				row.add(e.getValoracion());

				datos.add(row);
			}
		}

		generarDocumento(out, cabeceras, datos, "Actividades Externas");
	}

	/*
	 * Generar xls facturas.
	 * 
	 * @param facturas
	 *            facturas
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private void generarXlsFacturas(List<Factura> facturas, Locale locale, OutputStream out)
			throws IOException {
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();

		// Cabeceras
		cabeceras.add("Id");
		cabeceras.add("Proyecto");
		cabeceras.add("Año");
		cabeceras.add("Elemento");
		cabeceras.add("Proveedor");
		cabeceras.add("Concepto");
		cabeceras.add("Fecha Intr.");
		cabeceras.add("Estado");

		for (Factura f : facturas) {
			List<Object> row = new ArrayList<Object>();
			
			row.add(f.getId());
			row.add(f.getContenedor().getProyectoRaiz().getProyecto().getNombre());
			row.add(f.getContenedor().getProyectoRaiz().getAnyo());
			row.add(f.getContenedor().getNombre());
			row.add(f.getProveedor() == null ? "" : f.getProveedor().getNombre());
			row.add(f.getConcepto());
			row.add(f.getFechaIntroduccion());
			row.add(f.getEstadoActual().getTipoEstadoFactura().toString());
			
			datos.add(row);

		}
		generarDocumento(out, cabeceras, datos, "Facturas");
	}
	
	/*
	 * Generar Xls informes
	 * 
	 * @param practicasTalleres
	 *            practicas talleres
	 * @param out
	 *            out
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	/*
	  private void generarXlsInformeIndicadores(List<Curso> c, List<Charla> ch, List<ActividadExterna> ae, 
	 
							String cis, String ais, String ois, Locale locale, OutputStream out) throws IOException {
		
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();
		int nFilas = 0;
		int nUsuariosInscritosCursos = 0, nUsuariosInscritosCharlas = 0, nUsuariosInscritos = 0; 
		
		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.informes", locale);

		DateFormat dateformatterFecha = new SimpleDateFormat("dd/MM/yyyy", locale);
		DateFormat dateformatterHora = new SimpleDateFormat("HH:mm", locale);
		
		// Cabeceras
		for(String ci : cis.split(",")) {
			if(ci.contains("[") || ci.contains("]")) {
				ci = (ci.contains("[")) ? ci.substring(1,ci.length()) : ci.substring(0, ci.length()-1);
			}
			
			cabeceras.add(res.getString("informes.CamposInforme." + ci.trim()));
		}
		
		generarDocumento(out, cabeceras, datos, "Informe de indicadores");
	}
	*/

	/**
	 * cast form Object to String 
	 * @param oOrigin
	 * @return
	 */
	private String castObjectToString(Object oOrigin){
		String result = null;
		try{
			if(oOrigin instanceof Enum)
				result = ((Enum)oOrigin).name();
			else if (oOrigin instanceof Integer)
				result = ((Integer)oOrigin).toString();
			else	
				result = (String)oOrigin;	
		} catch(ClassCastException e){
			result = "";
		}
		return result;
	}
	
	/**
	 * cast form Object to Integer 
	 * @param oOrigin
	 * @return
	 */
	private Integer castObjectToInteger(Object oOrigin){
		Integer result = null;
		try{
			if (oOrigin instanceof Integer)
				result = (Integer)oOrigin;
			else if(oOrigin instanceof Long)
				result = ((Long)oOrigin).intValue();
			else if(oOrigin instanceof Float)
				result = ((Float)oOrigin).intValue();
			else if(oOrigin instanceof Double)
				result = ((Double)oOrigin).intValue();
			else 
				result = (Integer)oOrigin;	
		} catch(ClassCastException e){
			result = Integer.valueOf(0);
		}
		return result;
	}
	
	/**
	 * cast form Object to Long 
	 * @param oOrigin
	 * @return
	 */
	private Long castObjectToLong(Object oOrigin){
		Long result = null;
		try{
			if (oOrigin instanceof Integer)
				result = ((Integer)oOrigin).longValue();
			else if(oOrigin instanceof Long)
				result = (Long)oOrigin;
			else if(oOrigin instanceof Float)
				result = ((Float)oOrigin).longValue();
			else if(oOrigin instanceof Double)
				result = ((Double)oOrigin).longValue();
			else 
				result =(Long)oOrigin;		
		} catch(ClassCastException e){
			result = Long.valueOf(0);
		}
		return result;
	}

	/**
	 * cast form Object to Float 
	 * @param oOrigin
	 * @return
	 */
	private Float castObjectToFloat(Object oOrigin){
		Float result = null;
		try{
			if (oOrigin instanceof Integer)
				result = ((Integer)oOrigin).floatValue();
			else if(oOrigin instanceof Long)
				result = ((Long)oOrigin).floatValue();
			else if(oOrigin instanceof Float)
				result = (Float)oOrigin;
			else if(oOrigin instanceof Double)
				result = ((Double)oOrigin).floatValue();
			else 
				result =(Float)oOrigin;		
		} catch(ClassCastException e){
			result = Float.valueOf(0);
		}
		return result;
	}
	
	/**
	 * cast form Object to Double 
	 * @param oOrigin
	 * @return
	 */
	private Double castObjectToDouble(Object oOrigin){
		Double result = null;
		try{
			if (oOrigin instanceof Integer)
				result = ((Integer)oOrigin).doubleValue();
			else if(oOrigin instanceof Long)
				result = ((Long)oOrigin).doubleValue();
			else if(oOrigin instanceof Float)
				result = ((Float)oOrigin).doubleValue();
			else if(oOrigin instanceof Double)
				result = (Double)oOrigin;
			else 
				result =(Double)oOrigin;		
		} catch(ClassCastException e){
			result = Double.valueOf(0);
		}
		return result;
	}
	
	/**
	 * cast form Object to Rango Edades 
	 * @param oOrigin
	 * @return
	 */
	private String castObjectToRangoEdades(Object oOrigin){		
		Integer edad = castObjectToInteger(oOrigin);
		
		if (edad.intValue()<16)
			return "<16";
		else if (edad.intValue()<25)
			return "16-24";
		else if (edad.intValue()<35)
			return "25-34";		
		else if (edad.intValue()<45)
			return "35-44";		
		else if (edad.intValue()<55)
			return "45-54";		
		else if (edad.intValue()<65)
			return "55-64";
		else 
			return ">64";
	}

	/**
	 * Metodo de traduccion controlada empleando con los ficheros de resources
	 */
	private String readResource(ResourceBundle oRes, String oPrefix, String oTag){
		String result = "";
		try{
			return oRes.getString(oPrefix + '.' + oTag);
		}catch(java.util.MissingResourceException e){
			result = oTag;
		}
		return result;
	}
	
	/*
	 * Generar Xls informes detalle actividades
	 * 
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private String generarXlsReportDatos(String fields, EActivityTypes activityType, EReportDatosTypes reportDatosType, 
									   List<Object[]> a, String orden, Locale locale, OutputStream out) throws IOException {
		
		DateFormat dateformatterFecha = new SimpleDateFormat("dd/MM/yyyy", locale);
		DateFormat dateformatterHora = new SimpleDateFormat("HH:mm", locale);		
		String nombreFichero = "Listado_" + dateformatterFecha.format(new Date());	
		
		if(reportDatosType.equals(EReportDatosTypes.ACTIVIDAD)) 
			nombreFichero = "Listado_Detalle_de_Actividades_" + dateformatterFecha.format(new Date());
		else if(reportDatosType.equals(EReportDatosTypes.ACTIVIDADUSUARIO)) 
			nombreFichero = "Listado_Detalle_de_Participacion_" + dateformatterFecha.format(new Date());
		
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();		
		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.informes", locale);
		
		// Cabeceras
		String[] columns =  fields.split(",");
		for(String field : columns) {
			field = field.trim();
			field = field.replace("[", "");
			field = field.replace("]", "");
			if(!field.trim().equals("")){
				String columnHeader = null;
				try{
					columnHeader = res.getString("informes.reportDatosField." + field.trim());
				} catch (java.util.MissingResourceException e){
					columnHeader = field.trim();
				}
				cabeceras.add(columnHeader);
			}
		}
				
		if(a != null && a.size() > 0) {
			for(Object[] c : a) {
				List<Object> row = new ArrayList<Object>();
				
				if(fields.contains("ID")) 		row.add(castObjectToLong(c[0]));
				if(fields.contains("TIPO")) 	row.add(castObjectToString(c[1]));
				if(fields.contains("TEMR")) 	row.add(castObjectToString(c[2]));
				if(fields.contains("TEMA")) 	row.add(castObjectToString(c[3]));
				if(fields.contains("SERV")) 	row.add(castObjectToString(c[4]));
				if(fields.contains("ALCU"))		row.add(castObjectToString(c[5]));
				if(fields.contains("CENT"))		row.add(castObjectToString(c[6]));
				if(fields.contains("PROV")) 	row.add(castObjectToString(c[7]));
				if(fields.contains("PRZTOT"))	row.add(castObjectToInteger(c[8]));
				if(fields.contains("FI")) 		row.add(dateformatterFecha.format((Date)c[9]));
				if(fields.contains("FN")) 		row.add(dateformatterFecha.format((Date)c[10]));
				if(fields.contains("HI")) 		row.add(dateformatterHora.format((Date)c[11]));
				if(fields.contains("HF")) 		row.add(dateformatterHora.format((Date)c[12]));
				if(fields.contains("DRTOT"))	row.add(castObjectToFloat(c[13]));
				if(fields.contains("ISING")) 	row.add(((Boolean)c[14]) ? res.getString("informes.reportDatosFilter.Si").toUpperCase(): res.getString("informes.reportDatosFilter.No").toUpperCase());
				if(fields.contains("VIDEO")) 	row.add(((Boolean)c[15]) ? res.getString("informes.reportDatosFilter.Si").toUpperCase(): res.getString("informes.reportDatosFilter.No").toUpperCase());
				//Actividades
				if(fields.contains("DRPER")) 	row.add(castObjectToDouble(c[20]));
				if(fields.contains("NMAT")) 	row.add(castObjectToInteger(c[16]));
				if(fields.contains("NINS")) 	row.add(castObjectToInteger(c[17]));
				if(fields.contains("NAS")) 		row.add(castObjectToInteger(c[18]));
				if(fields.contains("EST")) 		row.add(((Boolean)c[19]) ? res.getString("informes.reportDatosField.EstadoCerrado") : res.getString("informes.reportDatosField.EstadoAbierto"));
				
				//Se marca como realizado si tiene algún asistente confirmado y se ha superado la fecha fin.
				if(fields.contains("RLZD")){
					Date fAgora = new Date();
					Date fFinCurso = (Date)c[10];
					boolean bRealizada = (fFinCurso!=null && fFinCurso.before(fAgora) && (Integer)c[21] >= 1);
					row.add(bRealizada ? res.getString("informes.reportDatosFilter.Realizada.Si").toUpperCase(): res.getString("informes.reportDatosFilter.Realizada.No").toUpperCase());
				}		
				
				//Participacion
				if(fields.contains("USER")) 	row.add(castObjectToString(c[16]));
				if(fields.contains("NOMB")) 	row.add(castObjectToString(c[17]));
				if(fields.contains("APE1")) 	row.add(castObjectToString(c[18]));
				if(fields.contains("APE2")) 	row.add(castObjectToString(c[19]));
				if(fields.contains("SEX")) 		row.add(readResource(res,"informes.reportDatosField.sexo",castObjectToString(c[20]))); 
				if(fields.contains("EDAD")) 	row.add(castObjectToInteger(c[21]));
				if(fields.contains("ADAPT")) 	row.add(readResource(res,"informes.reportDatosFilter.Adaptacion",castObjectToString(c[21]))); 
				if(fields.contains("FORM")) 	row.add(readResource(res,"informes.reportDatosFilter.Estudios",castObjectToString(c[23]))); 
				if(fields.contains("OCUP")) 	row.add(readResource(res,"informes.reportDatosFilter.Ocupacion",castObjectToString(c[24])));
				if(fields.contains("ASIS")) 	row.add(castObjectToFloat(c[25]));
				if(fields.contains("HTPO"))		row.add(castObjectToFloat(c[26]));
				if(fields.contains("HASI"))		row.add(castObjectToFloat(c[27]));
				if(fields.contains("HJUS"))		row.add(castObjectToFloat(c[28]));
				if(fields.contains("HORP"))		row.add(castObjectToFloat(c[29]));				

				datos.add(row);
			}
		}
		
		generarDocumento(out, cabeceras, datos, res.getString("informes.reportDatosType." + reportDatosType));
		
		return nombreFichero;
	}
	
	/*
	 * Generar Xls informes detalle actividades
	 * 
	 * @throws IOException
	 *             Signals that an I/O exception has occurred.
	 */
	private String generarXlsReportIndicadores(String fields, EActivityTypes activityType, EReportDatosTypes reportDatosType, 
									   List<Object[]> a, String orden, Locale locale, OutputStream out) throws IOException {
		
		DateFormat dateformatterFecha = new SimpleDateFormat("dd/MM/yyyy", locale);
		DateFormat dateformatterHora = new SimpleDateFormat("HH:mm", locale);
		String nombreFichero = "Listado_" + dateformatterFecha.format(new Date());	
		
		if(reportDatosType.equals(EReportDatosTypes.ACTIVIDAD)) 
			nombreFichero = "Listado_Indicadores_de_Actividades_" + dateformatterFecha.format(new Date());
		else if(reportDatosType.equals(EReportDatosTypes.ACTIVIDADUSUARIO)) 
			nombreFichero = "Listado_Indicadores_de_Participacion_" + dateformatterFecha.format(new Date());
		
		List<String> cabeceras = new ArrayList<String>();
		List<List<Object>> datos = new ArrayList<List<Object>>();		
		ResourceBundle res = ResourceBundle.getBundle("es.csa.fdt.cyldigital.resources.informes", locale);
		
		// Cabeceras
		String[] columns =  fields.split(",");
		for(String field : columns) {
			field = field.trim();
			field = field.replace("[", "");
			field = field.replace("]", "");
			if(!field.trim().equals("")){
				String columnHeader = null;
				try{
					columnHeader = res.getString("informes.reportIndicadoresField." + field.trim());
				} catch (java.util.MissingResourceException e){
					columnHeader = field.trim();
				}
				cabeceras.add(columnHeader);
			}
		}
		cabeceras.add(res.getString("informes.reportIndicadoresField.Indicador"));
		
		if(a != null && a.size() > 0) {
			for(Object[] c : a) {
				List<Object> row = new ArrayList<Object>();
				
				if(fields.contains("TIPO")) 	row.add(castObjectToString(c[1]));
				if(fields.contains("PROV")) 	row.add(castObjectToString(c[7]));
				if(fields.contains("CENT")) 	row.add(castObjectToString(c[6]));
				if(fields.contains("TEMA")) 	row.add(castObjectToString(c[2]));
				if(fields.contains("TPLX")) 	row.add(castObjectToString(c[3]));
				if(fields.contains("ISING")) 	row.add(((Boolean)c[14]) ? res.getString("informes.reportDatosFilter.Si").toUpperCase(): res.getString("informes.reportDatosFilter.No").toUpperCase());
				if(fields.contains("VIDEO")) 	row.add(((Boolean)c[15]) ? res.getString("informes.reportDatosFilter.Si").toUpperCase(): res.getString("informes.reportDatosFilter.No").toUpperCase());
				
				//Participacion
				if(fields.contains("EDAD")) 	row.add(castObjectToRangoEdades(c[21]));
				if(fields.contains("SEXO")) 	row.add(readResource(res,"informes.reportDatosField.sexo",castObjectToString(c[20])));
				if(fields.contains("ADAP")) 	row.add(readResource(res,"informes.reportDatosFilter.Adaptacion",castObjectToString(c[22]))); 
				if(fields.contains("FORM")) 	row.add(readResource(res,"informes.reportDatosFilter.Estudios",castObjectToString(c[23]))); 
				if(fields.contains("OCUP")) 	row.add(readResource(res,"informes.reportDatosFilter.Ocupacion",castObjectToString(c[24])));
				
				datos.add(row);
			}
		}

		// Se realiza una agrupación de los campos de los indicadores  
		HashMap<List<Object>, Integer> resultMap = new HashMap<List<Object>, Integer>();
		for (List<Object> row : datos) {
			if(!resultMap.containsKey(row)){
				resultMap.put(row, 1);
			} else {
				resultMap.put(row, resultMap.get(row)+1);
			}
		}

		//Volcamos la agrupación en un array de datos
		datos = new ArrayList();
		for(Map.Entry<List<Object>, Integer> entry : resultMap.entrySet()) {
			List<Object> row = entry.getKey();
			Integer value = entry.getValue();
			row.add(value);
			datos.add(row);
		}
		
		/* Se realiza la ordenación tras la agrupacion */
		if(orden != null && !orden.isEmpty()) {
			int columnOrderIndex = 0;
			
			for(int i=0;i<columns.length;i++){
				String column = columns[i].trim();
				column = column.replace("[", "");
				column = column.replace("]", "");
				if(column.equals(orden)){
					columnOrderIndex = i;
				}				
			}
			Collections.sort(datos, new ListingHelperListComparator(columnOrderIndex)); 	
		}

		generarDocumento(out, cabeceras, datos, res.getString("informes.reportDatosType." + reportDatosType));
		
		return nombreFichero;
	}
	
	private String streamMatriculadosCurso(String idCurso, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		String nombreServicioCurso = "";

		if (idCurso != null && !idCurso.trim().isEmpty()) {
			long id = Long.parseLong(idCurso);
			Curso c = (Curso)service.find(Curso.class, id);

			if (c != null) {
				DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
				nombreServicioCurso = GetServicioNombre(c.getServicio(), locale);

				String nombreFichero = (nombreServicioCurso.trim()
						.replaceAll(" ", "_")).replaceAll("\"", "\'")
						+ "_"
						+ df.format(c.getFechaInicio())
						+ "_"
						+ df.format(c.getFechaFin())
						+ "_"
						+ "_matriculados_"
						+ c.getHorario();

				if ((c.getProfesor() != null) && (!c.getProfesor().getNombreCompleto().isEmpty()))
						nombreFichero += c.getProfesor().getNombreCompleto();

				nombreFichero += df.format(new Date());

				generarXlsCurso(c, nombreServicioCurso, locale, outputStream);
				
				return nombreFichero;
			}
		}
		
		return null;
	}

	private String streamMatriculadosTaller(String idTaller, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		String nombreServicioTaller = "";
		
		if (idTaller != null && !idTaller.trim().isEmpty()) {
			long id = Long.parseLong(idTaller);
			Taller t = (Taller)service.find(Taller.class, id);
			
			if (t != null) {
				DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
				nombreServicioTaller = GetServicioNombre(t.getServicio(), locale);

				String nombreFichero =
					nombreServicioTaller.trim().replaceAll(" ", "_") + "(" + df.format(t.getFechaInicio())
								+ "_" + df.format(t.getFechaFin()) + ")" + "_matriculados_" + t.getHorario()
								+ (t.getProfesor() != null ? t.getProfesor().getNombreCompleto() : "sin profesor")
								+ df.format(new Date());

				generarXlsTaller(t, nombreServicioTaller, locale, outputStream);
				
				return nombreFichero;
			}
		}
		
		return null;
	}

	private String streamMatriculadosCharla(String idCharla, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		String nombreServicioCharla = "";

		if (idCharla != null && !idCharla.trim().isEmpty()) {
			long id = Long.parseLong(idCharla);
			Charla c = (Charla)service.find(Charla.class, id);

			if (c != null) {
				DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);

				nombreServicioCharla = GetActividadNombre(c, locale);

				String nombreFichero =
					nombreServicioCharla.trim().replaceAll(" ", "_") + "_" + df.format(c.getFechaInicio())
						+ "_" + c.getHorario() + (c.getProfesor() != null ? c.getProfesor().getNombreCompleto() : "sin proferor")
						+ "_matriculados_" + df.format(new Date());

				generarXlsCharla(c, nombreServicioCharla, locale, outputStream);
				
				return nombreFichero;
			}
		}
		
		return null;
	}

	private String streamEmpleados(Long idCentro, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		List<Empleado> empleados = new ArrayList<Empleado>();
		Centro c = null;

		if (idCentro == null || idCentro <= 0)
			empleados = (List<Empleado>)service.findWhere(Empleado.class, "desactivado", false);
		else {
			Map<String, Object> propiedades = new HashMap<String, Object>();

			c = (Centro)service.find(Centro.class, idCentro);

			propiedades.put("centro", c);
			propiedades.put("desactivado", false);

			empleados = (List<Empleado>)service.findWhere(Empleado.class, propiedades);
		}

		if (empleados != null && !empleados.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Empleados_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());
			
			generarXlsEmpleados(empleados, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}
	
	private String streamProveedores(Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		List<Proveedor> proveedores = new ArrayList<Proveedor>();

		proveedores = (List<Proveedor>)service.findWhere(Proveedor.class, "desactivado", false);

		if (proveedores != null && !proveedores.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Proveedores_" + df.format(new Date());
			
			generarXlsProveedores(proveedores, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamUsuarios(Long idCentro, Long indActivoLDAP, Locale locale, ByteArrayOutputStream outputStream) throws IOException {

		List<UsuarioCyL> usuarioCyLs = new ArrayList<UsuarioCyL>();
		Centro c = null;
		
		if(idCentro > 0 || indActivoLDAP > 0){
			Map<String, Object> propiedades = new HashMap<String, Object>();
			propiedades.put("desactivado", false);
			
			if (idCentro > 0){
				c = (Centro)service.find(Centro.class, idCentro);
				propiedades.put("centro", c);
			}
			
			if (indActivoLDAP != null && indActivoLDAP.longValue() > 0){
				Boolean bIndActivoLDAP = (indActivoLDAP.longValue()==2);
				propiedades.put("desactivadoLDAP", bIndActivoLDAP);
			}
			
			usuarioCyLs = (List<UsuarioCyL>)service.findWhere(UsuarioCyL.class, propiedades);
		} else {
			usuarioCyLs = (List<UsuarioCyL>)service.findWhere(UsuarioCyL.class, "desactivado", false);
		}

		if (usuarioCyLs != null && !usuarioCyLs.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Usuarios_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());
			
			generarXlsUsuarios(usuarioCyLs, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamUsuariosPre(Long idCentro, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<UsuarioPre> usuarioPres = new ArrayList<UsuarioPre>();
		Centro c = null;

		if (idCentro == null || idCentro <= 0)
			usuarioPres = (List<UsuarioPre>)service.findWhere(UsuarioPre.class, "desactivado", false);
		else{
			Map<String, Object> propiedades = new HashMap<String, Object>();

			c = (Centro)service.find(Centro.class, idCentro);
	
			propiedades.put("centro", c);
			propiedades.put("desactivado", false);
	
			usuarioPres = (List<UsuarioPre>)service.findWhere(UsuarioPre.class, propiedades);
		}

			
		if (usuarioPres != null && !usuarioPres.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Usuarios_Preregistrados" + df.format(new Date());
			
			generarXlsUsuariosPre(usuarioPres, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamCursosConPlaza(Long idCentro, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Curso> cursos = null;
		Centro c = null;

		if (idCentro == null || idCentro <= 0)
			cursos = (List<Curso>)service.findAll(Curso.class);
		else {
			c = (Centro)service.find(Centro.class, idCentro);
			cursos = (List<Curso>)service.findWhere(Curso.class, "centro", c);
		}

		if (cursos != null && !cursos.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Cursos_con_Plazas_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			generarXlsCursos(cursos, null, true, true, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamCursos(Long idCentro, Long idTematica, Long indIniciativaSingular, Long indVideoconferencia, Long fechaInicio, Long fechaFin, 
			Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		DateFormat dfo = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		List<Curso> cursos = null;
		Centro c = null;
		Tematica t = null;
		Date fechaI = null;
		Date fechaF = null;
		String query = "";
	    
		
		if(fechaInicio > 0 ) {
			fechaI = new Date(fechaInicio);       
		}
		
		if(fechaFin > 0) {
			fechaF = new Date(fechaFin);
		}
		
		query = "select e from " + Curso.class.getName() + " e ";
		if(idCentro > 0 || idTematica > 0 || indIniciativaSingular > 0 || indVideoconferencia > 0 || fechaI != null || fechaF != null){
			query += " where 0=0 ";

			if (idCentro > 0){
				c = (Centro)service.find(Centro.class, idCentro);
				query += " AND centro.id = " + c.getId();
			}
			
			if (idTematica > 0){
				t = (Tematica)service.find(Tematica.class, idTematica);
				query += " AND servicio.tematica.id = " + t.getId();
			}
			
			if (indIniciativaSingular != null && indIniciativaSingular.longValue() > 0){
				String sIndIniciativaSingular = (indIniciativaSingular.longValue()==1)?"true":"false";
				query += " AND iniciativaSingular = " + sIndIniciativaSingular;
			}

			if (indVideoconferencia != null && indVideoconferencia.longValue() > 0){
				String sIndVideoconferencia = (indVideoconferencia.longValue()==1)?"true":"false";
				query += " AND videoconferencia = " + sIndVideoconferencia;
			}
			
			if(fechaI != null)
				query += " AND fechaFin >='" + dfo.format(fechaI) + "' ";
			
			if(fechaF != null)
				query += " AND fechaInicio <='" + dfo.format(fechaF) + "'";
			
			cursos = (List<Curso>)service.findByQuery(Curso.class, query);
		} else {
			cursos = (List<Curso>)service.findAll(Curso.class);
		}
		
		if (cursos != null && !cursos.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Cursos_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());
			
			//Almacenamos el periodo de la busqueda
			setPeriodoInicio(fechaI);
			setPeriodoFin(fechaF);
			
			generarXlsCursos(cursos, null, false, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamCursosBrowser(Long idCentro, String filtros, Long indPlazasLibres, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		List<CursoLanguage> cursosLanguaje = null;
		List<Curso> cursos = null;
		Centro c = null;
		String query = "";
		
		if (idCentro > 0){
			c = (Centro)service.find(Centro.class, idCentro);
		}
		
		if(filtros != null){
		
			query = "select e from " + CursoLanguage.class.getName() + " e ";
			query += " where 0=0 ";
			
			ByteArrayInputStream inWhereFilter = new ByteArrayInputStream(Base64.decodeBase64(filtros.getBytes()));
		    try {
				ArrayList<String> filtrosList = (ArrayList<String>) new ObjectInputStream(inWhereFilter).readObject();
				query += filtrosList.remove(filtrosList.size()-1);

				for(int i=0; i<filtrosList.size(); i++ ){
					query = query.replaceFirst("\\?", filtrosList.get(i));
				}
					
				cursosLanguaje = (List<CursoLanguage>)service.findByQuery(CursoLanguage.class, query);
				cursos = new ArrayList<Curso>();
				for (CursoLanguage oCursoLanguaje : cursosLanguaje) {
					if(!cursos.contains(oCursoLanguaje.getCurso()))
						cursos.add(oCursoLanguaje.getCurso());
				}
				
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			cursos = (List<Curso>)service.findAll(Curso.class);
		}
		
		if (cursos != null && !cursos.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Cursos_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());
			
			generarXlsCursos(cursos, indPlazasLibres, false, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}
	
	private String streamServiciosCursos(Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<ServicioCurso> servicios = (List<ServicioCurso>)service.findAll(ServicioCurso.class);

		if (servicios != null && !servicios.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_ServiciosCursos_" + df.format(new Date());

			generarXlsServiciosCursos(servicios, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamServiciosTalleres(Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<ServicioTaller> servicios = (List<ServicioTaller>)service.findAll(ServicioTaller.class);

		if (servicios != null && !servicios.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_ServiciosTalleres_" + df.format(new Date());
			
			generarXlsServiciosTalleres(servicios, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamTalleresConPlaza(Long idCentro, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Taller> talleres = null;
		Centro c = null;
		
		if (idCentro == null || idCentro <= 0)
			talleres = (List<Taller>)service.findAll(Taller.class);
		else {
			c = (Centro)service.find(Centro.class, idCentro);
			talleres = (List<Taller>)service.findWhere(Taller.class, "centro", c);
		}
		
		if (talleres != null && !talleres.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Talleres_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());
			
			generarXlsTalleres(talleres, true, true, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamTalleres(Long idCentro, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Taller> talleres = null;
		Centro c = null;
		
		if (idCentro == null || idCentro <= 0)
			talleres = (List<Taller>)service.findAll(Taller.class);
		else {
			c = (Centro)service.find(Centro.class, idCentro);
			talleres = (List<Taller>)service.findWhere(Taller.class, "centro", c);
		}
		
		if (talleres != null && !talleres.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Talleres_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			generarXlsTalleres(talleres, false, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamCursosPersonal(String idPersonal, String nombrePersonal, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Curso> cursos = ((Empleado)service.find(Empleado.class, Long.parseLong(idPersonal))).getCursos();
		
		if (cursos != null && !cursos.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Cursos_" + (nombrePersonal.trim()) + "_" + df.format(new Date());

			generarXlsCursos(cursos, null, false, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamCursosProximosPersonal(String idPersonal, String nombrePersonal, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Curso> cursos = ((Empleado)service.find(Empleado.class, Long.parseLong(idPersonal))).getCursos();

		if (cursos != null && !cursos.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Cursos_Proximos" + (nombrePersonal.trim()) + "_" + df.format(new Date());

			generarXlsCursos(cursos, null, true, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamTalleresPersonal(String idPersonal, String nombrePersonal, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Taller> talleres = ((Empleado)service.find(Empleado.class, Long.parseLong(idPersonal))).getTalleres();
			
		if (talleres != null && !talleres.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Talleres_" + (nombrePersonal.trim()) + "_" + df.format(new Date());

			generarXlsTalleres(talleres, false, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamTalleresProximosPersonal(String idPersonal, String nombrePersonal, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Taller> talleres = ((Empleado)service.find(Empleado.class, Long.parseLong(idPersonal))).getTalleres();
		
		if (talleres != null && !talleres.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Talleres_" + (nombrePersonal.trim()) + "_" + df.format(new Date());
			
			generarXlsTalleres(talleres, true, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamCharlasConPlaza(Long idCentro, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Charla> charlas = null;
		Centro c = null;

		if (idCentro == null || idCentro <= 0)
			charlas = (List<Charla>)service.findAll(Charla.class);
		else {
			c = (Centro)service.find(Centro.class, idCentro);
			charlas = (List<Charla>)service.findWhere(Charla.class, "centro", c);
		}

		if (charlas != null && !charlas.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Charlas_con_Plazas_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			generarXlsCharlas(charlas, null, true, true, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamCharlas(Long idCentro, Long idTematica, Long indIniciativaSingular, Long indVideoconferencia, Long fechaInicio, Long fechaFin, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		DateFormat dfo = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		List<Charla> charlas = null;
		Centro c = null;
		Tematica t = null;
		Date fechaI = null;
		Date fechaF = null;
		String query = "";
		
		if(fechaInicio > 0 ) {
			fechaI = new Date(fechaInicio);       
		}
		
		if(fechaFin > 0) {
			fechaF = new Date(fechaFin);
		}

		query = "select e from " + Charla.class.getName() + " e ";
		if(idCentro > 0 || idTematica > 0 || indIniciativaSingular > 0 || indVideoconferencia > 0 || fechaI != null || fechaF != null){
			query += " where 0=0 ";

			if (idCentro > 0){
				c = (Centro)service.find(Centro.class, idCentro);
				query += " AND centro.id = " + c.getId();
			}
			
			if (idTematica > 0){
				t = (Tematica)service.find(Tematica.class, idTematica);
				query += " AND tematica.id = " + t.getId();
			}
			
			if (indIniciativaSingular != null && indIniciativaSingular.longValue() > 0){
				String sIndIniciativaSingular = (indIniciativaSingular.longValue()==1)?"true":"false";
				query += " AND iniciativaSingular = " + sIndIniciativaSingular;
			}
			
			if (indVideoconferencia != null && indVideoconferencia.longValue() > 0){
				String sIndVideoconferencia = (indVideoconferencia.longValue()==1)?"true":"false";
				query += " AND videoconferencia = " + sIndVideoconferencia;
			}
			
			if(fechaI != null)
				query += " AND fechaFin >='" + dfo.format(fechaI) + "' ";
			
			if(fechaF != null)
				query += " AND fechaInicio <='" + dfo.format(fechaF) + "'";
			
			charlas = (List<Charla>)service.findByQuery(Charla.class, query);
		} else {
			charlas = (List<Charla>)service.findAll(Charla.class);
		}

		if (charlas != null && !charlas.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Charlas_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			//Almacenamos el periodo de la busqueda
			setPeriodoInicio(fechaI);
			setPeriodoFin(fechaF);
			
			generarXlsCharlas(charlas, null, false, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamCharlasBrowser(Long idCentro, String filtros, Long indPlazasLibres, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		List<CharlaLanguage> charlasLanguaje = null;
		List<Charla> charlas = null;
		Centro c = null;
		String query = "";
		
		if (idCentro > 0){
			c = (Centro)service.find(Centro.class, idCentro);
		}
		
		if(filtros != null){
		
			query = "select e from " + CharlaLanguage.class.getName() + " e ";
			query += " where 0=0 ";
			
			ByteArrayInputStream inWhereFilter = new ByteArrayInputStream(Base64.decodeBase64(filtros.getBytes()));
		    try {
				ArrayList<String> filtrosList = (ArrayList<String>) new ObjectInputStream(inWhereFilter).readObject();
				query += filtrosList.remove(filtrosList.size()-1);

				for(int i=0; i<filtrosList.size(); i++ ){
					query = query.replaceFirst("\\?", filtrosList.get(i));
				}
					
				charlasLanguaje = (List<CharlaLanguage>)service.findByQuery(CharlaLanguage.class, query);
				charlas = new ArrayList<Charla>();
				for (CharlaLanguage oCharlaLanguaje : charlasLanguaje) {
					if(!charlas.contains(oCharlaLanguaje.getCharla()))
						charlas.add(oCharlaLanguaje.getCharla());
				}
				
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			charlas = (List<Charla>)service.findAll(Charla.class);
		}
		
		if (charlas != null && !charlas.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Charlas_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());
			
			generarXlsCharlas(charlas, indPlazasLibres, false, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}
	
	private String streamTodoInventario(Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Recurso> recursos = (List<Recurso>)service.findAllOrder(Recurso.class, "centro,categoria.nombre,nombre", true);
		
		if (recursos != null && !recursos.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Inventario_Completo_" + df.format(new Date());

			generarXlsInventario(recursos, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamInventario(long idCentro, long idCategoria, EstadoRecurso estado, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		Map<String, Object> propiedades = new HashMap<String, Object>();
		String filtros = "_";
		
		if (idCentro > 0) {
			propiedades.put("centro.id", idCentro);
			filtros += "Centro_'" + ((Centro)service.find(Centro.class, idCentro)).getNombre() + "'_";
		}

		if (idCategoria > 0) {
			propiedades.put("categoria.id", idCategoria);
			filtros += "Categoria_'" + ((CategoriaRecurso)service.find(CategoriaRecurso.class, idCategoria)).getNombre() + "'_";
		}

		if (estado != null) {
			propiedades.put("estado", estado);
			filtros += "Estado_'" + estado.toString() + "'_";
		}

		List<Recurso> recursos = (List<Recurso>)service.findWhereOrder(Recurso.class, propiedades, "categoria.nombre,nombre", true);
		if (recursos != null && !recursos.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Inventario" + filtros + df.format(new Date());

			generarXlsInventario(recursos, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamTodoIncidencias(Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Incidencia> incidencias2 = (List<Incidencia>)service.findAllOrder(Incidencia.class, "id", false); // centro,criticidad,nombre
		List<Incidencia> incidencias = getIncidenciasVisibles(incidencias2);

		if (incidencias != null && !incidencias.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Incidencias_Completo_" + df.format(new Date());

			generarXlsIncidencias(incidencias, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamFacturas(long idProyecto, long idSubproyecto, long idProveedor, long idResponsableArea, long fechaInicioInMillis,
			long fechaFinInMillis, String stringTipoEstadoFactura, String stringEstadoDocumentacion, Locale locale,
			ByteArrayOutputStream outputStream) throws IOException {
		boolean where = false;
		StringBuffer buffer = new StringBuffer();

		buffer.append("SELECT e FROM ").append(Factura.class.getName()).append(" e");

		if (idProyecto > 0) {
			buffer.append(where == false ? " WHERE" : " AND");
			where = true;

			buffer.append(" (contenedor.proyectoRaiz.proyecto.id = :idProyecto OR contenedor.proyectoRaiz.proyecto.proyectoGeneral.id = :idProyecto)");
		}
		if (idSubproyecto > 0) {
			buffer.append(where == false ? " WHERE" : " AND");
			where = true;

			buffer.append(" contenedor.proyectoRaiz.proyecto.id = :idSubproyecto");
		}
		if (idProveedor > 0) {
			buffer.append(where == false ? " WHERE" : " AND");
			where = true;

			buffer.append(" proveedor.id = :idProveedor");
		}
		if (idResponsableArea > 0) {
			buffer.append(where == false ? " WHERE" : " AND");
			where = true;

			buffer.append(" contenedor.seccionRaiz.responsable.id = :idResponsableArea");
		}
		if (fechaInicioInMillis > 0) {
			buffer.append(where == false ? " WHERE" : " AND");
			where = true;

			buffer.append(" fechaIntroduccion >= :fechaInicio");
		}
		if (fechaFinInMillis > 0) {
			buffer.append(where == false ? " WHERE" : " AND");
			where = true;

			buffer.append(" fechaIntroduccion <= :fechaFin");
		}
		if (!stringTipoEstadoFactura.equals("0")) {
			buffer.append(where == false ? " WHERE" : " AND");
			where = true;

			buffer.append(" estadoActual.tipoEstadoFactura = :tipoEstadoFactura");
		}
		if (!stringEstadoDocumentacion.equals("0")) {
			buffer.append(where == false ? " WHERE" : " AND");
			where = true;

			EstadoDocumentoFactura estadoDocumentoFactura = EstadoDocumentoFactura.valueOf(stringEstadoDocumentacion);
			
			if (estadoDocumentoFactura == EstadoDocumentoFactura.PENDIENTE_JUSTIFICACION)
				buffer.append(" justificada = false AND aprobadaJunta = false");
			else if (estadoDocumentoFactura == EstadoDocumentoFactura.PENDIENTE_APROBACION_JUNTA)
				buffer.append(" justificada = true AND aprobadaJunta = false");
			else if (estadoDocumentoFactura == EstadoDocumentoFactura.APROBADA_JUNTA)
				buffer.append(" justificada = true AND aprobadaJunta = true");
		}

		buffer.append(" ORDER BY id ASC");

		Query query = service.getEntityManager().createQuery(buffer.toString());
		
		if (idProyecto > 0)
			query.setParameter("idProyecto", idProyecto);

		if (idSubproyecto > 0)
			query.setParameter("idSubproyecto", idSubproyecto);

		if (idProveedor > 0)
			query.setParameter("idProveedor", idProveedor);

		if (idResponsableArea > 0)
			query.setParameter("idResponsableArea", idResponsableArea);

		if (fechaInicioInMillis > 0) {
			Date fechaInicio = new Date(fechaInicioInMillis);
			query.setParameter("fechaInicio", fechaInicio);
		}

		if (fechaFinInMillis > 0) {
			Date fechaFin = new Date(fechaFinInMillis);
			query.setParameter("fechaFin", fechaFin);
		}

		if (!stringTipoEstadoFactura.equals("0")) {
			TipoEstadoFactura tipoEstadoFactura = TipoEstadoFactura.valueOf(stringTipoEstadoFactura);
			query.setParameter("tipoEstadoFactura", tipoEstadoFactura);
		}

		@SuppressWarnings("unchecked")
		List<Factura> facturas = (List<Factura>)query.getResultList();
		
		if (facturas != null && !facturas.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Facturas_Filtradas_" + df.format(new Date());

			generarXlsFacturas(facturas, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamIncidencias(long idCentro, Criticidad criticidad, EstadoIncidencia estado, long idCategoriaIncidencia,
			Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		Map<String, Object> propiedades = new HashMap<String, Object>();
		String filtros = "_";
		
		if (idCentro > 0) {
			propiedades.put("centro.id", idCentro);
			filtros += "Centro_'" + ((Centro)service.find(Centro.class, idCentro)).getNombre() + "'_";
		}
		
		if (criticidad != null) {
			propiedades.put("criticidad", criticidad);
			filtros += "Criticidad_'" + criticidad.toString() + "'_";
		}
		
		if (estado != null) {
			propiedades.put("estado", estado);
			filtros += "Estado_'" + estado.toString() + "'_";
		}
		
		if (idCategoriaIncidencia > 0) {
			propiedades.put("categoriaIncidencia.id", idCategoriaIncidencia);
			filtros += "Categoria_'" + ((CategoriaIncidencia)service.find(CategoriaIncidencia.class, idCategoriaIncidencia)).getNombre() + "'_";
		}
		
		List<Incidencia> incidencias2 = (List<Incidencia>)service.findWhereOrder(Incidencia.class, propiedades, "criticidad", true);
		List<Incidencia> incidencias = getIncidenciasVisibles(incidencias2);
		
		if (incidencias != null && !incidencias.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Incidencias_filtrado" + filtros + df.format(new Date());

			generarXlsIncidencias(incidencias, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamAsesoramientos(Long idCentro, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Asesoramiento> asesoramientos;
		Centro c = null;
		
		if (idCentro == null || idCentro <= 0)
			asesoramientos = (List<Asesoramiento>)service.findAll(Asesoramiento.class);
		else {
			c = (Centro)service.find(Centro.class, idCentro);
			asesoramientos = (List<Asesoramiento>)service.findWhere(Asesoramiento.class, "centro", c);
		}
		
		if (asesoramientos != null && !asesoramientos.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Asesoramientos_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			generarXlsAsesoramientos(asesoramientos, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamWifis(Long idCentro, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<Wifi> wifis = null;
		Centro c = null;
		
		if (idCentro == null || idCentro <= 0)
			wifis = (List<Wifi>)service.findAll(Wifi.class);
		else {
			c = (Centro)service.find(Centro.class, idCentro);
			wifis = (List<Wifi>)service.findWhere(Wifi.class, "centro", c);
		}
		
		if (wifis != null && !wifis.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Wifis_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			generarXlsWifis(wifis, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamPracticasTalleres(Long idCentro, Long fechaInicio, Long fechaFin, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		DateFormat dfo = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		List<PracticaTaller> practicasTalleres = null;
		Centro c = null;
		Date fechaI = null;
		Date fechaF = null;
		String query = "";
		
		if(fechaInicio > 0 ) {
			fechaI = new Date(fechaInicio);       
		}
		
		if(fechaFin > 0 ) {
			fechaF = new Date(fechaFin);       
		}
		
		//3.4.8 - RF_15_20 Consulta e exportación da información das actividades
		query = "select e from " + PracticaTaller.class.getName() + " e ";
		
		if (idCentro == null || idCentro <= 0) {
			if(fechaI != null) {
				query += "where fecha >='" + dfo.format(fechaI) + "'";
				
				if(fechaF != null)
					query += " AND fecha <='" + dfo.format(fechaF) + "'";
			} else if(fechaF != null) {
				query += "where fecha <='" + dfo.format(fechaF) + "'";
			}
			
			if(fechaI == null && fechaF == null) {
				practicasTalleres = (List<PracticaTaller>)service.findAll(PracticaTaller.class);
			} else {
				practicasTalleres = (List<PracticaTaller>)service.findByQuery(PracticaTaller.class, query);
			}
		} else {
			c = (Centro)service.find(Centro.class, idCentro);
			query += "where centro.id = " + c.getId();
			
			if(fechaI != null) 
				query += " AND fecha >='" + dfo.format(fechaI) + "' ";
			
			if(fechaF != null) 
				query += " AND fecha <='" + dfo.format(fechaF) + "' ";
			
			practicasTalleres = (List<PracticaTaller>) service.findByQuery(PracticaTaller.class, query);
		}
		
		if (practicasTalleres != null && !practicasTalleres.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Cursos_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			//Almacenamos el periodo de la busqueda
			setPeriodoInicio(fechaI);
			setPeriodoFin(fechaF);
			
			generarXlsPracticasTalleres(practicasTalleres, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamPracticasTalleresBrowser(Long idCentro, String filtros, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		List<PracticaTaller> practicasTalleres = null;
		Centro c = null;
		String query = "";
		
		if (idCentro > 0){
			c = (Centro)service.find(Centro.class, idCentro);
		}
		
		if(filtros != null){
		
			query = "select e from " + PracticaTaller.class.getName() + " e ";
			query += " where 0=0 ";
			
			ByteArrayInputStream inWhereFilter = new ByteArrayInputStream(Base64.decodeBase64(filtros.getBytes()));
		    try {
				ArrayList<String> filtrosList = (ArrayList<String>) new ObjectInputStream(inWhereFilter).readObject();
				query += filtrosList.remove(filtrosList.size()-1);

				for(int i=0; i<filtrosList.size(); i++ ){
					query = query.replaceFirst("\\?", filtrosList.get(i));
				}
					
				practicasTalleres = (List<PracticaTaller>)service.findByQuery(PracticaTaller.class, query);
				
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			practicasTalleres = (List<PracticaTaller>) service.findByQuery(PracticaTaller.class, query);
		}
		
		if (practicasTalleres != null && !practicasTalleres.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Cursos_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());
			
			generarXlsPracticasTalleres(practicasTalleres, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}
	
	private String streamExternasConPlaza(Long idCentro, Long idProveedor, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		List<ActividadExterna> externas = null;
		Centro c = null;

		/*
		if (idCentro == null || idCentro <= 0)
			externas = (List<ActividadExterna>)service.findAll(ActividadExterna.class);
		else {
			c = (Centro)service.find(Centro.class, idCentro);
			externas = (List<ActividadExterna>)service.findWhere(ActividadExterna.class, "centro", c);
		}
		*/

		Map<String, Object> properties = new HashMap<String, Object>();
		if (idCentro > 0){
			properties.put("centro.id", idCentro);
		}
		if (idProveedor > 0){
			properties.put("colaborador.proveedor.id", idProveedor);			
		}
		if (properties.size()>0){
			externas = (List<ActividadExterna>)service.findWhere(ActividadExterna.class, properties);
		} else {
			externas = (List<ActividadExterna>)service.findAll(ActividadExterna.class);
		}
		
		if (externas != null && !externas.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Actividades_Externas_con_Plazas_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			generarXlsExternas(externas, true, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}

	private String streamExternasBrowser(Long idCentro, String filtros, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		List<ActividadExternaLanguage> externasLanguaje = null;
		List<ActividadExterna> externas = null;
		Centro c = null;
		String query = "";
		
		if (idCentro > 0){
			c = (Centro)service.find(Centro.class, idCentro);
		}
		
		if(filtros != null){
		
			query = "select e from " + ActividadExternaLanguage.class.getName() + " e ";
			query += " where 0=0 ";
			
			ByteArrayInputStream inWhereFilter = new ByteArrayInputStream(Base64.decodeBase64(filtros.getBytes()));
		    try {
				ArrayList<String> filtrosList = (ArrayList<String>) new ObjectInputStream(inWhereFilter).readObject();
				query += filtrosList.remove(filtrosList.size()-1);

				for(int i=0; i<filtrosList.size(); i++ ){
					query = query.replaceFirst("\\?", filtrosList.get(i));
				}
					
				externasLanguaje = (List<ActividadExternaLanguage>)service.findByQuery(ActividadExternaLanguage.class, query);
				externas = new ArrayList<ActividadExterna>();
				for (ActividadExternaLanguage oActividadExternaLanguaje : externasLanguaje) {
					if(!externas.contains(oActividadExternaLanguaje.getExterna()))
						externas.add(oActividadExternaLanguaje.getExterna());
				}
				
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		} else {			
			externas = (List<ActividadExterna>)service.findAll(ActividadExterna.class);
		}
		
		if (externas != null && !externas.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Actividades_Externas_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());
			
			generarXlsExternas(externas, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}
	
	private String streamExternas(Long idCentro, Long idProveedor, Long idTematica, Long indIniciativaSingular, Long indVideoconferencia, Long fechaInicio, Long fechaFin, Locale locale, ByteArrayOutputStream outputStream) throws IOException {
		
		DateFormat dfo = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		List<ActividadExterna> externas = null;
		Centro c = null;
		Proveedor p = null;
		Tematica t = null;
		Date fechaI = null;
		Date fechaF = null;
		String query = "";

		
		if(fechaInicio > 0 ) {
			fechaI = new Date(fechaInicio);       
		}
		
		if(fechaFin > 0) {
			fechaF = new Date(fechaFin);
		}
		
		query = "select e from " + ActividadExterna.class.getName() + " e ";
		if(idCentro > 0 || idProveedor > 0 || idTematica > 0 || indIniciativaSingular > 0 || indVideoconferencia > 0 || fechaI != null || fechaF != null){
			query += " where 0=0 ";

			if (idCentro > 0){
				c = (Centro)service.find(Centro.class, idCentro);
				query += " AND centro.id = " + c.getId();
			}
			
			if (idProveedor > 0){
				p = (Proveedor)service.find(Proveedor.class, idProveedor);
				query += " AND colaborador.proveedor.id = " + p.getId();
			}
			
			if (idTematica > 0){
				t = (Tematica)service.find(Tematica.class, idTematica);
				query += " AND tematica.id = " + t.getId();
			}
			
			if (indIniciativaSingular != null && indIniciativaSingular.longValue() > 0){
				String sIndIniciativaSingular = (indIniciativaSingular.longValue()==1)?"true":"false";
				query += " AND iniciativaSingular = " + sIndIniciativaSingular;
			}
			
			if (indVideoconferencia != null && indVideoconferencia.longValue() > 0){
				String sIndVideoconferencia = (indVideoconferencia.longValue()==1)?"true":"false";
				query += " AND videoconferencia = " + sIndVideoconferencia;
			}
			
			if(fechaI != null)
				query += " AND fechaFin >='" + dfo.format(fechaI) + "' ";
			
			if(fechaF != null)
				query += " AND fechaInicio <='" + dfo.format(fechaF) + "'";
			
			externas = (List<ActividadExterna>)service.findByQuery(ActividadExterna.class, query);
		} else {
			externas = (List<ActividadExterna>)service.findAll(ActividadExterna.class);
		}
		
		if (externas != null && !externas.isEmpty()) {
			DateFormat df = new SimpleDateFormat("yyyy-MM-dd", locale);
			String nombreFichero = "Listado_Actividades_Externas_" + (c != null ? c.getNombre() + "_" : "") + df.format(new Date());

			//Almacenamos el periodo de la busqueda
			setPeriodoInicio(fechaI);
			setPeriodoFin(fechaF);
			
			generarXlsExternas(externas, false, locale, outputStream);
			
			return nombreFichero;
		}
		
		return null;
	}
	
	/**
	 * Construye la cadena HQL para la consulta de actividades tipo Curso 
	 * @param fechaInicio
	 * @param fechaFin
	 * @param locale
	 * @return
	 */
	private String buildHQLActividadCursos(Long fechaInicio, Long fechaFin, Locale locale){
		
		DateFormat dfoI = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		DateFormat dfoF = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
		Date fechaI = (fechaInicio > 0) ? new Date(fechaInicio) : null;
		Date fechaF = (fechaFin > 0) ? new Date(fechaFin) : null;
		
		String sHQL = "SELECT " +
					 "c.id AS id, " +
					 "'CURSO' AS tipo, " +
					 "tp.nombre AS tematica_padre, " +
					 "tl.nombre AS tematica, " +
					 "sl.nombre AS servicio, " +
					 "cl.apodo AS apodo, " +
					 "c.centro.nombre AS centro, " +
					 "c.centro.provincia.nombre AS provincia, " +
					 "c.numeroPlazas AS plazasTotales, " +
					 "c.fechaInicio AS fechaInicio, " +
					 "c.fechaFin AS fechaFin, " +
					 "c.horaInicio AS horaInicio, " +
					 "c.horaFin AS horaFin, " +
					 //"c.numeroHoras AS duracionTotal, " +
					 "(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60), 2)), 0.00) + 0.00 " + 
						"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
						"WHERE cuci.actividad.id = c.id) AS duracionTotal, " +	
					 "c.iniciativaSingular AS iniciativaSingular, " +
					 "c.videoconferencia AS videoconferencia, " +						
					 "(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m WHERE ((m.admitido = TRUE) AND (m.enListaEspera = FALSE))) AS nMatriculas, " + 
					 "(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m WHERE ((m.desactivado = FALSE) AND (m.cancelada = FALSE))) AS nInscripciones, " +
					 /*"(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m WHERE ((m.asistencia IS NOT NULL) AND (m.asistencia >= 80)) AND (c.cerrada = TRUE)) AS nAsistencias, " +*/
					 "0 AS nAsistencias, " +
					 "c.cerrada AS estado, " +
					 "(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60), 2)), 0.00) + 0.00 " + 
						"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
						"WHERE (cuci.actividad.id = c.id) AND (cuci.start <= '" + dfoF.format(fechaF) + "' AND cuci.end >= '" + dfoI.format(fechaI) + "')) AS duracionPeriodo, " +
					 /*"(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60.00), 2)), 0.00) + 0.00 " + 
						"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
						"WHERE (cuci.actividad.id = c.id) AND (cuci.start <= '" + dfo.format(fechaF) + "' AND cuci.end >= '" + dfo.format(fechaI) + "')) AS duracionPeriodo, " +*/
					 /*"(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m " + 
						"WHERE ((m.asistencia IS NOT NULL) AND (m.asistencia >= 80))) AS realizada " +*/
					 "0 AS realizada " +					 
				"FROM " + Curso.class.getName() + " c " + 
					"INNER JOIN c.textosCurso cl " +
					"INNER JOIN cl.language lc WITH (lc.ISO LIKE '" + locale + "') " +
					"INNER JOIN c.servicio.tematica.padre.textos tp " +
					"INNER JOIN tp.language ltp WITH (ltp.ISO LIKE '" + locale + "') " +
					"INNER JOIN c.servicio.tematica.textos tl " +					
					"INNER JOIN tl.language lt WITH (lt.ISO LIKE '" + locale + "') " +
					"INNER JOIN c.servicio.textos sl " +
					"INNER JOIN sl.language st WITH (st.ISO LIKE '" + locale + "') " +
				"WHERE (c.desactivado = FALSE) AND (c.fechaInicio <= '" + dfoF.format(fechaF) + 
				"' AND c.fechaFin >= '" + dfoI.format(fechaI) + "')" +
				" :filtro_adicional ";

		return sHQL;
	}
	
	/**
	 * Construye la cadena HQL para la consulta de asistentes tipo Curso 
	 * @param fechaInicio
	 * @param fechaFin
	 * @return
	 */
	private String buildHQLAsistenciasCursos(Long fechaInicio, Long fechaFin){
		DateFormat dfoI = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		DateFormat dfoF = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
		Date fechaI = (fechaInicio > 0) ? new Date(fechaInicio) : null;
		Date fechaF = (fechaFin > 0) ? new Date(fechaFin) : null;
		
		String sHQL = "SELECT " +
					"c.id AS idActividad, " +
					"mc.usuario.id as idUsuario, " +
					"aci.excepcion as excepcion, " +
					"COALESCE(SUM(ROUND((HOUR(aci.end) - HOUR(aci.start)) + ((MINUTE(aci.end) - MINUTE(aci.start)) / 60), 2)), 0.00) + 0.00 as horas, " +
					"COUNT(aci) as jornadas " +
				"FROM " + MatriculaCurso.class.getName() + " mc " + 
					"INNER JOIN mc.curso c " +	
					"INNER JOIN c.asistencias aci " + 
				"WHERE c.desactivado = FALSE AND mc.desactivado = FALSE AND aci.usuario = mc.usuario AND " +
				 	"(c.fechaInicio <= '" + dfoF.format(fechaF) + "' AND c.fechaFin >= '" + dfoI.format(fechaI) + "') " +
				 	" :filtro_adicional " +
				"GROUP BY c.id, mc.usuario.id, aci.excepcion " + 
				"ORDER BY c.id, mc.usuario.id, aci.excepcion ";
		
		return sHQL;
	}
	
	/**
	 * Construye la cadena HQL para la consulta de participacion tipo Curso 
	 * @param fechaInicio
	 * @param fechaFin
	 * @param locale
	 * @return
	 */
	private String buildHQLParticipacionCursos(Long fechaInicio, Long fechaFin, Locale locale){
		
		DateFormat dfoI = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		DateFormat dfoF = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
		Date fechaI = (fechaInicio > 0) ? new Date(fechaInicio) : null;
		Date fechaF = (fechaFin > 0) ? new Date(fechaFin) : null;
		
		String sHQL = "SELECT " +
				 "c.id AS id, " +
				 "'CURSO' AS tipo, " +
				 "tp.nombre AS tematica_padre, " +
				 "tl.nombre AS tematica, " +
				 "sl.nombre AS servicio, " +
				 "cl.apodo AS apodo, " +
				 "cnt.nombre AS centro, " +
				 "prv.nombre AS provincia, " +
				 "c.numeroPlazas AS plazasTotales, " +
				 "c.fechaInicio AS fechaInicio, " +
				 "c.fechaFin AS fechaFin, " +
				 "c.horaInicio AS horaInicio, " +
				 "c.horaFin AS horaFin, " +
				 /*"c.numeroHoras AS duracionTotal, " +*/
				 "(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60), 2)), 0.00) + 0.00 " + 
					"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
					"WHERE cuci.actividad.id = c.id) AS duracionTotal, " +	
				 "c.iniciativaSingular AS iniciativaSingular, " +
				 "c.videoconferencia AS videoconferencia, " +						
				 "ucyl.username AS nif, " +
				 "ucyl.nombre AS nombre, " +
				 "ucyl.apellido1 AS apellido1, " +
				 "ucyl.apellido2 AS apellido2, " +
				 "ucyl.sexo AS sexo, " +
				 "DATE_FORMAT(FROM_DAYS(TO_DAYS(NOW())-TO_DAYS(ucyl.fechaNacimiento)), '%Y')+0 AS edad, " +
				 "ucyl.tipoDiscapacidad AS adaptacion, " +
				 "ucyl.tipoEstudiosRealizados AS formacion, " +
				 "ucyl.tipoOcupacion AS ocupacion, " +
				 "0 AS asistencia, " + 
				 "0 AS horasTotalesPonderadas, " +
				 "0 AS horasTotalesAsistencia, " +
				 "0 AS horasTotalesJustificadas, " +
				 "(SELECT ((COALESCE(SUM(ROUND((HOUR(aci.end) - HOUR(aci.start)) + ((MINUTE(aci.end) - MINUTE(aci.start)) / 60.00), 2)), 0.00)) + 0.00) " +
				   "FROM " + Curso.class.getName() + " cu INNER JOIN " +
					 "cu.asistencias aci " + 
					 "WHERE cu.desactivado = false AND cu = mc.curso AND aci.usuario.id = mc.usuario.id AND aci.excepcion = 'SIN' AND " +
					 "((cu.fechaInicio <= '" + dfoF.format(fechaF) + "' AND (cu.fechaFin >= '" + dfoI.format(fechaI) + "')) AND " + 
					 "((aci.start <= '" + dfoF.format(fechaF) + "' AND aci.end >= '" + dfoI.format(fechaI) + "')))) AS horasAsistenciaParciales, " +
				 "ucyl.id AS id_usuario " +					 
			 "FROM " + MatriculaCurso.class.getName() + " mc " + 
				 "INNER JOIN mc.curso c " +							 
				 "INNER JOIN mc.usuario ucyl " +
				 "INNER JOIN c.centro cnt " +
				 "INNER JOIN cnt.provincia prv " +
				 "INNER JOIN c.textosCurso cl " +
				 "INNER JOIN cl.language lc WITH (lc.ISO LIKE '" + locale + "') " +
				 "INNER JOIN c.servicio.tematica.padre.textos tp " +
				 "INNER JOIN tp.language ltp WITH (ltp.ISO LIKE '" + locale + "') " +							 
				 "INNER JOIN c.servicio.tematica.textos tl " +
				 "INNER JOIN tl.language lt WITH (lt.ISO LIKE '" + locale + "') " +
				 "INNER JOIN c.servicio.textos sl " +
				 "INNER JOIN sl.language st WITH (st.ISO LIKE '" + locale + "') " +
			 "WHERE (mc.desactivado = FALSE) AND (c.desactivado = FALSE) AND " + 
			 "(c.fechaInicio <= '" + dfoF.format(fechaF) + "' AND c.fechaFin >= '" + dfoI.format(fechaI) + "')" +
			 " :filtro_adicional ";

		return sHQL;
	}
	
	/**
	 * Construye la cadena HQL para la consulta de actividades tipo Charla 
	 * @param fechaInicio
	 * @param fechaFin
	 * @param locale
	 * @return
	 */
	private String buildHQLActividadCharlas(Long fechaInicio, Long fechaFin, Locale locale){
		
		DateFormat dfoI = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		DateFormat dfoF = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
		Date fechaI = (fechaInicio > 0) ? new Date(fechaInicio) : null;
		Date fechaF = (fechaFin > 0) ? new Date(fechaFin) : null;
		
		String sHQL = "SELECT " +
					 "c.id AS id, " +
					 "'CHARLA' AS tipo, " +
					 "tp.nombre AS tematica_padre, " +
					 "tl.nombre AS tematica, " +
					 "'N/A' AS servicio, " +
					 "cl.nombre AS nombre, " +
					 "c.centro.nombre AS centro, " +
					 "c.centro.provincia.nombre AS provincia, " +
					 "c.numeroPlazas AS plazasTotales, " +
					 "c.fechaInicio AS fechaInicio, " +
					 "c.fechaFin AS fechaFin, " +
					 "c.horaInicio AS horaInicio, " +
					 "c.horaFin AS horaFin, " +
					 "(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60), 2)), 0.00) + 0.00 " + 
						"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
						"WHERE cuci.actividad.id = c.id) AS duracionTotal, " +	
					 "c.iniciativaSingular AS iniciativaSingular, " +
					 "c.videoconferencia AS videoconferencia, " +							
					 "(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m WHERE ((m.admitido = TRUE) AND (m.enListaEspera = FALSE))) AS nMatriculas, " + 
					 "(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m WHERE ((m.desactivado = FALSE) AND (m.cancelada = FALSE))) AS nInscripciones, " +					 
					 /*"(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m WHERE ((m.asistencia IS NOT NULL) AND (m.asistencia >= 80)) AND (c.cerrada = TRUE)) AS nAsistencias, " +*/
					 " 0 AS nAsistencias, " +
					 "c.cerrada AS estado, " +
					 "(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60), 2)), 0.00) + 0.00 " + 
						"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
						"WHERE (cuci.actividad.id = c.id) AND (cuci.start <= '" + dfoF.format(fechaF) + "' AND cuci.end >= '" + dfoI.format(fechaI) + "')) AS duracionPeriodo, " +						
					 /*"(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m " + 
						"WHERE ((m.asistencia IS NOT NULL) AND (m.asistencia >= 80))) AS realizada " +*/					
					 " 0 AS realizada " +
				"FROM " + Charla.class.getName() + " c " + 
					"INNER JOIN c.textosCharla cl " +
					"INNER JOIN cl.language lc WITH (lc.ISO LIKE '" + locale + "') " +
					"INNER JOIN c.tematica.padre.textos tp " +
					"INNER JOIN tp.language ltp WITH (ltp.ISO LIKE '" + locale + "') " +
					"INNER JOIN c.tematica.textos tl " +
					"INNER JOIN tl.language lt WITH (lt.ISO LIKE '" + locale + "') " +
				"WHERE (c.desactivado = FALSE) AND (c.fechaInicio <= '" + dfoF.format(fechaF) + 
				"' AND c.fechaFin >= '" + dfoI.format(fechaI) + "')" +
				" :filtro_adicional ";

		return sHQL;
	}
	
	/**
	 * Construye la cadena HQL para la consulta de asistentes tipo Charla 
	 * @param fechaInicio
	 * @param fechaFin
	 * @return
	 */
	private String buildHQLAsistenciasCharlas(Long fechaInicio, Long fechaFin){
		DateFormat dfoI = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		DateFormat dfoF = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
		Date fechaI = (fechaInicio > 0) ? new Date(fechaInicio) : null;
		Date fechaF = (fechaFin > 0) ? new Date(fechaFin) : null;
		
		String sHQL = "SELECT " +
					"c.id AS idActividad, " +
					"mc.usuario.id as idUsuario, " +
					"aci.excepcion as excepcion, " +
					"COALESCE(SUM(ROUND((HOUR(aci.end) - HOUR(aci.start)) + ((MINUTE(aci.end) - MINUTE(aci.start)) / 60), 2)), 0.00) + 0.00 as horas, " +
					"COUNT(aci) as jornadas " +
				"FROM " + MatriculaCharla.class.getName() + " mc " + 
					"INNER JOIN mc.charla c " +	
					"INNER JOIN c.asistencias aci " +
				"WHERE c.desactivado = FALSE AND mc.desactivado = FALSE AND aci.usuario = mc.usuario AND " + 
				 	"(c.fechaInicio <= '" + dfoF.format(fechaF) + "' AND c.fechaFin >= '" + dfoI.format(fechaI) + "') " +
				 	" :filtro_adicional " +
				"GROUP BY c.id, mc.usuario.id, aci.excepcion " + 
				"ORDER BY c.id, mc.usuario.id, aci.excepcion ";
		
		return sHQL;
	}
	
	/**
	 * Construye la cadena HQL para la consulta de participacion tipo Charla 
	 * @param fechaInicio
	 * @param fechaFin
	 * @param locale
	 * @return
	 */
	private String buildHQLParticipacionCharlas(Long fechaInicio, Long fechaFin, Locale locale){
		
		DateFormat dfoI = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		DateFormat dfoF = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
		Date fechaI = (fechaInicio > 0) ? new Date(fechaInicio) : null;
		Date fechaF = (fechaFin > 0) ? new Date(fechaFin) : null;
		
		String sHQL = "SELECT " +
				 "c.id AS id, " +
				 "'CHARLA' AS tipo, " +
				 "tp.nombre AS tematica_padre, " +
				 "tl.nombre AS tematica, " +
				 "'N/A' AS servicio, " +
				 "cl.nombre AS nombre, " +
				 "cnt.nombre AS centro, " +
				 "prv.nombre AS provincia, " +
				 "c.numeroPlazas AS plazasTotales, " +
				 "c.fechaInicio AS fechaInicio, " +
				 "c.fechaFin AS fechaFin, " +
				 "c.horaInicio AS horaInicio, " +
				 "c.horaFin AS horaFin, " +
				 "(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60), 2)), 0.00) + 0.00 " + 
					"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
					"WHERE cuci.actividad.id = c.id) AS duracionTotal, " +		
				 "c.iniciativaSingular AS iniciativaSingular, " +
				 "c.videoconferencia AS videoconferencia, " +		
				 "ucyl.username AS nif, " +
				 "ucyl.nombre AS nombre, " +
				 "ucyl.apellido1 AS apellido1, " +
				 "ucyl.apellido2 AS apellido2, " +
				 "ucyl.sexo AS sexo, " +
				 "DATE_FORMAT(FROM_DAYS(TO_DAYS(NOW())-TO_DAYS(ucyl.fechaNacimiento)), '%Y')+0 AS edad, " +
				 "ucyl.tipoDiscapacidad AS adaptacion, " +
				 "ucyl.tipoEstudiosRealizados AS formacion, " +
				 "ucyl.tipoOcupacion AS ocupacion, " +
				 "0 AS asistencia, " +
				 "0 AS horasTotalesPonderadas, " +
				 "0 AS horasTotalesAsistencia, " +
				 "0 AS horasTotalesJustificadas, " +
				 "(SELECT ((COALESCE(SUM(ROUND((HOUR(aci.end) - HOUR(aci.start)) + ((MINUTE(aci.end) - MINUTE(aci.start)) / 60.00), 2)), 0.00)) + 0.00) " +
				   "FROM " + Charla.class.getName() + " cu INNER JOIN " +
					 "cu.asistencias aci " + 
					 "WHERE cu.desactivado = false AND cu = mc.charla AND aci.usuario.id = mc.usuario.id AND aci.excepcion = 'SIN' AND " +
					 "((cu.fechaInicio <= '" + dfoF.format(fechaF) + "' AND (cu.fechaFin >= '" + dfoI.format(fechaI) + "')) AND " + 
					 "((aci.start <= '" + dfoF.format(fechaF) + "' AND aci.end >= '" + dfoI.format(fechaI) + "')))) AS horasAsistenciaParciales, " +
				 "ucyl.id AS id_usuario " +					 
			 "FROM " + MatriculaCharla.class.getName() + " mc " + 
				 "INNER JOIN mc.charla c " +							 
				 "INNER JOIN mc.usuario ucyl " +
				 "INNER JOIN c.centro cnt " +
				 "INNER JOIN cnt.provincia prv " +
				 "INNER JOIN c.textosCharla cl " +
				 "INNER JOIN cl.language lc WITH (lc.ISO LIKE '" + locale + "') " +
				 "INNER JOIN c.tematica.padre.textos tp " +
				 "INNER JOIN tp.language ltp WITH (ltp.ISO LIKE '" + locale + "') " +							 
				 "INNER JOIN c.tematica.textos tl " +
				 "INNER JOIN tl.language lt WITH (lt.ISO LIKE '" + locale + "') " +
			 "WHERE (mc.desactivado = FALSE) AND (c.desactivado = FALSE) AND " + 
			 "(c.fechaInicio <= '" + dfoF.format(fechaF) + "' AND c.fechaFin >= '" + dfoI.format(fechaI) + "')" +
			 " :filtro_adicional ";

		return sHQL;
	}
	
	/**
	 * Construye la cadena HQL para la consulta de actividades tipo Charla 
	 * @param fechaInicio
	 * @param fechaFin
	 * @param locale
	 * @return
	 */
	private String buildHQLActividadExternas(Long fechaInicio, Long fechaFin, Locale locale){
		
		DateFormat dfoI = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
		DateFormat dfoF = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
		Date fechaI = (fechaInicio > 0) ? new Date(fechaInicio) : null;
		Date fechaF = (fechaFin > 0) ? new Date(fechaFin) : null;
		
		String sHQL = "SELECT " +
					 "c.id AS id, " +
					 "'EXTERNA' AS tipo, " +
					 "tp.nombre AS tematica_padre, " +
					 "tl.nombre AS tematica, " +
					 /*"sl.nombre AS servicio, " +*/
					 "(SELECT sl.nombre " +
					    "FROM " + ServicioLanguage.class.getName() + " sl " +
					    "INNER JOIN sl.language st WITH (st.ISO LIKE '" + locale + "') " +
					    "WHERE sl.servicio.id = s.id) AS servicio, " +
					 "cl.apodo AS apodo, " +
					 "cnt.nombre AS centro, " +
					 "prv.nombre AS provincia, " +
					 "c.numeroPlazas AS plazasTotales, " +
					 "c.fechaInicio AS fechaInicio, " +
					 "c.fechaFin AS fechaFin, " +
					 "c.horaInicio AS horaInicio, " +
					 "c.horaFin AS horaFin, " +
					 "(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60), 2)), 0.00) + 0.00 " + 
						"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
						"WHERE cuci.actividad.id = c.id) AS duracionTotal, " +	
					 "c.iniciativaSingular AS iniciativaSingular, " +
					 "c.videoconferencia AS videoconferencia, " +		
					 " 0 AS nMatriculas, " +
					 " 0 AS nInscripciones, " +
					 " c.numeroAsistentes AS nAsistencias, " +
					 "c.cerrada AS estado, " +
					 "(SELECT COALESCE(SUM(ROUND((HOUR(cuci.end) - HOUR(cuci.start)) + ((MINUTE(cuci.end) - MINUTE(cuci.start)) / 60.00), 2)), 0.00) + 0.00 " + 
						"FROM " + ActividadCalendarItem.class.getName() + " cuci " + 
						"WHERE (cuci.actividad.id = c.id) AND (cuci.start <= '" + dfoF.format(fechaF) + "' AND cuci.end >= '" + dfoI.format(fechaI) + "')) AS duracionPeriodo, " +						
					 /*"(SELECT (CAST(count(m) AS integer)) FROM c.matriculas m " + 
						"WHERE ((m.asistencia IS NOT NULL) AND (m.asistencia >= 80))) AS realizada " +*/					
					 " c.numeroAsistentes AS realizada " +
				"FROM " + ActividadExterna.class.getName() + " c " + 
				    "LEFT JOIN c.centro cnt " +
				    "LEFT JOIN cnt.provincia prv " +
					"INNER JOIN c.textosExterna cl " +
					"INNER JOIN cl.language lc WITH (lc.ISO LIKE '" + locale + "') " +
					"INNER JOIN c.tematica.padre.textos tp " +
					"INNER JOIN tp.language ltp WITH (ltp.ISO LIKE '" + locale + "') " +
					"INNER JOIN c.tematica.textos tl " +
					"INNER JOIN tl.language lt WITH (lt.ISO LIKE '" + locale + "') " +
					"LEFT JOIN c.servicio s " +
					/*"LEFT JOIN c.servicio.textos sl " +*/
					/*"LEFT JOIN sl.language st WITH (st.ISO LIKE '" + locale + "') " +*/					
				"WHERE (c.desactivado = FALSE) AND (c.fechaInicio <= '" + dfoF.format(fechaF) + 
				"' AND c.fechaFin >= '" + dfoI.format(fechaI) + "')" + 
				" :filtro_adicional ";

		return sHQL;
	}
	
	/**
	 * Genera la cadena HQL para filtrar por el tributo "Tematica"
	 * @param tematicas
	 * @return
	 */
	private String addFiltroTematicas(String tematicas){
		String sHQL ="";
		Tematica th = null;
		
		if(tematicas != null && !tematicas.isEmpty()) {
			sHQL += " AND (";
			
			int count = 0; int last = tematicas.split(",").length;
			
			for(String tematica : tematicas.split(",")) {
				Long t = Long.valueOf(tematica);
				th = (Tematica)service.find(Tematica.class, t);
				sHQL += " (c.servicio.tematica.id = " + th.getId() + ")";
				
				count++;
				
				if(count < (last)) sHQL += " OR";
			}	
			
			sHQL += " ) ";
		}		
		return sHQL;
		
	}
	
	/**
	 * Genera la cadena HQL para filtrar por el tributo "Centro"
	 * @param centroId
	 * @return
	 */
	private String addFiltroCentro(Long centroId){
		String sHQL ="";		
		if(centroId != null && centroId > 0) {
			Centro c = (Centro)service.find(Centro.class, centroId);
			sHQL += " AND (c.centro.id = " + c.getId() + ") ";
		}
		return sHQL;
		
	}
	
	/**
	 * Genera la cadena HQL para filtrar por el tributo "Servicio"
	 * @param servicioId
	 * @return
	 */
	private String addFiltroServicio(Long servicioId){
		String sHQL ="";		
		if(servicioId != null && servicioId > 0) {
			Servicio s = (Servicio)service.find(Servicio.class, servicioId);
			sHQL += " AND (c.servicio.id = " + s.getId() + ") ";
		}		
		return sHQL;
	
	}
		
	/**
	 * Genera la cadena HQL para filtrar por el tributo "Usuario"
	 * @param user
	 * @return
	 */
	private String addFiltroUsuario(String user){
		String sHQL ="";
		if(user != null && !user.isEmpty()) {
			UsuarioCyL ucyl = (UsuarioCyL)service.findOneWhere(UsuarioCyL.class, "username", user);
			sHQL += " AND (ucyl.username = '" + ucyl.getUsername() + "') ";
		}
		return sHQL;
	}

	/**
	 * Genera la cadena HQL para filtrar por el tributo "edad"
	 * @param edadX
	 * @param edadY
	 * @return
	 */
	private String addFiltroEdadUsuario(Integer edadX, Integer edadY){
		String sHQL ="";
		if((edadX != null) && (edadY != null)) {
			String sEdad = " (DATE_FORMAT(FROM_DAYS(TO_DAYS(NOW())-TO_DAYS(ucyl.fechaNacimiento)), '%Y')+0) ";
			sHQL += " AND ("+sEdad+" <= " + edadY + " AND "+sEdad+" >= " + edadX + ") ";
		}
		return sHQL;
	}

	/**
	 * Genera la cadena HQL para filtrar por el tributo "sexo"
	 * @param sexo
	 * @return
	 */
	private String addFiltroSexoUsuario(String sexo){
		String sHQL ="";
		if(sexo != null && !sexo.toString().isEmpty() ) 
			sHQL += " AND (ucyl.sexo = '" + sexo + "') ";
		return sHQL;
	}

	/**
	 * Genera la cadena HQL para filtrar por el tributo "adaptacion"
	 * @param adaptacion
	 * @return
	 */
	private String addFiltroAdaptacionUsuario(String adaptacion){
		String sHQL ="";
		if(adaptacion != null && !adaptacion.toString().isEmpty())
			sHQL += " AND (ucyl.tipoDiscapacidad LIKE '" + adaptacion + "') ";
		return sHQL;
	}
	
	/**
	 * Genera la cadena HQL para filtrar por iniciativa singular
	 * @param adaptacion
	 * @return
	 */
	private String addFiltroIniciativaSingular(Boolean iniciativaSingular){
		String sHQL ="";
		if(iniciativaSingular != null){			
			String sIniciativaSingular = (iniciativaSingular)?"true":"false";
			sHQL += " AND (c.iniciativaSingular = " + sIniciativaSingular + ") ";
		}
		
		return sHQL;
	}
	
	/**
	 * Genera la cadena HQL para filtrar por videoconferencia
	 * @param adaptacion
	 * @return
	 */
	private String addFiltroVideoconferencia(Boolean videoconferencia){
		String sHQL ="";
		if(videoconferencia != null){			
			String sVideoconferencia = (videoconferencia)?"true":"false";
			sHQL += " AND (c.videoconferencia = " + sVideoconferencia + ") ";
		}
		
		return sHQL;
	}
	
	@SuppressWarnings("unchecked")
	private String streamGeneradorInformes(EReportType reportType, String fields, Long centroId, String tematicas, 
									 Long servicioId, EActivityTypes activityType, Long fechaInicio, Long fechaFin,
									 Boolean filtroRealizada, Boolean filtroIniciativaSingular, Boolean filtroVideoconferencia, 
									 String user, Integer edadX, Integer edadY, String sexo, 
									 String adaptacion, EReportDatosTypes reportDatosType, String orden,
									 Locale locale, ByteArrayOutputStream outputStream) throws IOException {

		List<Object[]> result = new ArrayList<Object[]>();
		HashMap<String, List> resultAsistencias = new HashMap();
		String strqry = "";
		String filtro = "";

		/* Consultas de datos basados en actividad */
		if(reportDatosType.equals(EReportDatosTypes.ACTIVIDAD)){
			//Se carga la información de cursos
			if(activityType.equals(EActivityTypes.CURSO) || activityType.equals(EActivityTypes.TODOS)) {
				strqry = buildHQLActividadCursos(fechaInicio, fechaFin, locale);
				filtro = addFiltroTematicas(tematicas) +
						addFiltroCentro(centroId) +
						addFiltroIniciativaSingular(filtroIniciativaSingular) +
						addFiltroVideoconferencia(filtroVideoconferencia) +
						addFiltroServicio(servicioId);
				strqry = strqry.replace(":filtro_adicional", filtro);
				
				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkList = q.getResultList();
				
				strqry = buildHQLAsistenciasCursos(fechaInicio, fechaFin);
				filtro = addFiltroTematicas(tematicas) + 
						addFiltroCentro(centroId) +
						addFiltroIniciativaSingular(filtroIniciativaSingular) +
						addFiltroVideoconferencia(filtroVideoconferencia) +
						addFiltroServicio(servicioId);
				strqry = strqry.replace(":filtro_adicional", filtro);
				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkAsistencia = q.getResultList();

				for(Object[] row : wrkAsistencia) {
					Integer idActividad = castObjectToInteger(row[0]);	
					String keyActividad = idActividad.toString();
					if(!resultAsistencias.containsKey(keyActividad)){
						resultAsistencias.put(keyActividad, new ArrayList<Object[]>());
					}
					ArrayList rowsAsistenciaActividad = (ArrayList)resultAsistencias.get(keyActividad);
					rowsAsistenciaActividad.add(row);
					resultAsistencias.put(keyActividad, rowsAsistenciaActividad);					
				}

				/* Se recalcula la asistencia */
				for (int i = 0; i < wrkList.size(); i++) {
					Object[] oRow =  wrkList.get(i);
					Integer idActividad = castObjectToInteger(oRow[0]);
					String keyActividad = idActividad.toString();
					Float horasTotales = castObjectToFloat(oRow[13]);
					
					ArrayList<Object[]> rowsAsistenciaActividad = (ArrayList<Object[]>)resultAsistencias.get(keyActividad);
					int asistentes = 0;
					if(rowsAsistenciaActividad!=null){						
						HashMap<Integer, Float> horasUsuariosActividad = new HashMap();
						for(Object[] oRowAsistencia : rowsAsistenciaActividad){
							Integer idUsuario = castObjectToInteger(oRowAsistencia[1]);	
							if(!horasUsuariosActividad.containsKey(idUsuario)){
								horasUsuariosActividad.put(idUsuario, Float.valueOf(0));
							}
							float horasTotalesUsuario = ((Float)horasUsuariosActividad.get(idUsuario)).floatValue();
							if(castObjectToString(oRowAsistencia[2]).equals("SIN")){								
								horasTotalesUsuario += castObjectToFloat(oRowAsistencia[3]).floatValue();								
							} else if(castObjectToString(oRowAsistencia[2]).equals("JUSTIFICADA")){
								horasTotalesUsuario += (castObjectToFloat(oRowAsistencia[3]).floatValue()/2);
							}
							horasUsuariosActividad.put(idUsuario, Float.valueOf(horasTotalesUsuario));
						}

						for(Map.Entry<Integer, Float> entry : horasUsuariosActividad.entrySet()) {							
							Float horasUsuarioPonderadas = (Float)entry.getValue();
							Float porcentajeAsistencia = (float) (100 * horasUsuarioPonderadas /  horasTotales);
							if(porcentajeAsistencia >= 80 ){
								++asistentes;
							}
						}
						
						oRow[18]=Integer.valueOf(asistentes);
						oRow[21]=(asistentes>=3)?1:0;
						wrkList.set(i, oRow);
					}
					
					//Filtro realizada
					if( (filtroRealizada == null) || 
						(filtroRealizada.booleanValue() && (asistentes >= 3)) || 
						(!filtroRealizada.booleanValue() && (asistentes < 3)))
						result.add(oRow);										
				}
				//result.addAll(wrkList);
				
			}
			
			//Se carga la información de charlas
			if(activityType.equals(EActivityTypes.CHARLA) || activityType.equals(EActivityTypes.TODOS)) {
				strqry = buildHQLActividadCharlas(fechaInicio, fechaFin, locale);
				filtro = addFiltroTematicas(tematicas) +
						addFiltroCentro(centroId) + 
						addFiltroIniciativaSingular(filtroIniciativaSingular) + 
						addFiltroVideoconferencia(filtroVideoconferencia);
				strqry = strqry.replace(":filtro_adicional", filtro);
				
				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkList = q.getResultList();
				
				strqry = buildHQLAsistenciasCharlas(fechaInicio, fechaFin);
				filtro = addFiltroTematicas(tematicas) +
						addFiltroCentro(centroId) + 
						addFiltroIniciativaSingular(filtroIniciativaSingular) +
						addFiltroVideoconferencia(filtroVideoconferencia);				
				strqry = strqry.replace(":filtro_adicional", filtro);
				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkAsistencia = q.getResultList();

				for(Object[] row : wrkAsistencia) {
					Integer idActividad = castObjectToInteger(row[0]);
					String keyActividad = idActividad.toString(); 
					if(!resultAsistencias.containsKey(keyActividad)){
						resultAsistencias.put(keyActividad, new ArrayList<Object[]>());
					}
					ArrayList rowsAsistenciaActividad = (ArrayList)resultAsistencias.get(keyActividad);
					rowsAsistenciaActividad.add(row);
					resultAsistencias.put(keyActividad, rowsAsistenciaActividad);					
				}

				/* Se recalcula la asistencia */
				for (int i = 0; i < wrkList.size(); i++) {
					Object[] oRow =  wrkList.get(i);
					Integer idActividad = castObjectToInteger(oRow[0]);
					String keyActividad = idActividad.toString();
					Float horasTotales = castObjectToFloat(oRow[13]);
					
					ArrayList<Object[]> rowsAsistenciaActividad = (ArrayList<Object[]>)resultAsistencias.get(keyActividad);
					int asistentes = 0;
					if(rowsAsistenciaActividad!=null){	
						HashMap<Integer, Float> horasUsuariosActividad = new HashMap();
						for(Object[] oRowAsistencia : rowsAsistenciaActividad){
							Integer idUsuario = castObjectToInteger(oRowAsistencia[1]);	
							if(!horasUsuariosActividad.containsKey(idUsuario)){
								horasUsuariosActividad.put(idUsuario, Float.valueOf(0));
							}
							float horasTotalesUsuario = ((Float)horasUsuariosActividad.get(idUsuario)).floatValue();
							if(castObjectToString(oRowAsistencia[2]).equals("SIN")){								
								horasTotalesUsuario += castObjectToFloat(oRowAsistencia[3]).floatValue();								
							} else if(castObjectToString(oRowAsistencia[2]).equals("JUSTIFICADA")){
								horasTotalesUsuario += (castObjectToFloat(oRowAsistencia[3]).floatValue()/2);
							}
							horasUsuariosActividad.put(idUsuario, Float.valueOf(horasTotalesUsuario));
						}
						
						for(Map.Entry<Integer, Float> entry : horasUsuariosActividad.entrySet()) {							
							Float horasUsuarioPonderadas = (Float)entry.getValue();
							Float porcentajeAsistencia = (float) (100 * horasUsuarioPonderadas /  horasTotales);
							if(porcentajeAsistencia >= 80 ){
								++asistentes;
							}
						}
						
						oRow[18]=Integer.valueOf(asistentes);
						oRow[21]=(asistentes>=3)?1:0;
						wrkList.set(i, oRow);
					}
					//Filtro realizada
					if( (filtroRealizada == null) || 
						(filtroRealizada.booleanValue() && (asistentes >= 3)) || 
						(!filtroRealizada.booleanValue() && (asistentes < 3)))
						result.add(oRow);										

				}
				//result.addAll(wrkList);
			}
			
			//Se carga la información de actividad externas
			if(activityType.equals(EActivityTypes.AAEE) || activityType.equals(EActivityTypes.TODOS)) {
				strqry = buildHQLActividadExternas(fechaInicio, fechaFin, locale);
				filtro = addFiltroTematicas(tematicas) + 
						addFiltroCentro(centroId) +
						addFiltroIniciativaSingular(filtroIniciativaSingular) +
						addFiltroVideoconferencia(filtroVideoconferencia) +
						addFiltroServicio(servicioId);
				strqry = strqry.replace(":filtro_adicional", filtro);				

				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkList = q.getResultList();
				
				/* Se recalcula la asistencia */
				for (int i = 0; i < wrkList.size(); i++) {
					Object[] oRow =  wrkList.get(i);
					Integer asistentes = castObjectToInteger(oRow[21]);
					
					//Filtro realizada
					if( (filtroRealizada == null) || 
						(filtroRealizada.booleanValue() && (asistentes >= 3)) || 
						(!filtroRealizada.booleanValue() && (asistentes < 3)))
						result.add(oRow);	
				}
				//result.addAll(wrkList);
			}
		}
		
		/* Consultas de datos basados en participacion */
		if(reportDatosType.equals(EReportDatosTypes.ACTIVIDADUSUARIO)){
			
			//Se carga la información de cursos
			if(activityType.equals(EActivityTypes.CURSO) || activityType.equals(EActivityTypes.TODOS)) {
				//Se carga la información de cursos
				strqry = buildHQLParticipacionCursos(fechaInicio, fechaFin, locale);
				filtro = addFiltroUsuario(user) +
						addFiltroEdadUsuario(edadX, edadY) +
						addFiltroSexoUsuario(sexo) +
						addFiltroAdaptacionUsuario(adaptacion) +
						addFiltroTematicas(tematicas) +
						addFiltroCentro(centroId) +
						addFiltroIniciativaSingular(filtroIniciativaSingular) +
						addFiltroVideoconferencia(filtroVideoconferencia) +
						addFiltroServicio(servicioId);
				strqry = strqry.replace(":filtro_adicional", filtro);	
				
				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkList = q.getResultList();
				
				strqry = buildHQLAsistenciasCursos(fechaInicio, fechaFin);
				filtro = addFiltroTematicas(tematicas) + 
						addFiltroCentro(centroId) +
						addFiltroIniciativaSingular(filtroIniciativaSingular) +
						addFiltroVideoconferencia(filtroVideoconferencia) +
						addFiltroServicio(servicioId);
				strqry = strqry.replace(":filtro_adicional", filtro);
				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkAsistencia = q.getResultList();

				for(Object[] row : wrkAsistencia) {
					Integer idActividad = castObjectToInteger(row[0]);				
					Integer idUsuario = castObjectToInteger(row[1]);
					String keyActUsurio =  idActividad.toString() + "." + idUsuario.toString();
					if(!resultAsistencias.containsKey(keyActUsurio)){
						resultAsistencias.put(keyActUsurio, new ArrayList<Object[]>());
					}
					ArrayList rowsAsistenciaActividad = (ArrayList)resultAsistencias.get(keyActUsurio);
					rowsAsistenciaActividad.add(row);
					resultAsistencias.put(keyActUsurio, rowsAsistenciaActividad);					
				}

				/* Se recalcula la asistencia */
				for (int i = 0; i < wrkList.size(); i++) {
					Object[] oRow =  wrkList.get(i);
					Integer idActividad = castObjectToInteger(oRow[0]);				
					Integer idUsuario = castObjectToInteger(oRow[30]);
					String keyActUsurio =  idActividad.toString() + "." + idUsuario.toString();
					Float horasTotales = castObjectToFloat(oRow[13]);
					
					ArrayList<Object[]> rowsAsistenciaActividad = (ArrayList<Object[]>)resultAsistencias.get(keyActUsurio);
					boolean asistencia = false;		

					Float porcentajeAsistencia = Float.valueOf(0f);
					Float horasTotalesPonderadasUsuario = Float.valueOf(0f);
					Float horasTotalesAsistenciaUsuario = Float.valueOf(0f);
					Float horasTotalesJustificadasUsuario = Float.valueOf(0f);
					if(rowsAsistenciaActividad!=null){
						for(Object[] oRowAsistencia : rowsAsistenciaActividad){
							if(castObjectToString(oRowAsistencia[2]).equals("SIN")){								
								horasTotalesAsistenciaUsuario += castObjectToFloat(oRowAsistencia[3]).floatValue();
							} else if(castObjectToString(oRowAsistencia[2]).equals("JUSTIFICADA")){
								horasTotalesJustificadasUsuario += castObjectToFloat(oRowAsistencia[3]).floatValue();
							}							
						}	
						horasTotalesPonderadasUsuario = horasTotalesAsistenciaUsuario + (horasTotalesJustificadasUsuario / 2);
						porcentajeAsistencia = (float) (100 * horasTotalesPonderadasUsuario /  horasTotales);
						asistencia = (porcentajeAsistencia >= 80); 
						oRow[25]= porcentajeAsistencia;
						oRow[26]= horasTotalesPonderadasUsuario;
						oRow[27]= horasTotalesAsistenciaUsuario;
						oRow[28]= horasTotalesJustificadasUsuario;
						wrkList.set(i, oRow);
					}
					
					//Filtro realizada
					if( (filtroRealizada == null) || 
						(filtroRealizada.booleanValue() == asistencia) )
						result.add(oRow);										
				}
				//result.addAll(wrkList);
				
			}
			
			//Se carga la información de charlas
			if(activityType.equals(EActivityTypes.CHARLA) || activityType.equals(EActivityTypes.TODOS)) {
				strqry = buildHQLParticipacionCharlas(fechaInicio, fechaFin, locale);
				filtro = addFiltroUsuario(user) +
						addFiltroEdadUsuario(edadX, edadY) +
						addFiltroSexoUsuario(sexo) +
						addFiltroAdaptacionUsuario(adaptacion) +
						addFiltroTematicas(tematicas) +
						addFiltroCentro(centroId) +
						addFiltroIniciativaSingular(filtroIniciativaSingular) +
						addFiltroVideoconferencia(filtroVideoconferencia);
				strqry = strqry.replace(":filtro_adicional", filtro);	
				
				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkList = q.getResultList();
				
				strqry = buildHQLAsistenciasCharlas(fechaInicio, fechaFin);
				filtro = addFiltroTematicas(tematicas) +
						addFiltroCentro(centroId) +
						addFiltroIniciativaSingular(filtroIniciativaSingular) +
						addFiltroVideoconferencia(filtroVideoconferencia);				
				strqry = strqry.replace(":filtro_adicional", filtro);
				q = service.getEntityManager().createQuery(strqry);
				List<Object[]> wrkAsistencia = q.getResultList();
				
				for(Object[] row : wrkAsistencia) {
					Integer idActividad = castObjectToInteger(row[0]);				
					Integer idUsuario = castObjectToInteger(row[1]);
					String keyActUsurio =  idActividad.toString() + "." + idUsuario.toString();
					if(!resultAsistencias.containsKey(keyActUsurio)){
						resultAsistencias.put(keyActUsurio, new ArrayList<Object[]>());
					}
					ArrayList rowsAsistenciaActividad = (ArrayList)resultAsistencias.get(keyActUsurio);
					rowsAsistenciaActividad.add(row);
					resultAsistencias.put(keyActUsurio, rowsAsistenciaActividad);					
				}

				/* Se recalcula la asistencia */
				for (int i = 0; i < wrkList.size(); i++) {
					Object[] oRow =  wrkList.get(i);
					Integer idActividad = castObjectToInteger(oRow[0]);				
					Integer idUsuario = castObjectToInteger(oRow[30]);
					String keyActUsurio =  idActividad.toString() + "." + idUsuario.toString();
					Float horasTotales = castObjectToFloat(oRow[13]);
					
					ArrayList<Object[]> rowsAsistenciaActividad = (ArrayList<Object[]>)resultAsistencias.get(keyActUsurio);
					boolean asistencia = false;				
					Float porcentajeAsistencia = Float.valueOf(0f);
					Float horasTotalesPonderadasUsuario = Float.valueOf(0f);
					Float horasTotalesAsistenciaUsuario = Float.valueOf(0f);
					Float horasTotalesJustificadasUsuario = Float.valueOf(0f);
					if(rowsAsistenciaActividad!=null){
						for(Object[] oRowAsistencia : rowsAsistenciaActividad){
							if(castObjectToString(oRowAsistencia[2]).equals("SIN")){								
								horasTotalesAsistenciaUsuario += castObjectToFloat(oRowAsistencia[3]).floatValue();
							} else if(castObjectToString(oRowAsistencia[2]).equals("JUSTIFICADA")){
								horasTotalesJustificadasUsuario += castObjectToFloat(oRowAsistencia[3]).floatValue();
							}							
						}
						horasTotalesPonderadasUsuario = horasTotalesAsistenciaUsuario + (horasTotalesJustificadasUsuario / 2);
						porcentajeAsistencia = (float) (100 * horasTotalesPonderadasUsuario /  horasTotales);
						asistencia = (porcentajeAsistencia >= 80);
						oRow[25]= porcentajeAsistencia;
						oRow[26]= horasTotalesPonderadasUsuario;
						oRow[27]= horasTotalesAsistenciaUsuario;
						oRow[28]= horasTotalesJustificadasUsuario;
						wrkList.set(i, oRow);
					}
					
					//Filtro realizada
					if( (filtroRealizada == null) || 
						(filtroRealizada.booleanValue() == asistencia) )
						result.add(oRow);
				}
				//result.addAll(wrkList);
			}
			
		}

		/* Se realiza la ordenación por codigo de las diferentes consultas HQL realizadas */
		if(orden != null && !orden.isEmpty()) {
			int columnOrderIndex = 0;
			
			if(orden.equals("ID")) columnOrderIndex = 0;
			else if(orden.equals("TIPO")) columnOrderIndex = 1;
			else if(orden.equals("TEMR")) columnOrderIndex = 2;
			else if(orden.equals("TEMA")) columnOrderIndex = 3;
			else if(orden.equals("SERV")) columnOrderIndex = 4;
			else if(orden.equals("ALCU")) columnOrderIndex = 5;
			else if(orden.equals("CENT")) columnOrderIndex = 6;
			else if(orden.equals("PROV")) columnOrderIndex = 7;
			else if(orden.equals("PRZTOT")) columnOrderIndex = 8;
			else if(orden.equals("FI")) columnOrderIndex = 9;
			else if(orden.equals("FN")) columnOrderIndex = 10;
			else if(orden.equals("HI")) columnOrderIndex = 11;
			else if(orden.equals("HF")) columnOrderIndex = 12;
			else if(orden.equals("DRTOT")) columnOrderIndex = 13;
			else if(orden.equals("ISING")) columnOrderIndex = 14;
			else if(orden.equals("VIDEO")) columnOrderIndex = 15;
			//Detalle de actividades
			else if(orden.equals("NMAT")) columnOrderIndex = 16;
			else if(orden.equals("NINS")) columnOrderIndex = 17;
			else if(orden.equals("NAS")) columnOrderIndex = 18;
			else if(orden.equals("EST")) columnOrderIndex = 19;
			else if(orden.equals("DRPER")) columnOrderIndex = 20;
			//Detalle de participacion
			else if(orden.equals("USER")) columnOrderIndex = 16;
			else if(orden.equals("NOMB")) columnOrderIndex = 17;
			else if(orden.equals("APE1")) columnOrderIndex = 18;
			else if(orden.equals("APE2")) columnOrderIndex = 19;
			else if(orden.equals("SEX") || orden.equals("SEXO")) columnOrderIndex = 20; 
			else if(orden.equals("EDAD")) columnOrderIndex = 21;
			else if(orden.equals("ADAPT") || orden.equals("ADAP")) columnOrderIndex = 22;
			else if(orden.equals("FORM")) columnOrderIndex = 23;
			else if(orden.equals("OCUP")) columnOrderIndex = 24;
			else if(orden.equals("ASIS")) columnOrderIndex = 25; 
			else if(orden.equals("HTPO")) columnOrderIndex = 26;
			else if(orden.equals("HASI")) columnOrderIndex = 27; 
			else if(orden.equals("HJUS")) columnOrderIndex = 28; 
			else if(orden.equals("HORP")) columnOrderIndex = 29;
				
			Collections.sort(result, new ListingHelperArrayObjectComparator(columnOrderIndex)); 	
		}
		
		if(reportType.equals(EReportType.DATOS))		
			return generarXlsReportDatos(fields, activityType, reportDatosType, result, orden, locale, outputStream);
		else if(reportType.equals(EReportType.INDICADORES))
			return generarXlsReportIndicadores(fields, activityType, reportDatosType, result, orden, locale, outputStream);
			
		return null;
			
	}
	
	/**
	 * 
	 * @param method
	 * 
	 * @param parameters
	 * 
	 * @param locale
	 * @param outputStream
	 * 
	 * @return
	 */
	@Transactional(readOnly = true)
	public String runGenerateXlsMethod(String method, Map<Integer, Object> parameters, Locale locale, ByteArrayOutputStream outputStream) {
		try {
			if (method.contentEquals("streamMatriculadosCurso")) {
			    return streamMatriculadosCurso((String)parameters.get(0), locale, outputStream);
			}
			else if (method.contentEquals("streamMatriculadosTaller")) {
				return streamMatriculadosTaller((String)parameters.get(0), locale, outputStream);
			}
			else if (method.contentEquals("streamMatriculadosCharla")) {
				return streamMatriculadosCharla((String)parameters.get(0), locale, outputStream);
			}
			else if (method.contentEquals("streamEmpleados")) {
				return streamEmpleados((Long)parameters.get(0), locale, outputStream);			
			}
			else if (method.contentEquals("streamProveedores")) {
				return streamProveedores(locale, outputStream);			
			}
			else if (method.contentEquals("streamUsuarios")) {
				return streamUsuarios((Long)parameters.get(0), (Long)parameters.get(1), locale, outputStream);			
			}
			else if (method.contentEquals("streamUsuariosPre")) {
				return streamUsuariosPre((Long)parameters.get(0), locale, outputStream);
			}
			else if (method.contentEquals("streamCursosConPlaza")) {
				return streamCursosConPlaza((Long)parameters.get(0), locale, outputStream);
			}
			else if (method.contentEquals("streamCursos")) {
				return streamCursos((Long)parameters.get(0), (Long) parameters.get(1), (Long) parameters.get(2), (Long) parameters.get(3), (Long)parameters.get(4), (Long)parameters.get(5), locale, outputStream);
			}
			else if (method.contentEquals("streamCursosBrowser")) {
				return streamCursosBrowser((Long) parameters.get(0), (String)parameters.get(1), (Long) parameters.get(2), locale, outputStream);
			}
			else if (method.contentEquals("streamServiciosCursos")) {
				return streamServiciosCursos(locale, outputStream);
			}
			else if (method.contentEquals("streamServiciosTalleres")) {
				return streamServiciosTalleres(locale, outputStream);
			}
			else if (method.contentEquals("streamTalleresConPlaza")) {
				return streamTalleresConPlaza((Long)parameters.get(0), locale, outputStream);
			}
			else if (method.contentEquals("streamTalleres")) {
				return streamTalleres((Long)parameters.get(0), locale, outputStream);
			}
			else if (method.contentEquals("streamCursosPersonal")) {
				return streamCursosPersonal((String)parameters.get(0), (String)parameters.get(1), locale, outputStream);
			}
			else if (method.contentEquals("streamCursosProximosPersonal")) {
				return streamCursosProximosPersonal((String)parameters.get(0), (String)parameters.get(1), locale, outputStream);
			}
			else if (method.contentEquals("streamTalleresPersonal")) {
				return streamTalleresPersonal((String)parameters.get(0), (String)parameters.get(1), locale, outputStream);
			}
			else if (method.contentEquals("streamTalleresProximosPersonal")) {
				return streamTalleresProximosPersonal((String)parameters.get(0), (String)parameters.get(1), locale, outputStream);
			}
			else if (method.contentEquals("streamCharlasConPlaza")) {
				return streamCharlasConPlaza((Long)parameters.get(0), locale, outputStream);	
			}
			else if (method.contentEquals("streamCharlas")) {
				return streamCharlas((Long)parameters.get(0), (Long) parameters.get(1), (Long) parameters.get(2), (Long)parameters.get(3), (Long)parameters.get(4), (Long)parameters.get(5), locale, outputStream);
			}
			else if (method.contentEquals("streamCharlasBrowser")) {
				return streamCharlasBrowser((Long) parameters.get(0), (String)parameters.get(1), (Long) parameters.get(2), locale, outputStream);
			}
			else if (method.contentEquals("streamTodoInventario")) {
				return streamTodoInventario(locale, outputStream); 
			}
			else if (method.contentEquals("streamInventario")) {
				return streamInventario((Long)parameters.get(0), (Long)parameters.get(1), (EstadoRecurso)parameters.get(2), locale, outputStream); 
			}
			else if (method.contentEquals("streamTodoIncidencias")) {
				return streamTodoIncidencias(locale, outputStream); 
			}
			else if (method.contentEquals("streamFacturas")) {
				return streamFacturas((Long)parameters.get(0), (Long)parameters.get(1), (Long)parameters.get(2), (Long)parameters.get(3),
						(Long)parameters.get(4), (Long)parameters.get(5), (String)parameters.get(6), (String)parameters.get(7), locale, outputStream); 
			}
			else if (method.contentEquals("streamIncidencias")) {
				return streamIncidencias((Long)parameters.get(0), (Criticidad)parameters.get(1), (EstadoIncidencia)parameters.get(2), (Long)parameters.get(3), locale, outputStream); 
			}
			else if (method.contentEquals("streamAsesoramientos")) {
				return streamAsesoramientos((Long)parameters.get(0), locale, outputStream); 
			}
			else if (method.contentEquals("streamWifis")) {
				return streamWifis((Long)parameters.get(0), locale, outputStream); 
			}
			else if (method.contentEquals("streamPracticasTalleres")) {
				return streamPracticasTalleres((Long)parameters.get(0), (Long)parameters.get(1), (Long)parameters.get(2), locale, outputStream); 
			}
			else if (method.contentEquals("streamPracticasTalleresBrowser")) {
				return streamPracticasTalleresBrowser((Long) parameters.get(0), (String)parameters.get(1), locale, outputStream);
			}
			else if (method.contentEquals("streamExternasConPlaza")) {
				return streamExternasConPlaza((Long)parameters.get(0), (Long)parameters.get(1), locale, outputStream); 
			}
			else if (method.contentEquals("streamExternas")) {
				return streamExternas((Long)parameters.get(0), (Long)parameters.get(1), (Long)parameters.get(2), (Long)parameters.get(3), (Long)parameters.get(4), (Long)parameters.get(5), (Long)parameters.get(6), locale, outputStream); 
			}
			else if (method.contentEquals("streamExternasBrowser")) {
				return streamExternasBrowser((Long) parameters.get(0), (String)parameters.get(1), locale, outputStream); 
			}
			else if(method.contentEquals("streamGeneradorInformes")) {
				return streamGeneradorInformes((EReportType)parameters.get(0),(String)parameters.get(1), (Long)parameters.get(2),
										 (String)parameters.get(3), (Long)parameters.get(4), 
										 (EActivityTypes)parameters.get(5), (Long)parameters.get(6), 
										 (Long)parameters.get(7), (Boolean)parameters.get(8), 
										 (Boolean)parameters.get(9),  (Boolean)parameters.get(10), 
										 (String)parameters.get(11),  (Integer)parameters.get(12), (Integer)parameters.get(13), 
										 (String)parameters.get(14), (String)parameters.get(15),
										 (EReportDatosTypes)parameters.get(16), (String)parameters.get(17),
										 locale, outputStream);
			}
		}
		catch (Exception ex) {
			ex.printStackTrace();

			return null;
		}
		
		return null;
	}
}
